#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"


static char builtin_code[]=
"\n"
"define_widget \n"
"{\n"
"   name button\n"
"   foxclass FXButton\n"
"   property text str\n"
"   property bgcolor color\n"
"   property font font\n"
"   property toolbar_style flag\n"
"   property icon icon\n"
"   signal click \n"
"   common_properties { layout padding objid iconpos frame justification }\n"
"\n"
"   widget_code\n"
"   {\n"
"@form_constructor\n"
"\n"
"  FXButton *$G_obj;\n"
"\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXButton($container,\n"
"      $dev($text)(\042\042),\n"
"      $dev($icon)(NULL),\n"
"      $def($click)(this) $nef($click)(NULL),\n"
"      $def($click)($G_selector) $nef($click)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
" \n"
"        $dev($frame)(FRAME_RAISED|FRAME_THICK) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"\n"
"    0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
"\n"
"  $def($bgcolor)( $G_obj->setBackColor($bgcolor); )\n"
"\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"\n"
"  $def($click)(long $G_click(FXObject *object,FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
" $def($click)\n"
" (\n"
"   FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
" )\n"
"\n"
"@form_methods\n"
"  $def($click)\n"
"  (\n"
"    long $form_class::$G_click\n"
"      (FXObject *object,FXSelector sel, void *arg)\n"
"         { $click return 1; }\n"
"  )\n"
"\n"
"@form_selector_ids        $def($click)($G_selector,)\n"
"\n"
"   }\n"
"\n"
"   command set_text { const char *text }\n"
"   {\n"
"      widget->setText(text);\n"
"   }\n"
"}\n"
"\n"
"\n"
"define_widget \n"
"{\n"
"  name check_box\n"
"  foxclass FXCheckButton\n"
"  property text str\n"
"  property plus_style flag\n"
"  property font font\n"
"  common_properties { objid layout iconpos frame padding justification }\n"
"  signal click \n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXCheckButton *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXCheckButton(\n"
"             $container, $dev($text)(\042\042),\n"
"             $def($click)(this)        $nef($click)(NULL),\n"
"             $def($click)($G_selector) $nef($click)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(FRAME_NONE) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_LEFT) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"   0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"  $def($click)(long $G_click(FXObject *object,FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click)(\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),)\n"
"\n"
"@form_methods\n"
"  $def($click)(\n"
"       long $form_class::$G_click\n"
"            (FXObject *object,FXSelector sel, void *arg)\n"
"       { $click return 1; }\n"
"  )\n"
"\n"
"@form_selector_ids\n"
"  $def($click)($G_selector,)\n"
"\n"
"  }\n"
"\n"
"  command get_value { int *R }\n"
"  {\n"
"    // I know, I`m checking against TRUE but this is necessary\n"
"    // since the library has also a MAYBE value. peh.\n"
"    if (widget->getCheck()==TRUE)\n"
"       *R= 1;\n"
"    else *R= 0;\n"
"  }\n"
"\n"
"  command set_value { int V }\n"
"  {\n"
"     if (V) widget->setCheck(TRUE); \n"
"       else widget->setCheck(FALSE);\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"   name hbox\n"
"   is_container\n"
"   common_properties { layout spacing padding packer frame }\n"
"   widget_code\n"
"   {\n"
"@form_constructor\n"
"  FXHorizontalFrame *$G_obj= new\n"
"    FXHorizontalFrame( $container,\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(0) |\n"
"        $dev($uniform_height)(0) | \n"
"        $dev($uniform_width)(0) ,\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        , $dev($hz_spacing)(DEFAULT_SPACING),\n"
"        $dev($vt_spacing)(DEFAULT_SPACING));\n"
"   }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"   name vbox\n"
"   is_container\n"
"   common_properties { layout spacing padding packer frame }\n"
"   widget_code\n"
"   {\n"
"@form_constructor\n"
"  FXVerticalFrame *$G_obj= new\n"
"    FXVerticalFrame( $container,\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(0) |\n"
"        $dev($uniform_height)(0) | \n"
"        $dev($uniform_width)(0) ,\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        , $dev($hz_spacing)(DEFAULT_SPACING),\n"
"        $dev($vt_spacing)(DEFAULT_SPACING));\n"
"   }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name label\n"
"  foxclass FXLabel\n"
"  property text str\n"
"  property icon icon\n"
"  common_properties { objid layout iconpos frame justification padding }\n"
"  property font font\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"\n"
"  FXLabel *$G_obj;\n"
"\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXLabel($container, $dev($text)(\042\042), $dev($icon)(NULL),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(0) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"        0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"  }\n"
"  command set_text { const char *text }\n"
"  {\n"
"    widget->setText(text);\n"
"  }\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name text_field\n"
"  foxclass FXTextField\n"
"  common_properties { layout objid justification frame }\n"
"  property ncols int\n"
"  enum mode { password_mode {TEXTFIELD_PASSWD}\n"
"              integer_mode  {TEXTFIELD_INTEGER}\n"
"              real_mode     {TEXTFIELD_REAL} }\n"
"  property limit_length flag\n"
"  property notify_enter_only flag\n"
"  signal change \n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXTextField *$G_obj;\n"
"  $def($objid)($objid =) $G_obj= \n"
"    new FXTextField($container,\n"
"      $dev($ncols)(40), $def($change)(this) $nef($change)(NULL),\n"
"                        $def($change)($G_selector) $nef($change)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"    $dev($frame)(FRAME_SUNKEN|FRAME_THICK) |\n"
"    $dev($justify_x)(JUSTIFY_LEFT) | JUSTIFY_CENTER_Y |\n"
"    $def($notify_enter_only)(TEXTFIELD_ENTER_ONLY|)\n"
"    $def($limit_length)(TEXTFIELD_LIMITED|)\n"
"    $dev($mode)(0),\n"
"    0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"@form_members\n"
"\n"
"$def($change)(long $G_change (FXObject *object,FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
" $def($change)\n"
" (\n"
"   FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_change),\n"
" )\n"
"\n"
"@form_methods\n"
"\n"
"  $def($change)\n"
"  (\n"
"    long $form_class::$G_change\n"
"      (FXObject *object,FXSelector sel, void *arg)\n"
"         {\n"
"           const char *text= (const char*) arg;\n"
"           $change return 1;\n"
"         }\n"
"  )\n"
"\n"
"@form_selector_ids        $def($change)($G_selector,)\n"
"  }\n"
"  \n"
"  command set_text { const char *text }\n"
"  {\n"
"     widget->setText(text);\n"
"  }\n"
"  command get_text { char **result }\n"
"  {\n"
"    FXString S= widget->getText();\n"
"    *result= strdup(S.text());\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name separator\n"
"  common_properties { layout padding }\n"
"  enum direction { vertical {V} horizontal {H} }\n"
"  enum style { groove {SEPARATOR_GROOVE}\n"
"               ridge  {SEPARATOR_RIDGE}\n"
"               line   {SEPARATOR_LINE} }\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"    new $eq($direction=V)(FXVerticalSeparator)\n"
"        $eq($direction=H)(FXHorizontalSeparator) ($container,\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($style)(SEPARATOR_GROOVE),\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(0),\n"
"  $dev($pad_right)(0),\n"
"  $dev($pad_top)(0),\n"
"  $dev($pad_bottom)(0)\n"
"\n"
"        );\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"   name radio_group\n"
"   common_properties { objid }\n"
"   foxclass FYRadioGroup\n"
"   widget_code\n"
"   {\n"
"@form_constructor\n"
"  FYRadioGroup *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) (FYRadioGroup*) malloc(sizeof(* $G_obj));\n"
"  $G_obj->target= & $objid$def(1)(_store);\n"
"  $G_obj->head= NULL;\n"
"\n"
"@form_members\n"
"  int $objid$def(1)(_store);\n"
" // FIXME: I should find some prefix and not use the suffix _store..\n"
"   }\n"
"\n"
"   library_code\n"
"   {\n"
"@library_code\n"
"\n"
" typedef struct radio_item {\n"
"   struct radio_item *next;\n"
"   FXRadioButton *button;\n"
"   int value;\n"
" } radio_item_t;\n"
"\n"
" typedef struct {\n"
"   int *target;\n"
"   radio_item_t *head;\n"
" } FYRadioGroup;\n"
"\n"
"static void radio_set_value (FYRadioGroup *G, int V)\n"
"{\n"
"  radio_item_t *T;\n"
"  for(T=G->head;T;T=T->next)\n"
"    if (T->value==V) \n"
"     T->button->setCheck(TRUE);\n"
"    else T->button->setCheck(FALSE);\n"
"  G->target[0]= V;\n"
"}\n"
"\n"
"static void radio_get_value (FYRadioGroup *G,int *R)\n"
"{\n"
"  *R= G->target[0];\n"
"}\n"
"\n"
"static void radio_append(FYRadioGroup *G, FXRadioButton *B, int V)\n"
"{\n"
"  radio_item_t *T= (radio_item_t*) malloc(sizeof(*T));\n"
"  T->button= B;\n"
"  T->value= V;\n"
"  T->next= G->head;\n"
"  G->head= T;\n"
"}\n"
"  }\n"
"\n"
"  command set_value {int V}  { radio_set_value(widget, V); }\n"
"  command get_value {int *R} { radio_get_value(widget, R); }\n"
"\n"
"}\n"
"\n"
"define_widget\n"
"{\n"
"  name radio_button\n"
"  foxclass FXRadioButton\n"
"  property default flag\n"
"  property text str\n"
"  property group ident\n"
"  property value int\n"
"  signal click\n"
"  common_properties { layout iconpos frame justification padding }\n"
"  property font font\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"\n"
"  FXRadioButton * $G_obj;\n"
"  $G_obj= new FXRadioButton($container, $dev($text)(\042\042), this, $G_selector, \n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(FRAME_NONE) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
"    radio_append( $group, $G_obj, $value );\n"
"    $def($default)( $G_obj->setCheck(TRUE); $group$def(1)(_store)= $value; )\n"
"    $nef($default)( $G_obj->setCheck(FALSE); )\n"
"\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_signal_mappings\n"
"  FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
" \n"
"\n"
"@form_methods\n"
"\n"
"long $form_class::$G_click\n"
"  (FXObject *object,FXSelector sel, void *arg)\n"
"{\n"
"  radio_set_value( $group, $value );\n"
"  $dev($click)(/* NOP */)\n"
"  // FIXME: put the on_click stuff here\n"
"  return 1;\n"
"}\n"
"\n"
"@form_members      long $G_click(FXObject *object,FXSelector sel, void *arg);\n"
"@form_selector_ids $G_selector,\n"
"\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name toggle_button\n"
"  foxclass FXToggleButton\n"
"\n"
"  common_properties { objid layout iconpos frame justification padding }\n"
"  property font font\n"
"  property bgcolor color\n"
"  signal click\n"
"  property text_off str\n"
"  property text_on str\n"
"  property icon_on icon\n"
"  property icon_off icon\n"
"  property toolbar_style flag\n"
"\n"
"  widget_code\n"
"  {\n"
"\n"
"@form_constructor\n"
"\n"
"  FXToggleButton *$G_obj;\n"
"\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXToggleButton($container,\n"
"      $dev($text_off)(\042\042), $dev($text_on)(\042\042), \n"
"      $dev($icon_off)(NULL), $dev($icon_on)(NULL),\n"
"      $def($click)(this) $nef($click)(NULL),\n"
"      $def($click)($G_selector) $nef($click)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(FRAME_RAISED|FRAME_THICK) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) \n"
"\n"
"        $def($toolbar_style)(| TOGGLEBUTTON_TOOLBAR)\n"
"        ,\n"
"        0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"  $def($bgcolor)( $G_obj->setBackColor($bgcolor); )\n"
"\n"
"\n"
"@form_members\n"
"  $def($click)(long $G_click(FXObject *object,FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click)\n"
"  (\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
"  )\n"
"@form_methods\n"
"  $def($click)\n"
"  (\n"
"     long $form_class::$G_click\n"
"          (FXObject *object,FXSelector sel, void *arg)\n"
"          { $click return 1; }\n"
"  )\n"
"@form_selector_ids $def($click)($G_selector,)\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name group_box\n"
"  foxclass FXGroupBox\n"
"  common_properties { layout spacing padding justification }\n"
"  property title str\n"
"  is_container\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXGroupBox *$G_obj;\n"
"  $G_obj= new FXGroupBox($container, $dev($title)(\042\042), \n"
"        GROUPBOX_TITLE_LEFT |  // FIXME: this shall be configurable\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(FRAME_LINE) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"     0,0,0,0, // xywh\n"
"        $dev($pad_left)(DEFAULT_SPACING),\n"
"        $dev($pad_right)(DEFAULT_SPACING),\n"
"        $dev($pad_top)(DEFAULT_SPACING),\n"
"        $dev($pad_bottom)(DEFAULT_SPACING),\n"
"        $dev($hz_spacing)(DEFAULT_SPACING),\n"
"        $dev($vt_spacing)(DEFAULT_SPACING));\n"
"   }\n"
"}\n"
"\n"
"define_widget\n"
"{\n"
"  name spinner\n"
"  foxclass FXSpinner\n"
"  common_properties { objid layout frame padding }\n"
"  property max int\n"
"  property min int\n"
"  property increment int\n"
"  property ncols int\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXSpinner *$G_obj;\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXSpinner($container, $dev($ncols)(3),\n"
"       // target and selector\n"
"       NULL, 0,\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"       // there are some options, but I dont know how to use those yet.\n"
"        $dev($frame)(0) | SPIN_NORMAL,\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
"    $def($max $min)(\n"
"      $G_obj->setRange($dev($min)(INT_MIN), $dev($max)(INT_MAX));\n"
"    )\n"
"    $def($increment)(\n"
"      $G_obj->setIncrement($increment);\n"
"    )\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"  }\n"
"  command set_value { int V } { widget->setValue(V); }\n"
"  command get_value { int *R } { *R= widget->getValue(); }\n"
"}\n"
"\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name float_spinner\n"
"  foxclass FXRealSpinner\n"
"  common_properties { objid layout frame padding }\n"
"  property max float\n"
"  property min float\n"
"  property increment float\n"
"  property ncols int\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"\n"
"  FXRealSpinner *$G_obj;\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXRealSpinner($container, $dev($ncols)(3),\n"
"       // target and selector\n"
"       NULL, 0,\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(0) |\n"
"        $nef($max)(REALSPIN_NOMAX |)\n"
"        $nef($min)(REALSPIN_NOMIN |)\n"
"       // there are some options, but I dont know how to use those yet.\n"
"        SPIN_NORMAL,\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
"    $def($max $min)( $G_obj->setRange($dev($min)(0.0), $dev($max)(1.0));)\n"
"    $def($increment)( $G_obj->setIncrement($increment); )\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"  }\n"
"\n"
"  command set_value { double V } { widget->setValue(V); }\n"
"  command get_value { double *ret } { *ret= widget->getValue(); }\n"
"}\n"
"\n"
"define_widget\n"
"{\n"
"  name file_list\n"
"  foxclass FXFileList\n"
"  property show_hidden flag\n"
"  property no_parent flag\n"
"  common_properties { objid layout frame }\n"
"  signal click_file\n"
"  signal click_dir\n"
"  signal dclick_file\n"
"  signal dclick_dir\n"
"  property font font\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"\n"
"  FXFileList *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXFileList($container,\n"
"           $def($click_file $dclick_file $dclick_dir $click_dir)(this)\n"
"           $nef($click_file $dclick_file $dclick_dir $click_dir)(NULL),\n"
"           $def($click_file $dclick_file $dclick_dir $click_dir)($G_selector)\n"
"           $nef($click_file $dclick_file $dclick_dir $click_dir)(0),\n"
"             FILELIST_NO_OWN_ASSOC |\n"
"           $def($show_hidden)(FILELIST_SHOWHIDDEN |)\n"
"           $def($no_parent)(FILELIST_NO_PARENT |)\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"           $dev($frame)(FRAME_RAISED|FRAME_THICK) \n"
"           ,0,0,0,0);  // xywh\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"   $def($click_file $click_dir)\n"
"     (long $G_click(FXObject *object,FXSelector sel,void *arg);)\n"
"   $def($dclick_file $dclick_dir)\n"
"     (long $G_dclick(FXObject *object,FXSelector sel,void *arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click_file $click_dir)(\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click), )\n"
"  $def($dclick_file $dclick_dir)(\n"
"    FXMAPFUNC(SEL_DOUBLECLICKED, $form_class::$G_selector, $form_class::$G_dclick), )\n"
"\n"
"@form_methods\n"
"\n"
"  $def($click_file $click_dir)(\n"
"long $form_class::$G_click\n"
"     (FXObject *object, FXSelector sel, void *arg)\n"
"{\n"
"   FXFileList *$G_Ylist= (FXFileList*) object;\n"
"   int $G_clicked_item= (intptr_t) arg;\n"
"   FXString $G_path= $G_Ylist->getItemPathname($G_clicked_item);\n"
"   const char *clicked_path=$G_path.text(); \n"
"   FXString $G_fname= $G_Ylist->getItemFilename($G_clicked_item);\n"
"   const char *clicked_name= $G_fname.text();\n"
"   if ($G_Ylist->isItemFile($G_clicked_item))\n"
"   {\n"
"      $click_file\n"
"      return 1;\n"
"   }\n"
"   if ($G_Ylist->isItemDirectory($G_clicked_item))\n"
"   {\n"
"      $click_dir\n"
"      return 1;\n"
"   }\n"
"   return 1;\n"
"}\n"
"  )\n"
"\n"
"\n"
"  $def($dclick_file $dclick_dir)(\n"
"long $form_class::$G_dclick\n"
"     (FXObject *object, FXSelector sel, void *arg)\n"
"{\n"
"   FXFileList *$G_Ylist= (FXFileList*) object;\n"
"   int $G_clicked_item= (intptr_t) arg;\n"
"   FXString $G_path= $G_Ylist->getItemPathname($G_clicked_item);\n"
"   const char *clicked_path=$G_path.text(); \n"
"   FXString $G_fname= $G_Ylist->getItemFilename($G_clicked_item);\n"
"   const char *clicked_name= $G_fname.text();\n"
"   if ($G_Ylist->isItemFile($G_clicked_item))\n"
"   {\n"
"      $dclick_file\n"
"      return 1;\n"
"   }\n"
"   if ($G_Ylist->isItemDirectory($G_clicked_item))\n"
"   {\n"
"      $dclick_dir\n"
"      return 1;\n"
"   }\n"
"   return 1;\n"
"}\n"
"  )\n"
"\n"
"@form_selector_ids \n"
"    $def($click_file $click_dir $dclick_file $dclick_dir)($G_selector,)\n"
"  }\n"
"\n"
"  command get_current { int *Rresult, const char **Rname, int *Rtype }\n"
"  {\n"
"    FXString cur;\n"
"    int item;\n"
"\n"
"    item= widget->getCurrentItem();\n"
"    if (item<0) { *Rresult= 0; return ; }\n"
"    cur= widget->getCurrentFile();\n"
"    if (Rname) *Rname= strdup(cur.text());\n"
"    if (Rtype) *Rtype= item_type(widget,item);\n"
"    *Rresult= 1;\n"
"  }\n"
"  command set_current_file { const char *fn }\n"
"  {\n"
"    widget->setCurrentFile(fn);\n"
"  }\n"
"\n"
"  command set_directory { const char *fn } { widget->setDirectory(fn); }\n"
"  command get_directory { char **fn }\n"
"  {\n"
"    FXString cur;\n"
"    cur= widget->getDirectory();\n"
"    if (fn) *fn= strdup(cur.text());\n"
"  }\n"
"\n"
"  library_code\n"
"  {\n"
"@library_code\n"
"static int item_type(FXFileList *L, int item)\n"
"{\n"
"  if (L->isItemDirectory(item)) return \047D\047;\n"
"  return \047F\047;\n"
"}\n"
"  }\n"
"\n"
"}\n"
"\n"
"\n"
"define_widget \n"
"{\n"
"  name dir_list\n"
"  foxclass FXDirList\n"
"  property show_hidden flag\n"
"  property show_files flag\n"
"  common_properties { objid layout frame }\n"
"  property font font\n"
"  signal click\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXDirList *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXDirList($container,\n"
"           $def($click)(this) $nef($click)(NULL),\n"
"           $def($click)($G_selector) $nef($click)(0),\n"
"             TREELIST_SHOWS_LINES|TREELIST_SHOWS_BOXES|TREELIST_BROWSESELECT|\n"
"             DIRLIST_NO_OWN_ASSOC |\n"
"             $def($show_files)(DIRLIST_SHOWFILES|) \n"
"             $def($show_hidden)(DIRLIST_SHOWHIDDEN|) \n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"             $dev($frame)(FRAME_RAISED|FRAME_THICK) \n"
"           ,0,0,0,0);  // xywh\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"   $def($click)(long $G_click(FXObject *object, FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click)\n"
"  (\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
"  )\n"
"@form_methods\n"
"  $def($click)\n"
"  (\n"
"long $form_class::$G_click\n"
"     (FXObject *object, FXSelector sel, void *arg)\n"
"{\n"
"   $click\n"
"   return 1;\n"
"}\n"
"  )\n"
"\n"
"@form_selector_ids $def($click)($G_selector,)\n"
"  }\n"
"\n"
"  command set_current_file {const char *fn}\n"
"    { widget->setCurrentFile(fn); }\n"
"\n"
"  command set_current_dir {const char *fn}\n"
"    { widget->setDirectory(fn); }\n"
"\n"
"  command get_current {int *result, const char **name, int *type}\n"
"  {\n"
"    FXDirItem *item= (FXDirItem*) (widget->getCurrentItem());\n"
"    *result= 0;\n"
"    if (!item) return ;\n"
"    if (name) *name= strdup(widget->getItemPathname(item).text());\n"
"    if (type) *type= item_type(item);\n"
"    *result= 1;\n"
"  }\n"
"\n"
"  library_code\n"
"  {\n"
"@library_code\n"
"static int item_type(FXDirItem *item)\n"
"{\n"
"  if (item->isDirectory()) return \047D\047;\n"
"  if (item->isSymlink())   return \047L\047;\n"
"  if (item->isChardev())   return \047C\047;\n"
"  if (item->isBlockdev())  return \047B\047;\n"
"  if (item->isFifo())      return \047P\047;\n"
"  if (item->isSocket())    return \047S\047;\n"
"  return \047F\047;\n"
"}\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name message_console\n"
"  foxclass FXText\n"
"  property text str\n"
"  common_properties { objid layout frame justification padding }\n"
"  property font font\n"
"  enum wrap { word_wrap {TEXT_WORDWRAP} no_wrap {0}\n"
"              fixed_wrap {TEXT_FIXEDWRAP} }\n"
"  property no_vertical_scroller flag\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXText *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXText(\n"
"       $container, NULL,0, // target & selector\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($wrap)(TEXT_FIXEDWRAP) |\n"
"        $nef($no_vertical_scroller)(VSCROLLER_ALWAYS) |\n"
"        TEXT_READONLY | TEXT_AUTOSCROLL |\n"
"        $dev($frame)(0),\n"
"      0,0,0,0,  // x,y,w,h\n"
"           // FIXME: these are given as number constants in the\n"
"           // FXText constructor. Nothing symbolic like DEFAULT_PAD\n"
"           // etc. is used. So, I will do the same unwillingly.\n"
"     $dev($pad_left)(3),\n"
"     $dev($pad_right)(3),\n"
"     $dev($pad_top)(2),\n"
"     $dev($pad_bottom)(2));\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"  }\n"
"\n"
"  command print {const char *fmt, ...}\n"
"  {\n"
"   int size=200; char *message; int len; char *atmp;\n"
"   va_list ap;\n"
"   message= (char*) malloc(size);\n"
"   while(1) {\n"
"     va_start(ap,fmt);\n"
"     len= vsnprintf(message,size, fmt, ap);\n"
"     va_end(ap);\n"
"     if (len<0) size*= 2;\n"
"     else if (len<size) break;\n"
"     else size= len+2;\n"
"     message= (char*) realloc(atmp= message, size);\n"
"     if (!message) {\n"
"        free(atmp);\n"
"        message= (char*) fmt;\n"
"        break;\n"
"     }\n"
"    } \n"
"    widget->appendText(message, strlen(message));\n"
"    if (message!=fmt) free(message);\n"
"     // argh, AUTOSCROLL doesn`t work yet. see\n"
"     // http://ruby.11.n6.nabble.com/TEXT-AUTOSCROLL-in-FXText-with-usage-of-FXDataTarget-td3510118.html\n"
"    widget->makePositionVisible(widget->getLength()-1);\n"
"  }\n"
"\n"
"  command append {const char *str, size_t len}\n"
"  {\n"
"    //If somebody does their own formatting, they will want to print bytes\n"
"    //directly. So, this one does that.\n"
"    widget->appendText(str, len);\n"
"     // argh, AUTOSCROLL doesn`t work yet. see\n"
"     // http://ruby.11.n6.nabble.com/TEXT-AUTOSCROLL-in-FXText-with-usage-of-FXDataTarget-td3510118.html\n"
"    widget->makePositionVisible(widget->getLength()-1);\n"
"  }\n"
"\n"
"  command clear { }\n"
"  {\n"
"    widget->removeText(0, widget->getLength()); \n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name text_viewer\n"
"  foxclass FXText\n"
"  property text str\n"
"  common_properties { objid layout frame justification padding }\n"
"  property font font\n"
"  enum wrap { fixed_wrap {TEXT_FIXEDWRAP} \n"
"              no_wrap {0}\n"
"              word_wrap {TEXT_WORDWRAP} }\n"
"  property no_vertical_scroller flag\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXText *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXText(\n"
"       $container, NULL,0, // target & selector\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($wrap)(TEXT_WORDWRAP) |\n"
"        $nef($no_vertical_scroller)(VSCROLLER_ALWAYS |) \n"
"        TEXT_READONLY | \n"
"        $dev($frame)(0),\n"
"     0,0,0,0,  // x,y,w,h\n"
"             // FIXME: these are given as number constants in the\n"
"             // FXText constructor. Nothing symbolic like DEFAULT_PAD\n"
"             // etc. is used. So, I will do the same unwillingly.\n"
"     $dev($pad_left)(3),\n"
"     $dev($pad_right)(3),\n"
"     $dev($pad_top)(2),\n"
"     $dev($pad_bottom)(2));\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"  }\n"
"\n"
"  command set_text {const char *V} { widget->setText(V); }\n"
"  command clear { } { widget->removeText(0, widget->getLength());  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name int_list\n"
"  foxclass FXList\n"
"  common_properties { layout objid }\n"
"  property font font\n"
"\n"
"  signal click\n"
"  signal dclick\n"
"  \n"
"  library_code\n"
"  {\n"
"@library_code\n"
"\n"
"class FYListItem_i : public FXListItem \n"
"{\n"
"  FXDECLARE(FYListItem_i)\n"
"protected:\n"
"  FYListItem_i() : FXListItem() { }\n"
"public:\n"
"  FYListItem_i(const FXString& text,FXIcon* ic, int idata)\n"
"   : FXListItem(text,ic,NULL)\n"
"  { data_i= idata; }\n"
"  ~FYListItem_i() { }\n"
"  int data_i;\n"
"};\n"
"FXIMPLEMENT(FYListItem_i,FXListItem,NULL,0)\n"
"\n"
"static FYListItem_i* intlist_get_selected(FXList *L)\n"
"{\n"
"   int i, N= L->getNumItems();\n"
"   for(i=0;i<N;i++)\n"
"     if (L->isItemSelected(i))\n"
"       return (FYListItem_i*) L->getItem(i);\n"
"   return NULL;\n"
"}\n"
"static int intlist_find_item(FXList *L, int key)\n"
"{\n"
"  int i;\n"
"  int N= L->getNumItems();\n"
"  for(i=0;i<N;i++)\n"
"    {\n"
"        FYListItem *it= (FYListItem*) L->getItem(i);\n"
"        if (it->data_i==key) return i;\n"
"    }\n"
"  return -1;\n"
"}\n"
"  }\n"
"\n"
"  command clear_selection { }\n"
"  {\n"
"    int i,N;\n"
"    N= widget->getNumItems();\n"
"    for(i=0;i<N;i++) widget->deselectItem(i);\n"
"  }\n"
"\n"
"  command get_selected {int *R, int *key}\n"
"  {\n"
"    FYListItem_i *item= intlist_get_selected(widget);\n"
"    if (item) { *key= item->data_i; *R= 1; }\n"
"    else        *R= 0;\n"
"  }\n"
"  \n"
"  command select_item { int key, int sel }\n"
"  {\n"
"     int i= intlist_find_item(widget, key); \n"
"     if (i==-1) return ;\n"
"     if (sel) widget->selectItem(i);\n"
"         else widget->deselectItem(i); \n"
"  }\n"
"\n"
"  command append { const char *text, int key }\n"
"    { widget->appendItem(new FYListItem_i(text, NULL,key)); }\n"
"\n"
"  command prepend { const char *text, int key }\n"
"    { widget->prependItem(new FYListItem_i(text, NULL,key)); }\n"
"\n"
"  command insert { int poskey, const char *text, int key }\n"
"  {\n"
"    int i= intlist_find_item(widget, poskey);\n"
"    if (i!=-1)\n"
"      widget->insertItem(i, new FYListItem_i(text, NULL, key));\n"
"    else\n"
"      widget->appendItem(new FYListItem_i(text, NULL, key));\n"
"  }\n"
"\n"
"  command remove { int key }\n"
"  {\n"
"    int i= intlist_find_item(widget, key);\n"
"    if (i==-1) return ;\n"
"    widget->removeItem(i);\n"
"  }\n"
"\n"
"  command clear { } { widget->clearItems(); }\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"   FXList *$G_obj; \n"
"\n"
"   $G_obj= $def($objid)($objid =) new FXList($container,\n"
"        $def($click $dclick)(this) $nef($dclick $click)(NULL),\n"
"        $def($click $dclick)($G_selector) $nef($dclick $click)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"           0 ,0,0,0,0); // xywh\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"  $def($click)(long $G_click(FXObject *object,FXSelector sel,void* arg);)\n"
"  $def($dclick)(long $G_dclick(FXObject *object,FXSelector sel,void* arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click)\n"
"  (\n"
"     FXMAPFUNC(SEL_CLICKED,$form_class::$G_selector,$form_class::$G_click),\n"
"  )\n"
"  $def($dclick)\n"
"  (\n"
"     FXMAPFUNC(SEL_DOUBLECLICKED,$form_class::$G_selector,\n"
"               $form_class::$G_dclick),\n"
"  )\n"
"\n"
"@form_selector_ids\n"
"  $def($click $dclick)($G_selector,)\n"
"\n"
"@form_methods\n"
"  $def($click)\n"
"  (\n"
"long $form_class::$G_click(FXObject *object,FXSelector sel, void *arg)\n"
"    {\n"
"      FXList *$G_list= (FXList*)(object);\n"
"      int clicked_item= (intptr_t) (arg);\n"
"      FYListItem_i *item= (FYListItem_i*) ($G_list->getItem(clicked_item));\n"
"      int clicked_key = item->data_i;\n"
"      $click\n"
"      return 1;\n"
"    }\n"
"  )\n"
"  $def($dclick)\n"
"  (\n"
"long $form_class::$G_dclick(FXObject *object,FXSelector sel, void *arg)\n"
"    {\n"
"      FXList *$G_list= (FXList*)(object);\n"
"      int clicked_item= (intptr_t) (arg);\n"
"      FYListItem_i *item= (FYListItem_i*) ($G_list->getItem(clicked_item));\n"
"      int clicked_key = item->data_i;\n"
"      $dclick\n"
"      return 1;\n"
"    }\n"
"  )\n"
"  }\n"
"}\n"
"\n"

;


void parse_builtin_widgets()
{
  parser_t* P;
  extern int no_lines;
  int nn;
  nn= no_lines;
  no_lines= 1;
  P= malloc(sizeof(*P));
  P->fn= strdup("[builtin]");
  P->ipt= P->ore= builtin_code;
  
  while(1) {
   char *kw;
   kw= parse_ident_or_eof(P);
   if (!kw) break;
   if (!strcmp(kw,"define_widget")) { define_widget(P); continue; }
   p_error(P, NULL, "unknown keyword in builtin definitions: %s\n", kw);
  }

  free(P->fn);
  free(P);
  no_lines= nn;
}


