#line 427 "/home/dodo/SFP/fxform-1.3/src/parse.u"
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>

#include "template.h"
#include "parse.h"

#line 392 "/home/dodo/SFP/fxform-1.3/src/parse.u"

typedef struct { char *name; tpl_t* (*func)(parser_t*); } widget_parser_t;

tpl_t  *parse_user_widget(parser_t *P, char *name);

#line 48 "/home/dodo/SFP/fxform-1.3/src/file.u"

typedef struct buffer {
  struct buffer *next;
  int len;
  char data[504];
} buffer_t;

#line 384 "/home/dodo/SFP/fxform-1.3/src/parse.u"

  tpl_t *p_list(parser_t*);
  tpl_t *p_tab_book(parser_t*);

#line 31 "parse.c"
static char *parser_collect(char *s,parser_t *P);
static int isspc(int a);
static int isident(int a);
static void skip_quote(parser_t *P);
static void skip_comment(parser_t *P);
static void skip_directive(parser_t *P);
static int count_lines(parser_t *P, char *lref);
static file_t *newfile(char* name);
static void do_read(FILE *D, file_t *F);
#line 23 "/home/dodo/SFP/fxform-1.3/src/parse.u"

void p_error(parser_t *P, char *lref, char *fmt, ...)
{
   int N;
   char *L;
   va_list(ap);
   if (!lref) lref= P->ipt;
   for(L=P->ore,N=1;L!=lref;L++)
     if (L[0]=='\n') N++;
   fprintf(stderr,"error at %s:%d: ", P->fn, N);
   va_start(ap,fmt);
   vfprintf(stderr, fmt, ap);
   va_end(ap);
   exit(1);
}

parser_t *parser_new(char *fn)
{
  parser_t *P;
  file_t *F;
  P= malloc(sizeof(*P));
  P->fn= fn;
  F= file_read(fn);
  if (F->error)
    exit(fprintf(stderr,"can not open %s for reading: %s\n", fn, F->error));
  P->ore= P->ipt= (char*) F->contents;
  // FIXME: file_close??
  return P;
}

#line 68 "/home/dodo/SFP/fxform-1.3/src/parse.u"

char *parse_strlit(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]!='"') p_error(P,0,"a string literal was expected.\n");
  b= P->ipt;
  P->ipt++;
  while(1)
  {
    if (P->ipt[0]==0) { goto premature_eof; }
    if (P->ipt[0]=='\\') { P->ipt++; if (P->ipt[0]==0) goto premature_eof; }
    if (P->ipt[0]=='"') { P->ipt++; break; }
    P->ipt++;
  }
  return parser_collect(b, P);
premature_eof:
  p_error(P, b, "end of file within string literal");
  return 0;
}

#line 96 "/home/dodo/SFP/fxform-1.3/src/parse.u"

int parse_int(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (!isdigit(P->ipt[0]) && P->ipt[0]!='-') 
     p_error(P, 0,"an integer was expected.\n");
  b= P->ipt;
  P->ipt++;
  while(isdigit(P->ipt[0])) P->ipt++;
  char *V= parser_collect(b,P);
  if (V[0]=='-' && V[1]==0)
    p_error(P, b, "malformed integer");
  int R= atoi(V);
  free(V); 
  return R;
}

char* parse_flo(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (!isdigit(P->ipt[0]) && P->ipt[0]!='-') 
     p_error(P, 0,"a floating point number was expected.\n");
  b= P->ipt;
  P->ipt++;
  while(isdigit(P->ipt[0])) P->ipt++;
  if (P->ipt[0]=='.') {
     P->ipt++;
     while(isdigit(P->ipt[0])) P->ipt++;
  }
  if (P->ipt[0]=='E' || P->ipt[0]=='e') {
     P->ipt++;
     if (P->ipt[0]=='-' || P->ipt[0]=='+') P->ipt++;
     if (!isdigit(P->ipt[0])) p_error(P,b,"malformed float");
     while(isdigit(P->ipt[0])) P->ipt++;
  }
  return parser_collect(b,P);
}

#line 157 "/home/dodo/SFP/fxform-1.3/src/parse.u"

char* parse_ident_or_rcurly(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]=='}') { P->ipt++; return 0; }
  if (!isalpha(P->ipt[0]) && P->ipt[0]!='_') 
    p_error(P,0, "an identifier or '}' was expected.\n");
  b= P->ipt;
  while(isident(P->ipt[0]))
    P->ipt++;
  return parser_collect(b,P);
}

#line 175 "/home/dodo/SFP/fxform-1.3/src/parse.u"

char *parse_ident_or_eof(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]==0) return 0; 
  if (!isalpha(P->ipt[0]) && P->ipt[0]!='_') 
    p_error(P,0, "an identifier or EOF was expected.\n");
  b= P->ipt;
  while(isident(P->ipt[0]))
    P->ipt++;
  return parser_collect(b,P);
}
#line 194 "/home/dodo/SFP/fxform-1.3/src/parse.u"

char *parse_ident(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (!isalpha(P->ipt[0]) && P->ipt[0]!='_') 
    p_error(P,0, "an identifier was expected.\n");
  b= P->ipt;
  while(isident(P->ipt[0]))
    P->ipt++;
  return parser_collect(b,P);
}

#line 228 "/home/dodo/SFP/fxform-1.3/src/parse.u"

void parse_lcurly(parser_t *P)
{
  char *ep= P->ipt;
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]!='{')
     p_error(P, ep, "'{' was expected.\n");
  P->ipt++;
}

#line 242 "/home/dodo/SFP/fxform-1.3/src/parse.u"

 char* gen_symbol()
 {
   static int last= 1;
   char buf[200];
   sprintf(buf,"VFLL%d",last++);
   return strdup(buf);
 }

#line 324 "/home/dodo/SFP/fxform-1.3/src/parse.u"

char *parse_cpp(parser_t *P)
{
  extern int no_lines; // FIXME: do this properly
  int K;
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]!='{') p_error(P,0, "a '{' was expected.\n"); 
  b= P->ipt; P->ipt++;
  K=1;
  while(1) 
    if (P->ipt[0]=='#') skip_directive(P);
    else if (P->ipt[0]=='\'' || P->ipt[0]=='"') skip_quote(P);
    else if (P->ipt[0]=='/') 
       { P->ipt++; if (P->ipt[0]=='*' || P->ipt[0]=='/') skip_comment(P); }
    else if (P->ipt[0]=='{') { P->ipt++; K++; }
    else if (P->ipt[0]=='}') {
       K--; P->ipt++;
       if (K==0) {
         char lnbuf[2000];
         char *R, *C;
	 if (no_lines)
           lnbuf[0]= 0;
         else
           snprintf(lnbuf,2000,"\n#line %d \"%s\" \n",
             count_lines(P,b),P->fn);
         
         C= parser_collect(b+1,P);
         R= malloc(strlen(C)+strlen(lnbuf)+1);
         sprintf(R, "%s%s", lnbuf, C);
         R[strlen(R)-1]= 0;
         free(C);
         return R;
       }
    } else P->ipt++;
  p_error(P,b, "unterminated code section.\n");
}

#line 398 "/home/dodo/SFP/fxform-1.3/src/parse.u"

tpl_t *parse_sub_widget(parser_t* P,char *name)
{
   tpl_t *R;
   static widget_parser_t widgets[]=
   {
      { "list", p_list },
      { "tab_book", p_tab_book },
      { 0,0 },
   };
   int i;
   R= parse_user_widget(P, name);
   if (R) return R;
   for(i=0;widgets[i].name;i++)
       if (!strcmp(widgets[i].name,name))
         return (*widgets[i].func)(P);
   return 0;
}

#line 450 "/home/dodo/SFP/fxform-1.3/src/parse.u"

char *parse_color(parser_t *P)
{
  int i;
  char buf[200];
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]!='#') goto bad_color;
  P->ipt++;
  for(i=0;i<6;i++)
   if (!P->ipt[i] || !strchr("0123456789abcdefABCDEF",P->ipt[i]))
      goto bad_color;
  sprintf(buf,"FXRGB(0x%c%c,0x%c%c,0x%c%c)",
     P->ipt[0], P->ipt[1],
     P->ipt[2], P->ipt[3],
     P->ipt[4], P->ipt[5]);
  P->ipt+=6;
  return strdup(buf);

bad_color:
  p_error(P,0, "a color specification (#xxxxxx) was expected.\n");
  return 0;
}

#line 21 "/home/dodo/SFP/fxform-1.3/src/file.u"

file_t *file_read(char *name)
{
   file_t *F;
   FILE *D;
   F= newfile(name);
   D= fopen(name, "r");
   if (!D) {
      char buf[2000];
      sprintf(buf, "can not open file for reading: %s", strerror(errno));
      F->error= strdup(buf);
      return F;
   }
   do_read(D, F);
   fclose(D);
   return F;
}

file_t *file_read_descriptor(FILE *D,char *name)
{
   file_t *F;
   F= newfile(name);
   do_read(D, F);
   return F;
}

#line 142 "/home/dodo/SFP/fxform-1.3/src/parse.u"
static char *parser_collect(char *s,parser_t *P)
{
  int L= P->ipt-s;
  char *R= malloc(L+1);
  memcpy(R, s, L);
  R[L]= 0;
  return R;
}

#line 214 "/home/dodo/SFP/fxform-1.3/src/parse.u"

static int isspc(int a)
{
  if (a>0 && a<=32) return 1;
  if (a==127) return 1;
  return 0;
}

static int isident(int a)
{
  return isalnum(a) || a=='_';
}

#line 262 "/home/dodo/SFP/fxform-1.3/src/parse.u"

static void skip_quote(parser_t *P)
{
  int q= P->ipt[0];
  char *b= P->ipt;
  P->ipt++;
  while(P->ipt[0])
  {
     if (P->ipt[0]=='\\') { P->ipt++; if (!P->ipt[0]) break; P->ipt++;}
     if (P->ipt[0]==q) { P->ipt++; return ; }
     P->ipt++;
  }
  p_error(P, b, "unmatched quote.\n");
}

#line 282 "/home/dodo/SFP/fxform-1.3/src/parse.u"

static void skip_comment(parser_t *P)
{
  char *b;
  b= P->ipt-1;
  if (P->ipt[0]=='*') {
     P->ipt++;
     while(1) 
        if (P->ipt[0]==0) break;
        else if (P->ipt[0]!='*') P->ipt++;
        else { P->ipt++; if (P->ipt[0]=='/') { P->ipt++; return ; } }
  } else {
    P->ipt++;
    while(1) 
      if (P->ipt[0]==0) break;
      else if (P->ipt[0]=='\n') { P->ipt++; return; }
      else P->ipt++;
  }
  p_error(P,b, "unterminated comment.\n");
}

static void skip_directive(parser_t *P)
{
  char *b= P->ipt;
  while(1)
     if (P->ipt[0]==0) break;
     else if (P->ipt[0]=='\'' || P->ipt[0]=='"') skip_quote(P);
     else if (P->ipt[0]=='\\')
          { P->ipt++;
            if (P->ipt[0]=='\r') P->ipt++;
            if (P->ipt[0]==0) break; P->ipt++; }
     else if (P->ipt[0]=='/')
          { P->ipt++; if (P->ipt[0]=='*' || P->ipt[0]=='/') skip_comment(P); }
     else if (P->ipt[0]=='\n') { P->ipt++; return ; }
     else P->ipt++;
  p_error(P,b, "unterminated preprocessor directive.\n");
}
#line 363 "/home/dodo/SFP/fxform-1.3/src/parse.u"

static int count_lines(parser_t *P, char *lref)
{
   int N;
   char *L;
   if (!lref) lref= P->ipt;
   for(L=P->ore,N=1;L!=lref;L++)
     if (L[0]=='\n') N++;
   return N;
}

#line 56 "/home/dodo/SFP/fxform-1.3/src/file.u"

static file_t *newfile(char* name)
{
  file_t *F;
  F= calloc(1,sizeof(*F));
  F->name= strdup(name);
  return F;
}


static void do_read(FILE *D, file_t *F)
{
  buffer_t **tail;
  buffer_t *head;
  buffer_t *B,*N;

  tail= &head;
  head= 0;

  while(1) {
     int R;
     B= malloc(sizeof(*B));
     R= fread(B->data, 1, sizeof(B->data), D);
     if (R<=0) {
	free(B);
        if (feof(D)) break;
        F->error= strdup("read failed");
        goto free_all;
     }
     B->len= R;
     B->next= 0;
     *tail= B; 
     tail = &B->next;
  }

  int L=0;
  for(B=head;B;B=B->next)
    L+= B->len;

  F->contents= malloc(L+1);
  L= 0;
  for(B=head;B;B=B->next) {
      memcpy(F->contents+L, B->data, B->len);
      L+= B->len;
  }
  F->contents[L]= 0;
  F->size= L;

free_all:
  for(B= head; B; B=N)
  {
     N= B->next;
     free(B);
  }
}

#line 444 "/home/dodo/SFP/fxform-1.3/src/parse.u"

