#line 157 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "template.h"
#include "parse.h"
#include "property.h"
#include "prophandler.h"
#include "icon.h"

#line 38 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"

static void parse_font_and_replace(char *pfx,parser_t *P,tpl_t *T)
{
  static char * font_style_keywords[][3]= 
  {
  { "reverse_oblique", "slant", "ReverseOblique" },
  { "reverse_italic" , "slant", "ReverseItalic" },
  { "no_slant"       , "slant", "Straight" },
  { "italic"         , "slant", "Italic" },
  { "oblique"        , "slant", "Oblique" },

  { "thin"           , "weight", "Thin" },
  { "extra_light"    , "weight", "ExtraLight" },
  { "light"          , "weight", "Light" },
  { "normal_weight"  , "weight", "Normal" },
  { "medium_bold"    , "weight", "Medium" },
  { "demi_bold"      , "weight", "DemiBold" },
  { "bold"           , "weight", "Bold" },
  { "extra_bold"     , "weight", "ExtraBold" },
  { "ultra_bold"     , "weight", "Black" },

  { "ultra_condensed", "width", "UltraCondensed"},
  { "extra_condensed", "width", "ExtraCondensed"},
  { "condensed"      , "width", "Condensed"},
  { "semi_condensed" , "width", "SemiCondensed"},
  { "normal_width"   , "width", "NonExpanded"},
  { "semi_expanded"  , "width", "SemiExpanded"},
  { "expanded"       , "width", "Expanded"},
  { "extra_expanded" , "width", "ExtraExpanded"},
  { "ultra_expanded" , "width", "UltraExpanded"},
  { 0, 0, 0 }
  };
  char buf[2000];
  char val[200];
  parse_lcurly(P);
  while(1)
  {
     int i;
     char *kw= parse_ident_or_rcurly(P);
     if (!kw) return ;
     if (!strcmp(kw,"size"))
        { sprintf(buf,"$%s_size", pfx);
          tpl_replace_i(T, buf, parse_int(P)); continue; }
     if (!strcmp(kw,"family"))
        { sprintf(buf,"$%s_family", pfx);
          tpl_replace(T, buf, parse_strlit(P)); continue; }
     for(i=0;font_style_keywords[i][0];i++)
       if (!strcmp(kw,font_style_keywords[i][0]))
       {
        sprintf(buf,"$%s_%s", pfx, font_style_keywords[i][1]);
        sprintf(val,"FXFont::%s", font_style_keywords[i][2]);
        tpl_replace(T, buf, strdup(val));
        break;
       }
     if (!font_style_keywords[i])
       p_error(P,0,"unknown font property '%s'.\n",kw);
  }
}

#line 5 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"

int handle_prop_keyword(char *kw,property_t *props, tpl_t *T, parser_t* P)
{
  property_t *pro;
  char buf[2000], namebuf[2000];

  for(pro=props;pro;pro=pro->next)
    if (!strcmp(pro->name, kw)) break;
  if (!pro) return 0;

  sprintf(buf,"$%s",kw);
  switch(pro->kind)
  {
  case pro_int: tpl_replace_i(T,buf, parse_int(P)); break;
  case pro_float: tpl_replace(T,buf, parse_cpp(P)); break;
  case pro_string: tpl_replace(T,buf, parse_strlit(P)); break;
  case pro_ident: tpl_replace(T, buf, parse_ident(P)); break;
  case pro_flag: tpl_replace(T, buf, "Y"); break;
  case pro_color: tpl_replace(T, buf, parse_color(P)); break;
  case pro_font: parse_font_and_replace(kw,P,T); break;
  case pro_icon: 
       sprintf(namebuf,"$%s", pro->name);
       put_icon(T, namebuf,P); break;
  case pro_enum: 
       tpl_replace(T, pro->target, pro->value);
       break;
  default:
       p_error(P,0,"bad property type for %s.\n", kw);
  }
  return 1;
}

#line 106 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"

char *p_mainwindow_decorations(parser_t *P)
{
    char *dkw;
    static char *names[]= {
    "title", "minimize", "maximize",
    "close", "border", "shrinkable",
    "stretchable", "menu",0 };
    int decs[8];
    int i;
    for(i=0;i<8;i++) decs[i]= 0;
    parse_lcurly(P);
    while((dkw=parse_ident_or_rcurly(P)))
    {
         char *namepart; int R;
         if (!strncmp(dkw,"no_",3)) { namepart= dkw+3; R= 0; }
         else { namepart= dkw; R= 1; }
         for(i=0;names[i];i++)
           if (!strcmp(namepart,names[i])) { decs[i] = R; break; }
         if (!names[i]) {
            if (!strcmp(namepart,"resize"))
               decs[5]= decs[6]= R;
            else if (!strcmp(dkw,"all"))
               for(i=0;names[i];i++) decs[i]= 1;
            else if (!strcmp(dkw,"none"))
               for(i=0;names[i];i++) decs[i]= 0;
            else p_error(P,0,"unknown decoration %s.\n", dkw);
         }
    }

   char buf[1000];
   strcpy(buf," 0 ");
   for(i=0;names[i];i++)
     if (decs[i]) { 
      strcat(buf, " | DECOR_");
      strcat(buf, names[i]);
     }
   for(i=0;buf[i];i++) buf[i]= toupper(buf[i]);
   return strdup(buf);
}





#line 168 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"

