#line 183 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "template.h"
#include "parse.h"
#include "property.h"
#include "prophandler.h"


#line 13 "w_main_window.c"

static void parse_menu_item(parser_t *P,tpl_t *T);
static void parse_menu(parser_t *P,tpl_t *T);
static void parse_menubar(parser_t *P, tpl_t *T);
#line 280 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"


static void parse_menu_item(parser_t *P,tpl_t *T)
{
   char *kw;
   parse_lcurly(P);
   tpl_t *ST;
   ST= tpl_new(
#line 26 "w_main_window.c"
"@menu_items\n"
"   new FXMenuCommand($menupane,$dev($title)(\042Item\042),NULL,\n"
"      $def($click)(this) $nef($click)(NULL),\n"
"      $def($click)($G_selector) $nef($click)(0));\n"
"\n"
"@form_selector_ids\n"
"   $def($click)($G_selector,)\n"
"@form_methods\n"
"   $def($click)(\n"
"     long $form_class::$G_click\n"
"          (FXObject *object,FXSelector sel, void *arg)\n"
"          { $click return 1; }\n"
"   )\n"
"@form_members\n"
"   $def($click)(long $G_click(FXObject *object,FXSelector sel, void *arg);)\n"
"@form_signal_mappings\n"
"  $def($click)\n"
"  (\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
"  )\n"

#line 310 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
  );
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (!strcmp(kw,"title"))
     {
       tpl_replace(ST, "$title", parse_strlit(P));
       continue;
     }
     if (!strcmp(kw,"click"))
     {
       tpl_replace(ST, "$click", parse_cpp(P));
       continue;
     }
     p_error(P, NULL,"unknown keyword %s in menu item",kw);
   }
   tpl_builtin(ST);
   tpl_relocations(T,ST);
}

static void parse_menu(parser_t *P,tpl_t *T)
{
   char *kw;
   parse_lcurly(P);
   tpl_t *ST;
   ST= tpl_new(
#line 73 "w_main_window.c"
"@form_constructor\n"
"   FXMenuPane *$menupane= new FXMenuPane(this); \n"
" <menu_items>\n"
"   new FXMenuTitle($menubar, $dev($title)(\042Menu\042),NULL, $menupane);\n"

#line 341 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
  );
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (!strcmp(kw,"title"))
     {
       tpl_replace(ST, "$title", parse_strlit(P));
       continue;
     }
     if (!strcmp(kw,"item"))
     {
       parse_menu_item(P,ST);
       continue;
     }
     p_error(P, NULL,"unknown keyword %s in menubar",kw);
   }
   tpl_replace(ST, "$menupane", gen_symbol());
   tpl_builtin(ST);
   tpl_relocations(T,ST);
}

static void parse_menubar(parser_t *P, tpl_t *T)
{
   char *kw;
   tpl_t *ST;
   parse_lcurly(P);
   ST= tpl_new(
#line 105 "w_main_window.c"
"@form_constructor\n"
"   FXMenuBar *$menubar= new FXMenuBar(this, LAYOUT_SIDE_TOP|LAYOUT_FILL_X);\n"

#line 371 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
   );
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (!strcmp(kw,"menu"))
     {
       parse_menu(P,ST);
       continue;
     }
     p_error(P, NULL,"unknown keyword %s in menubar",kw);
   }
   tpl_replace(ST, "$menubar", gen_symbol());
   tpl_builtin(ST);
   tpl_relocations(T,ST);
}
#line 8 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"

tpl_t *p_main_window(parser_t *P)
{
   char *form_class_name= 0;
   char *kw;
   tpl_t *T= tpl_new(
#line 130 "w_main_window.c"
"\n"
"@top_level_interface\n"
"\n"
"typedef struct {\n"
"  void *self;\n"
"  <form_widget_declarations>\n"
"} gui_$T($objid)_t;\n"
"\n"
"#ifdef __cplusplus\n"
"extern \042C\042 {\n"
"#endif\n"
"\n"
"gui_$T($objid)_t *gui_c_$objid();\n"
"\n"
"#ifdef __cplusplus\n"
"}\n"
"#endif\n"
"\n"
"@form_types\n"
"\n"
" class $form_class: public FXMainWindow\n"
" {\n"
"  FXDECLARE($form_class)\n"
" public:\n"
"  enum { ID_FIRST= FXMainWindow::ID_LAST,\n"
"         ID_SELF,\n"
"         <form_selector_ids> };\n"
"  <form_members>\n"
"  $form_class(FXApp* a,const FXString& name,\n"
"         FXIcon *ic,FXIcon *mi,FXuint opts,\n"
"         FXint x,FXint y,FXint w,FXint h,\n"
"         FXint pl,FXint pr,FXint pt,FXint pb,\n"
"         FXint hs,FXint vs);\n"
"  virtual ~$form_class();\n"
"  $form_class() : FXMainWindow() { }\n"
"  long handle_close(FXObject *object,FXSelector sel, void *arg);\n"
" };\n"
"\n"
" FXDEFMAP($form_class) $G_map []= {\n"
"  FXMAPFUNC(SEL_CLOSE, $form_class::ID_SELF, $form_class::handle_close),\n"
"  <form_signal_mappings>\n"
" }; \n"
"\n"
" FXIMPLEMENT($form_class, FXMainWindow, $G_map, ARRAYNUMBER($G_map))\n"
"\n"
" // FIXME: the argument names must be changed so that\n"
" // we can have widgets called \047y\047 etc.\n"
" $form_class::$form_class(\n"
"         FXApp* a,const FXString& name,\n"
"         FXIcon *ic,FXIcon *mi,FXuint opts,\n"
"         FXint x,FXint y,FXint w,FXint h,\n"
"         FXint pl,FXint pr,FXint pt,FXint pb,\n"
"         FXint hs,FXint vs) :\n"
"               FXMainWindow(a,name, ic,mi,opts,\n"
"                            x,y,w,h, pl,pr,pt,pb, hs,vs)\n"
"\n"
" {\n"
"   setTarget(this);\n"
"   setSelector(ID_SELF);\n"
"   <form_constructor>\n"
" }\n"
" $form_class:: ~ $form_class() { }\n"
" long $form_class::handle_close\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
" {\n"
"    $dev($close_code)(/* window closing code would go here */)\n"
"    return 0;\n"
" } \n"
" <form_methods>\n"
"\n"
"\n"
"@top_level_code \n"
"\n"
" gui_$T($objid)_t *gui_c_$objid()\n"
" {\n"
"    // ffo -> fox form object\n"
"    // ifo -> interface form object \n"
"   $form_class *ffo;\n"
"   gui_$T($objid)_t * ifo;\n"
"   ffo= new $form_class(\n"
"       FXApp::instance(),\n"
"       $dev($title)(\042Main Window\042),\n"
"       NULL, NULL, // FIXME: icons\n"
"       $dev($decorations)(DECOR_ALL) ,\n"
"       $dev($pos_x)(0), $dev($pos_y)(0),\n"
"       $dev($default_width)(400), $dev($default_height)(400),\n"
"       $dev($pad_left)(0), $dev($pad_right)(0),\n"
"       $dev($pad_top)(0), $dev($pad_bottom)(0),\n"
"       $dev($hz_spacing)(0), $dev($vt_spacing)(0));\n"
"   // If the application has not been created, this will done\n"
"   // when the application gets created. Otherwise, we have\n"
"   // to explicitly do this.\n"
"   if (app_created) \n"
"     ffo->create();\n"
"   \n"
"   ffo->show(PLACEMENT_SCREEN);\n"
"\n"
"   ifo= (typeof(ifo)) malloc(sizeof(*ifo));\n"
"   ifo->self= ffo;\n"
"   <form_widget_export>\n"
"   return ifo;\n"
" }\n"
"\n"
"\n"

#line 17 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
   );
   static property_t *props;
   if (!props)
   {
     prop_common(&props, "padding");
     prop_common(&props, "spacing");
     prop_common(&props, "objid");
     prop_str(&props, "title");
     prop_int(&props, "pos_x"); prop_int(&props, "pos_y");
     prop_int(&props, "default_width"); prop_int(&props, "default_height");
   }
   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (handle_prop_keyword(kw,props, T,P)) continue;
     if (!strcmp(kw,"decorations"))
     {
       tpl_replace(T,"decorations", p_mainwindow_decorations(P)); 
       continue;
     }
     if (!strcmp(kw,"class_name"))
        { form_class_name= parse_ident(P); continue; }
     if (!strcmp(kw,"close"))
        { tpl_replace(T,"$close_code", parse_cpp(P)); continue; }
     if (!strcmp(kw,"menubar"))
        { parse_menubar(P, T); continue; }
#line 214 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"

 if (!strcmp(kw, "signal")) {
   char  *id,*selector,*code;
   selector= parse_ident(P);
   id= parse_ident(P);
   code= parse_cpp(P);
   tpl_t *ST= tpl_new(
#line 270 "w_main_window.c"
"\n"
" @form_members\n"
"  long $G_name(FXObject *object,FXSelector sel, void *arg);\n"
" @form_signal_mappings\n"
"  FXMAPFUNC($SELECTOR, $form_class::$ID, $form_class::$G_name),\n"
" @form_methods\n"
"  long $form_class::$G_name(FXObject *object,FXSelector sel, void *arg)\n"
"  {\n"
"    $code\n"
"  }\n"

#line 224 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
   );
   tpl_replace(ST, "$ID", id);
   tpl_replace(ST, "$SELECTOR", selector);
   tpl_replace(ST, "$code", code);
   tpl_builtin(ST);
   tpl_relocations(T, ST);
   continue;
 }

#line 248 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
  if (!strcmp(kw,"selector"))
  {
     tpl_t *trivial= tpl_new("\n@form_selector_ids\n$ID,\n");
     tpl_replace(trivial, "$ID", parse_ident(P));
     tpl_relocations(T, trivial);
     continue;
  }
  if (!strcmp(kw,"constructor"))
  {
     tpl_t *trivial= tpl_new("\n@form_constructor\n$code\n");
     tpl_replace(trivial, "$code", parse_cpp(P));
     tpl_relocations(T, trivial);
     continue;
  }
  if (!strcmp(kw,"members"))
  {
     tpl_t *trivial= tpl_new("\n@form_members\n$code\n");
     tpl_replace(trivial, "$code", parse_cpp(P));
     tpl_relocations(T, trivial);
     continue;
  }
  if (!strcmp(kw,"destructor"))
  {
     tpl_t *trivial= tpl_new("\n@form_destructor\n$code\n");
     tpl_replace(trivial, "$code", parse_cpp(P));
     tpl_relocations(T, trivial);
     continue;
  }
#line 172 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"

  { tpl_t *C;
    C= parse_sub_widget(P, kw);
    if (!C) p_error(P, 0, "unknown keyword '%s'.\n",kw);
    tpl_replace(C, "$container", "this");
    tpl_relocations(T, C);
    continue; }

#line 45 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
     p_error(P, NULL,"unknown keyword %s in main window declaration",kw);
   }
   if (form_class_name)
     tpl_replace(T, "$form_class", form_class_name);
   else
     tpl_replace(T, "$form_class", gen_symbol());
   tpl_builtin(T);

   return T;
}

#line 199 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"

