#line 252 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"
#include "property.h"
#include "prophandler.h"

#line 22 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

typedef struct sig {
  struct sig *prev, *next;
  char *name;
  
} signal_t;
 
#line 424 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

typedef struct funcprop {
  struct funcprop *next;
  char *keyword;
  void (*func)(tpl_t *,parser_t*);
} funcprop_t;

#line 3 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

typedef struct userwidget {
  struct userwidget *next;
  char *widget_name;
  tpl_t *library_code;
  char *widget_code;
  int library_code_printed;
  property_t *properties;
  signal_t *signals;
  funcprop_t *funcprops;

  int is_container;
  char *foxclass;
} user_widget_t;

#line 33 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

static user_widget_t *user_widgets;

#line 353 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

void define_verb(char*);

#line 51 "w_user.c"

tpl_t *parse_user_widget(parser_t *P, char *name);
static tpl_t* parse_widget(parser_t *P, user_widget_t *uw);
static void parse_command(parser_t *P, tpl_t *lib,char *foxclass);
static int only_whitespace(char* str);
static void parse_common_properties(user_widget_t *uw, parser_t *P);
static void parse_enumspec(user_widget_t *W, parser_t *P);
static void add_funcprop
  (user_widget_t *W, char *kw, void (*f)(tpl_t *,parser_t *));
static void common_justify(tpl_t *T, parser_t *P);
#line 152 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

tpl_t *parse_user_widget(parser_t *P, char *name)
{
  user_widget_t *uw;
  for(uw=user_widgets;uw;uw=uw->next)
    if (!strcmp(name, uw->widget_name))
      return parse_widget(P, uw);
  return 0;
}

#line 163 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

static tpl_t* parse_widget(parser_t *P, user_widget_t *uw)
{
  char buf[2000];
  char *kw;
  tpl_t *T;
  signal_t *sig;  funcprop_t *fp;
  char *objid= 0;

  T= tpl_new(uw->widget_code);
  parse_lcurly(P);
again:
  kw= parse_ident_or_rcurly(P);
  if (!kw) goto done;
  if (!strcmp(kw,"objid")) 
  {
    objid= parse_ident(P);
    tpl_replace(T, "$objid", objid);
    goto again;
  }
  if (handle_prop_keyword(kw, uw->properties, T, P)) goto again;
  for(fp=uw->funcprops;fp;fp=fp->next)
    if (!strcmp(fp->keyword,kw))
      goto do_funcprop;
  for(sig=uw->signals;sig;sig=sig->next)
    if (!strcmp(sig->name,kw))
      goto do_signal;
  if (uw->is_container)
  {
    tpl_t *child;
    child= parse_sub_widget(P, kw);
    if (child)
    {
      tpl_replace_var(child, "$container", "$G_obj");
      // the semantics of this function is very important
      // the unknown sections are appended to this widget's code
      // and therefore follow the construction of this code.
      tpl_relocations(T, child);
      goto again;
    }
  }
  p_error(P,0,"unknown keyword '%s'\n", kw);
done:
  if (objid && !uw->library_code_printed)
  {
    if (uw->library_code) tpl_append(T, uw->library_code);
    uw->library_code_printed= 1;
  }
  if (objid)
  {
    char g[2000];
    if (!uw->foxclass)
       p_error(P, NULL,"no foxclass is defined for widget class '%s'\n", 
               uw->widget_name);
    tpl_t *export= tpl_new(
#line 128 "w_user.c"
"\n"
"@form_members $foxclass *$objid;\n"
"@form_widget_declarations $widget_struct_t $objid;\n"
"@form_widget_export \n"
"  ifo->$objid.widget= ffo->$objid;\n"
"  ifo->$objid.cls= & $class_object;\n"

#line 221 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
    );
      sprintf(g,"gui_%s_class", uw->widget_name);
    tpl_replace(export, "$class_object", strdup(g));
    tpl_replace(export, "$objid", objid);
      sprintf(g,"gui_%s_t", uw->widget_name);
    tpl_replace(export, "$widget_struct_t", strdup(g));
    tpl_replace(export, "$foxclass", uw->foxclass);
    tpl_append(T, export);
  }
  tpl_builtin(T);
  return T;
do_signal:
  sprintf(buf,"$%s",kw);
  tpl_replace(T, buf, parse_cpp(P));
  goto again;
do_funcprop:
  (*fp->func)(T, P);
  goto again;
}

#line 309 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

static void parse_command(parser_t *P, tpl_t *lib,char *foxclass)
{
  char *name,*args;

  if (!foxclass) 
   p_error(P,NULL,"please give the foxclass before defining commands.\n");

  tpl_t *ct= tpl_new(
#line 166 "w_user.c"
"@generated_commands\n"
" static void $G_func($widget_struct_t *_object $comma $arguments)\n"
" {\n"
"    $foxclass *widget= ($foxclass*) (_object->widget);\n"
"    $code\n"
" }\n"
"@command_declarations void (*$command_name)($widget_struct_t *object\n"
"                                             $comma $arguments);\n"
"@command_assignments       $G_func,\n"

#line 329 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
  );
  name= parse_ident(P);
  args= parse_cpp(P);
  if (only_whitespace(args))
  {
    tpl_replace(ct, "$arguments", "");
    tpl_replace(ct, "$comma", "");
  } 
  else
  {
    tpl_replace(ct, "$arguments", args);
    tpl_replace(ct, "$comma", ",");
  }

  tpl_replace(ct, "$code", parse_cpp(P));
  tpl_replace(ct, "$command_name", name);
  tpl_replace(ct, "$foxclass", foxclass);
  tpl_builtin(ct);

  tpl_relocations(lib, ct);
  define_verb(name);
}

#line 363 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

static int only_whitespace(char* str)
{
  while(*str)
   if ((*str!=127 && *str>32) || *str<0) return 0;
   else str++;
  return 1;
}

#line 377 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

static void parse_common_properties(user_widget_t *uw, parser_t *P)
{
  char *kw;
  parse_lcurly(P);
  while((kw=parse_ident_or_rcurly(P)))
  {
    if (!strcmp(kw,"justification"))
    {
      add_funcprop(uw, "justify", common_justify);
      continue;
    }
    if (prop_common(&uw->properties, kw)) continue;

    p_error(P,0,"unknown common property '%s'.\n", kw);
  }
}

#line 400 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

static void parse_enumspec(user_widget_t *W, parser_t *P)
{
  char *target,*name,*value,*tvar;
  char buf[2000];
  target= parse_ident(P);
  parse_lcurly(P);
  sprintf(buf,"$%s",target);
  tvar= strdup(buf);
  while(1)
  {
    name= parse_ident_or_rcurly(P);
    if (!name) break;
    value= parse_cpp(P);
    prop_enum(&W->properties, tvar, name, value);
  }
}


#line 432 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

static void add_funcprop
  (user_widget_t *W, char *kw, void (*f)(tpl_t *,parser_t *))
{
  funcprop_t *fp;
  fp= calloc(1,sizeof(*fp));
  fp->next= W->funcprops;
  W->funcprops= fp;
  fp->keyword= kw;
  fp->func= f;
}

#line 448 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

static void common_justify(tpl_t *T, parser_t *P)
{
  char *kw;
  parse_lcurly(P);
  while((kw= parse_ident_or_rcurly(P)))
  {
    if (!strcmp(kw,"center_x"))
        tpl_replace(T, "$justify_x", "JUSTIFY_CENTER_X");
    else if (!strcmp(kw,"left"))
        tpl_replace(T, "$justify_x", "JUSTIFY_LEFT");
    else if (!strcmp(kw,"right"))
        tpl_replace(T, "$justify_x", "JUSTIFY_RIGHT");
    else if (!strcmp(kw,"hz_apart"))
        tpl_replace(T, "$justify_x", "JUSTIFY_HZ_APART");
    else if (!strcmp(kw,"center_y"))
        tpl_replace(T, "$justify_y", "JUSTIFY_CENTER_Y");
    else if (!strcmp(kw,"top"))
        tpl_replace(T, "$justify_y", "JUSTIFY_TOP");
    else if (!strcmp(kw,"bottom"))
        tpl_replace(T, "$justify_y", "JUSTIFY_BOTTOM");
    else if (!strcmp(kw,"vt_apart"))
        tpl_replace(T, "$justify_y", "JUSTIFY_VT_APART");
    else p_error(P,0, "unknown justification keyword '%s'\n", kw);
  }
}
#line 42 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

tpl_t *define_widget(parser_t *P)
{
   tpl_t *T;
   int have_commands=0;
   user_widget_t *W;
   char *kw;
   W= calloc(1,sizeof(*W));
   T= tpl_new(
#line 299 "w_user.c"
"\n"
"@library_interface\n"
"\n"
" typedef struct $widget_struct $widget_struct_t;\n"
" typedef struct \n"
" {\n"
"   <command_declarations>\n"
" } $class;\n"
"\n"
" struct $widget_struct {\n"
"   $class *cls;\n"
"   void *widget;\n"
" };\n"
"\n"
"@library_objects\n"
"\n"
"static $class $class_object = {\n"
" <command_assignments>\n"
"};\n"
"\n"
"\n"

#line 54 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
   );
   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (!strcmp(kw,"is_container"))
     {
       W->is_container= 1;
       continue;
     }
     if (!strcmp(kw,"foxclass"))
     {
       W->foxclass= parse_ident(P);
       continue;
     }
     if (!strcmp(kw,"property"))
     {
       property_t *pro= calloc(1,sizeof(*pro));
       pro->name= parse_ident(P);
       char *type= parse_ident(P);
       if (!strcmp(type,"int")) pro->kind= pro_int;
       else if (!strcmp(type,"float")) pro->kind= pro_float;
       else if (!strcmp(type,"str")) pro->kind= pro_string;
       else if (!strcmp(type,"ident")) pro->kind= pro_ident;
       else if (!strcmp(type,"flag")) pro->kind= pro_flag;
       else if (!strcmp(type,"color")) pro->kind= pro_color;
       else if (!strcmp(type,"font")) pro->kind= pro_font;
       else if (!strcmp(type,"icon")) pro->kind= pro_icon;
       // FIXME: handle the enum case
       else p_error(P,0, "unknown property type '%s'\n", type);
       pro->next= W->properties;
       W->properties= pro;
       continue;
     }
     if (!strcmp(kw,"enum")) { parse_enumspec(W,P); continue; }
     if (!strcmp(kw,"name"))
     {
       if (W->widget_name) p_error(P,0,"multiple names given for the widget");
       W->widget_name= parse_ident(P);
       continue;
     }
     if (!strcmp(kw,"library_code"))
     {
        if (W->library_code)
         tpl_append(W->library_code, tpl_new(parse_cpp(P)));
        else 
         W->library_code= tpl_new(parse_cpp(P));
        continue;
     }
     if (!strcmp(kw,"widget_code"))
     {
        if (W->widget_code)
          p_error(P,0,"widget code already defined for widget");
        W->widget_code= parse_cpp(P);
        continue;
     }
     if (!strcmp(kw,"signal"))
     {
        signal_t *S;
        S= malloc(sizeof(*S));
        S->name= parse_ident(P);
        S->next= W->signals;
        W->signals= S;
        continue;
     }
     if (!strcmp(kw,"command")) 
       { parse_command(P,T,W->foxclass); have_commands=1; continue; }
     if (!strcmp(kw,"common_properties"))
       { parse_common_properties(W, P); continue; }
     p_error(P, NULL, "unknown keyword '%s' in define_widget",kw);
   }

   if (have_commands)
   {
     char g[2000];
     sprintf(g,"gui_%s", W->widget_name);
     tpl_replace(T, "$widget_struct", strdup(g));
     sprintf(g,"gui_%s_t", W->widget_name);
     tpl_replace(T, "$widget_struct_t", strdup(g));
     sprintf(g,"gui_%s_class_t", W->widget_name);
     tpl_replace(T, "$class", strdup(g));
     sprintf(g,"gui_%s_class", W->widget_name);
     tpl_replace(T,"$class_object", strdup(g));

     if (W->library_code) tpl_append(W->library_code, T);
     else W->library_code= T; 
   }

   W->next= user_widgets;
   user_widgets= W;
   return tpl_new("/* no code for user widget class definition */\n");
}

#line 270 "/home/dodo/SFP/fxform-1.3/src/w_user.u"

