/* This file is an amalgamation of several source files.
   Please look for BEGIN FILE,END FILE and CONTINUE FILE
   strings to browse contents of individual files contained
   here. */
/* BEGIN FILE ../src/COPY.c */
/*
Copyright (c) 2014 by Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/* END FILE ../src/COPY.c */
/* BEGIN FILE ../build/w_user.c */
#line 252 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
/* BEGIN FILE ../build/template.h */
#line 279 "/home/dodo/tmp/FX/fxform-1.4/src/template.u"
#line 32 "/home/dodo/tmp/FX/fxform-1.4/src/template.u"
typedef struct tpl tpl_t;
#line 7 "template.h"
tpl_t *tpl_new(char *str);
void tpl_print(tpl_t *T);
char *tpl_to_str(tpl_t *T);
void tpl_append(tpl_t *dest, tpl_t *src);
void tpl_replace(tpl_t *TPL,char *name, char *value);
void tpl_replace_i(tpl_t *T, char *name, int v);
void tpl_free(tpl_t *T);
void tpl_builtin(tpl_t *TPL);
void tpl_relocations(tpl_t *dest,tpl_t *src);
void tpl_relocations_known_only(tpl_t *dest, tpl_t *src);
void tpl_replace_var(tpl_t *TPL, char *name, char *var);
void tpl_replace_tpl(tpl_t *TPL, char *name, tpl_t *value);
void tpl_remove_targets(tpl_t *TPL);
/* END FILE ../build/template.h */
/* CONTINUE FILE ../build/w_user.c */
/* BEGIN FILE ../build/parse.h */
#line 9 "/home/dodo/SFP/fxform-1.3/src/parse.u"
typedef struct {
   char *ipt, *ore;
   char *fn;
} parser_t;
#line 7 "/home/dodo/SFP/fxform-1.3/src/file.u"
typedef struct {
  char *name;
  char *error;
  size_t size;
  unsigned char* contents;
} file_t;
#line 16 "parse.h"
void p_error(parser_t *P, char *lref, char *fmt, ...);
parser_t *parser_new(char *fn);
char *parse_strlit(parser_t *P);
int parse_int(parser_t *P);
char* parse_flo(parser_t *P);
char* parse_ident_or_rcurly(parser_t *P);
char *parse_ident_or_eof(parser_t *P);
char *parse_ident(parser_t *P);
void parse_lcurly(parser_t *P);
 char* gen_symbol()
 ;
char *parse_cpp(parser_t *P);
tpl_t *parse_sub_widget(parser_t* P,char *name);
char *parse_color(parser_t *P);
file_t *file_read(char *name);
file_t *file_read_descriptor(FILE *D,char *name);
#line 425 "/home/dodo/SFP/fxform-1.3/src/parse.u"
/* END FILE ../build/parse.h */
/* CONTINUE FILE ../build/w_user.c */
/* BEGIN FILE ../build/property.h */
#line 7 "/home/dodo/tmp/FX/fxform-1.4/src/property.u"
enum pro_kind { pro_int, pro_string, pro_ident, pro_float,
                pro_flag, pro_color, pro_font, pro_icon, pro_enum };
typedef struct pro {
  struct pro *next;
  char *name;
  enum pro_kind kind;
  char *target, *value;
} property_t;
#line 13 "property.h"
int prop_common(property_t **L, char* kw);
void prop_flag(property_t **L, char *name);
void prop_int(property_t **L, char *name);
void prop_ident(property_t **L, char *name);
void prop_enum(property_t **L, char *target, char *name, char *value);
void prop_str(property_t **L, char *name);
void prop_font(property_t **L, char *name);
void prop_new(property_t **L, char *name, int kind, char *target, char *value);
/* END FILE ../build/property.h */
/* CONTINUE FILE ../build/w_user.c */
/* BEGIN FILE ../build/prophandler.h */
#line 152 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"
#line 3 "prophandler.h"
int handle_prop_keyword(char *kw,property_t *props, tpl_t *T, parser_t* P);
char *p_mainwindow_decorations(parser_t *P);
/* END FILE ../build/prophandler.h */
/* CONTINUE FILE ../build/w_user.c */
#line 22 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
typedef struct sig {
  struct sig *prev, *next;
  char *name;
} signal_t;
#line 424 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
typedef struct funcprop {
  struct funcprop *next;
  char *keyword;
  void (*func)(tpl_t *,parser_t*);
} funcprop_t;
#line 3 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
typedef struct userwidget {
  struct userwidget *next;
  char *widget_name;
  tpl_t *library_code;
  char *widget_code;
  int library_code_printed;
  property_t *properties;
  signal_t *signals;
  funcprop_t *funcprops;
  int is_container;
  char *foxclass;
} user_widget_t;
#line 33 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
static user_widget_t *user_widgets;
#line 353 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
void define_verb(char*);
#line 51 "w_user.c"
tpl_t *parse_user_widget(parser_t *P, char *name);
static tpl_t* parse_widget(parser_t *P, user_widget_t *uw);
static void parse_command(parser_t *P, tpl_t *lib,char *foxclass);
static int only_whitespace(char* str);
static void parse_common_properties(user_widget_t *uw, parser_t *P);
static void parse_enumspec(user_widget_t *W, parser_t *P);
static void add_funcprop
  (user_widget_t *W, char *kw, void (*f)(tpl_t *,parser_t *));
static void common_justify(tpl_t *T, parser_t *P);
#line 152 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
tpl_t *parse_user_widget(parser_t *P, char *name)
{
  user_widget_t *uw;
  for(uw=user_widgets;uw;uw=uw->next)
    if (!strcmp(name, uw->widget_name))
      return parse_widget(P, uw);
  return 0;
}
#line 163 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
static tpl_t* parse_widget(parser_t *P, user_widget_t *uw)
{
  char buf[2000];
  char *kw;
  tpl_t *T;
  signal_t *sig;  funcprop_t *fp;
  char *objid= 0;
  T= tpl_new(uw->widget_code);
  parse_lcurly(P);
again:
  kw= parse_ident_or_rcurly(P);
  if (!kw) goto done;
  if (!strcmp(kw,"objid"))
  {
    objid= parse_ident(P);
    tpl_replace(T, "$objid", objid);
    goto again;
  }
  if (handle_prop_keyword(kw, uw->properties, T, P)) goto again;
  for(fp=uw->funcprops;fp;fp=fp->next)
    if (!strcmp(fp->keyword,kw))
      goto do_funcprop;
  for(sig=uw->signals;sig;sig=sig->next)
    if (!strcmp(sig->name,kw))
      goto do_signal;
  if (uw->is_container)
  {
    tpl_t *child;
    child= parse_sub_widget(P, kw);
    if (child)
    {
      tpl_replace_var(child, "$container", "$G_obj");
// the semantics of this function is very important
// the unknown sections are appended to this widget's code
// and therefore follow the construction of this code.
      tpl_relocations(T, child);
      goto again;
    }
  }
  p_error(P,0,"unknown keyword '%s'\n", kw);
done:
  if (objid && !uw->library_code_printed)
  {
    if (uw->library_code) tpl_append(T, uw->library_code);
    uw->library_code_printed= 1;
  }
  if (objid)
  {
    char g[2000];
    if (!uw->foxclass)
       p_error(P, NULL,"no foxclass is defined for widget class '%s'\n",
               uw->widget_name);
    tpl_t *export= tpl_new(
#line 128 "w_user.c"
"\n"
"@form_members $foxclass *$objid;\n"
"@form_widget_declarations $widget_struct_t $objid;\n"
"@form_widget_export \n"
"  ifo->$objid.widget= ffo->$objid;\n"
"  ifo->$objid.cls= & $class_object;\n"
#line 221 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
    );
      sprintf(g,"gui_%s_class", uw->widget_name);
    tpl_replace(export, "$class_object", strdup(g));
    tpl_replace(export, "$objid", objid);
      sprintf(g,"gui_%s_t", uw->widget_name);
    tpl_replace(export, "$widget_struct_t", strdup(g));
    tpl_replace(export, "$foxclass", uw->foxclass);
    tpl_append(T, export);
  }
  tpl_builtin(T);
  return T;
do_signal:
  sprintf(buf,"$%s",kw);
  tpl_replace(T, buf, parse_cpp(P));
  goto again;
do_funcprop:
  (*fp->func)(T, P);
  goto again;
}
#line 309 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
static void parse_command(parser_t *P, tpl_t *lib,char *foxclass)
{
  char *name,*args;
  if (!foxclass)
   p_error(P,NULL,"please give the foxclass before defining commands.\n");
  tpl_t *ct= tpl_new(
#line 166 "w_user.c"
"@generated_commands\n"
" static void $G_func($widget_struct_t *_object $comma $arguments)\n"
" {\n"
"    $foxclass *widget= ($foxclass*) (_object->widget);\n"
"    $code\n"
" }\n"
"@command_declarations void (*$command_name)($widget_struct_t *object\n"
"                                             $comma $arguments);\n"
"@command_assignments       $G_func,\n"
#line 329 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
  );
  name= parse_ident(P);
  args= parse_cpp(P);
  if (only_whitespace(args))
  {
    tpl_replace(ct, "$arguments", "");
    tpl_replace(ct, "$comma", "");
  }
  else
  {
    tpl_replace(ct, "$arguments", args);
    tpl_replace(ct, "$comma", ",");
  }
  tpl_replace(ct, "$code", parse_cpp(P));
  tpl_replace(ct, "$command_name", name);
  tpl_replace(ct, "$foxclass", foxclass);
  tpl_builtin(ct);
  tpl_relocations(lib, ct);
  define_verb(name);
}
#line 363 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
static int only_whitespace(char* str)
{
  while(*str)
   if ((*str!=127 && *str>32) || *str<0) return 0;
   else str++;
  return 1;
}
#line 377 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
static void parse_common_properties(user_widget_t *uw, parser_t *P)
{
  char *kw;
  parse_lcurly(P);
  while((kw=parse_ident_or_rcurly(P)))
  {
    if (!strcmp(kw,"justification"))
    {
      add_funcprop(uw, "justify", common_justify);
      continue;
    }
    if (prop_common(&uw->properties, kw)) continue;
    p_error(P,0,"unknown common property '%s'.\n", kw);
  }
}
#line 400 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
static void parse_enumspec(user_widget_t *W, parser_t *P)
{
  char *target,*name,*value,*tvar;
  char buf[2000];
  target= parse_ident(P);
  parse_lcurly(P);
  sprintf(buf,"$%s",target);
  tvar= strdup(buf);
  while(1)
  {
    name= parse_ident_or_rcurly(P);
    if (!name) break;
    value= parse_cpp(P);
    prop_enum(&W->properties, tvar, name, value);
  }
}
#line 432 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
static void add_funcprop
  (user_widget_t *W, char *kw, void (*f)(tpl_t *,parser_t *))
{
  funcprop_t *fp;
  fp= calloc(1,sizeof(*fp));
  fp->next= W->funcprops;
  W->funcprops= fp;
  fp->keyword= kw;
  fp->func= f;
}
#line 448 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
static void common_justify(tpl_t *T, parser_t *P)
{
  char *kw;
  parse_lcurly(P);
  while((kw= parse_ident_or_rcurly(P)))
  {
    if (!strcmp(kw,"center_x"))
        tpl_replace(T, "$justify_x", "JUSTIFY_CENTER_X");
    else if (!strcmp(kw,"left"))
        tpl_replace(T, "$justify_x", "JUSTIFY_LEFT");
    else if (!strcmp(kw,"right"))
        tpl_replace(T, "$justify_x", "JUSTIFY_RIGHT");
    else if (!strcmp(kw,"hz_apart"))
        tpl_replace(T, "$justify_x", "JUSTIFY_HZ_APART");
    else if (!strcmp(kw,"center_y"))
        tpl_replace(T, "$justify_y", "JUSTIFY_CENTER_Y");
    else if (!strcmp(kw,"top"))
        tpl_replace(T, "$justify_y", "JUSTIFY_TOP");
    else if (!strcmp(kw,"bottom"))
        tpl_replace(T, "$justify_y", "JUSTIFY_BOTTOM");
    else if (!strcmp(kw,"vt_apart"))
        tpl_replace(T, "$justify_y", "JUSTIFY_VT_APART");
    else p_error(P,0, "unknown justification keyword '%s'\n", kw);
  }
}
#line 42 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
tpl_t *define_widget(parser_t *P)
{
   tpl_t *T;
   int have_commands=0;
   user_widget_t *W;
   char *kw;
   W= calloc(1,sizeof(*W));
   T= tpl_new(
#line 299 "w_user.c"
"\n"
"@library_interface\n"
"\n"
" typedef struct $widget_struct $widget_struct_t;\n"
" typedef struct \n"
" {\n"
"   <command_declarations>\n"
" } $class;\n"
"\n"
" struct $widget_struct {\n"
"   $class *cls;\n"
"   void *widget;\n"
" };\n"
"\n"
"@library_objects\n"
"\n"
"static $class $class_object = {\n"
" <command_assignments>\n"
"};\n"
"\n"
"\n"
#line 54 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
   );
   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (!strcmp(kw,"is_container"))
     {
       W->is_container= 1;
       continue;
     }
     if (!strcmp(kw,"foxclass"))
     {
       W->foxclass= parse_ident(P);
       continue;
     }
     if (!strcmp(kw,"property"))
     {
       property_t *pro= calloc(1,sizeof(*pro));
       pro->name= parse_ident(P);
       char *type= parse_ident(P);
       if (!strcmp(type,"int")) pro->kind= pro_int;
       else if (!strcmp(type,"float")) pro->kind= pro_float;
       else if (!strcmp(type,"str")) pro->kind= pro_string;
       else if (!strcmp(type,"ident")) pro->kind= pro_ident;
       else if (!strcmp(type,"flag")) pro->kind= pro_flag;
       else if (!strcmp(type,"color")) pro->kind= pro_color;
       else if (!strcmp(type,"font")) pro->kind= pro_font;
       else if (!strcmp(type,"icon")) pro->kind= pro_icon;
// FIXME: handle the enum case
       else p_error(P,0, "unknown property type '%s'\n", type);
       pro->next= W->properties;
       W->properties= pro;
       continue;
     }
     if (!strcmp(kw,"enum")) { parse_enumspec(W,P); continue; }
     if (!strcmp(kw,"name"))
     {
       if (W->widget_name) p_error(P,0,"multiple names given for the widget");
       W->widget_name= parse_ident(P);
       continue;
     }
     if (!strcmp(kw,"library_code"))
     {
        if (W->library_code)
         tpl_append(W->library_code, tpl_new(parse_cpp(P)));
        else
         W->library_code= tpl_new(parse_cpp(P));
        continue;
     }
     if (!strcmp(kw,"widget_code"))
     {
        if (W->widget_code)
          p_error(P,0,"widget code already defined for widget");
        W->widget_code= parse_cpp(P);
        continue;
     }
     if (!strcmp(kw,"signal"))
     {
        signal_t *S;
        S= malloc(sizeof(*S));
        S->name= parse_ident(P);
        S->next= W->signals;
        W->signals= S;
        continue;
     }
     if (!strcmp(kw,"command"))
       { parse_command(P,T,W->foxclass); have_commands=1; continue; }
     if (!strcmp(kw,"common_properties"))
       { parse_common_properties(W, P); continue; }
     p_error(P, NULL, "unknown keyword '%s' in define_widget",kw);
   }
   if (have_commands)
   {
     char g[2000];
     sprintf(g,"gui_%s", W->widget_name);
     tpl_replace(T, "$widget_struct", strdup(g));
     sprintf(g,"gui_%s_t", W->widget_name);
     tpl_replace(T, "$widget_struct_t", strdup(g));
     sprintf(g,"gui_%s_class_t", W->widget_name);
     tpl_replace(T, "$class", strdup(g));
     sprintf(g,"gui_%s_class", W->widget_name);
     tpl_replace(T,"$class_object", strdup(g));
     if (W->library_code) tpl_append(W->library_code, T);
     else W->library_code= T;
   }
   W->next= user_widgets;
   user_widgets= W;
   return tpl_new("/* no code for user widget class definition */\n");
}
#line 270 "/home/dodo/SFP/fxform-1.3/src/w_user.u"
/* END FILE ../build/w_user.c */
/* BEGIN FILE ../build/builtin.c */
/* CONTINUE FILE ../build/builtin.c */
/* CONTINUE FILE ../build/builtin.c */
static char builtin_code[]=
"\n"
"define_widget \n"
"{\n"
"   name button\n"
"   foxclass FXButton\n"
"   property text str\n"
"   property bgcolor color\n"
"   property font font\n"
"   property toolbar_style flag\n"
"   property icon icon\n"
"   signal click \n"
"   common_properties { layout padding objid iconpos frame justification }\n"
"\n"
"   widget_code\n"
"   {\n"
"@form_constructor\n"
"\n"
"  FXButton *$G_obj;\n"
"\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXButton($container,\n"
"      $dev($text)(\042\042),\n"
"      $dev($icon)(NULL),\n"
"      $def($click)(this) $nef($click)(NULL),\n"
"      $def($click)($G_selector) $nef($click)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
" \n"
"        $dev($frame)(FRAME_RAISED|FRAME_THICK) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"\n"
"    0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
"\n"
"  $def($bgcolor)( $G_obj->setBackColor($bgcolor); )\n"
"\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"\n"
"  $def($click)(long $G_click(FXObject *object,FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
" $def($click)\n"
" (\n"
"   FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
" )\n"
"\n"
"@form_methods\n"
"  $def($click)\n"
"  (\n"
"    long $form_class::$G_click\n"
"      (FXObject *object,FXSelector sel, void *arg)\n"
"         { $click return 1; }\n"
"  )\n"
"\n"
"@form_selector_ids        $def($click)($G_selector,)\n"
"\n"
"   }\n"
"\n"
"   command set_text { const char *text }\n"
"   {\n"
"      widget->setText(text);\n"
"   }\n"
"}\n"
"\n"
"\n"
"define_widget \n"
"{\n"
"  name check_box\n"
"  foxclass FXCheckButton\n"
"  property text str\n"
"  property plus_style flag\n"
"  property font font\n"
"  common_properties { objid layout iconpos frame padding justification }\n"
"  signal click \n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXCheckButton *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXCheckButton(\n"
"             $container, $dev($text)(\042\042),\n"
"             $def($click)(this)        $nef($click)(NULL),\n"
"             $def($click)($G_selector) $nef($click)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(FRAME_NONE) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_LEFT) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"   0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"  $def($click)(long $G_click(FXObject *object,FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click)(\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),)\n"
"\n"
"@form_methods\n"
"  $def($click)(\n"
"       long $form_class::$G_click\n"
"            (FXObject *object,FXSelector sel, void *arg)\n"
"       { $click return 1; }\n"
"  )\n"
"\n"
"@form_selector_ids\n"
"  $def($click)($G_selector,)\n"
"\n"
"  }\n"
"\n"
"  command get_value { int *R }\n"
"  {\n"
"    // I know, I`m checking against TRUE but this is necessary\n"
"    // since the library has also a MAYBE value. peh.\n"
"    if (widget->getCheck()==TRUE)\n"
"       *R= 1;\n"
"    else *R= 0;\n"
"  }\n"
"\n"
"  command set_value { int V }\n"
"  {\n"
"     if (V) widget->setCheck(TRUE); \n"
"       else widget->setCheck(FALSE);\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"   name hbox\n"
"   is_container\n"
"   common_properties { layout spacing padding packer frame }\n"
"   widget_code\n"
"   {\n"
"@form_constructor\n"
"  FXHorizontalFrame *$G_obj= new\n"
"    FXHorizontalFrame( $container,\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(0) |\n"
"        $dev($uniform_height)(0) | \n"
"        $dev($uniform_width)(0) ,\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        , $dev($hz_spacing)(DEFAULT_SPACING),\n"
"        $dev($vt_spacing)(DEFAULT_SPACING));\n"
"   }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"   name vbox\n"
"   is_container\n"
"   common_properties { layout spacing padding packer frame }\n"
"   widget_code\n"
"   {\n"
"@form_constructor\n"
"  FXVerticalFrame *$G_obj= new\n"
"    FXVerticalFrame( $container,\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(0) |\n"
"        $dev($uniform_height)(0) | \n"
"        $dev($uniform_width)(0) ,\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        , $dev($hz_spacing)(DEFAULT_SPACING),\n"
"        $dev($vt_spacing)(DEFAULT_SPACING));\n"
"   }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name label\n"
"  foxclass FXLabel\n"
"  property text str\n"
"  property icon icon\n"
"  common_properties { objid layout iconpos frame justification padding }\n"
"  property font font\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"\n"
"  FXLabel *$G_obj;\n"
"\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXLabel($container, $dev($text)(\042\042), $dev($icon)(NULL),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(0) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"        0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"  }\n"
"  command set_text { const char *text }\n"
"  {\n"
"    widget->setText(text);\n"
"  }\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name text_field\n"
"  foxclass FXTextField\n"
"  common_properties { layout objid justification frame }\n"
"  property ncols int\n"
"  enum mode { password_mode {TEXTFIELD_PASSWD}\n"
"              integer_mode  {TEXTFIELD_INTEGER}\n"
"              real_mode     {TEXTFIELD_REAL} }\n"
"  property limit_length flag\n"
"  property notify_enter_only flag\n"
"  signal change \n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXTextField *$G_obj;\n"
"  $def($objid)($objid =) $G_obj= \n"
"    new FXTextField($container,\n"
"      $dev($ncols)(40), $def($change)(this) $nef($change)(NULL),\n"
"                        $def($change)($G_selector) $nef($change)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"    $dev($frame)(FRAME_SUNKEN|FRAME_THICK) |\n"
"    $dev($justify_x)(JUSTIFY_LEFT) | JUSTIFY_CENTER_Y |\n"
"    $def($notify_enter_only)(TEXTFIELD_ENTER_ONLY|)\n"
"    $def($limit_length)(TEXTFIELD_LIMITED|)\n"
"    $dev($mode)(0),\n"
"    0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"@form_members\n"
"\n"
"$def($change)(long $G_change (FXObject *object,FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
" $def($change)\n"
" (\n"
"   FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_change),\n"
" )\n"
"\n"
"@form_methods\n"
"\n"
"  $def($change)\n"
"  (\n"
"    long $form_class::$G_change\n"
"      (FXObject *object,FXSelector sel, void *arg)\n"
"         {\n"
"           const char *text= (const char*) arg;\n"
"           $change return 1;\n"
"         }\n"
"  )\n"
"\n"
"@form_selector_ids        $def($change)($G_selector,)\n"
"  }\n"
"  \n"
"  command set_text { const char *text }\n"
"  {\n"
"     widget->setText(text);\n"
"  }\n"
"  command get_text { char **result }\n"
"  {\n"
"    FXString S= widget->getText();\n"
"    *result= strdup(S.text());\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name separator\n"
"  common_properties { layout padding }\n"
"  enum direction { vertical {V} horizontal {H} }\n"
"  enum style { groove {SEPARATOR_GROOVE}\n"
"               ridge  {SEPARATOR_RIDGE}\n"
"               line   {SEPARATOR_LINE} }\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"    new $eq($direction=V)(FXVerticalSeparator)\n"
"        $eq($direction=H)(FXHorizontalSeparator) ($container,\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($style)(SEPARATOR_GROOVE),\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(0),\n"
"  $dev($pad_right)(0),\n"
"  $dev($pad_top)(0),\n"
"  $dev($pad_bottom)(0)\n"
"\n"
"        );\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"   name radio_group\n"
"   common_properties { objid }\n"
"   foxclass FYRadioGroup\n"
"   widget_code\n"
"   {\n"
"@form_constructor\n"
"  FYRadioGroup *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) (FYRadioGroup*) malloc(sizeof(* $G_obj));\n"
"  $G_obj->target= & $objid$def(1)(_store);\n"
"  $G_obj->head= NULL;\n"
"\n"
"@form_members\n"
"  int $objid$def(1)(_store);\n"
" // FIXME: I should find some prefix and not use the suffix _store..\n"
"   }\n"
"\n"
"   library_code\n"
"   {\n"
"@library_code\n"
"\n"
" typedef struct radio_item {\n"
"   struct radio_item *next;\n"
"   FXRadioButton *button;\n"
"   int value;\n"
" } radio_item_t;\n"
"\n"
" typedef struct {\n"
"   int *target;\n"
"   radio_item_t *head;\n"
" } FYRadioGroup;\n"
"\n"
"static void radio_set_value (FYRadioGroup *G, int V)\n"
"{\n"
"  radio_item_t *T;\n"
"  for(T=G->head;T;T=T->next)\n"
"    if (T->value==V) \n"
"     T->button->setCheck(TRUE);\n"
"    else T->button->setCheck(FALSE);\n"
"  G->target[0]= V;\n"
"}\n"
"\n"
"static void radio_get_value (FYRadioGroup *G,int *R)\n"
"{\n"
"  *R= G->target[0];\n"
"}\n"
"\n"
"static void radio_append(FYRadioGroup *G, FXRadioButton *B, int V)\n"
"{\n"
"  radio_item_t *T= (radio_item_t*) malloc(sizeof(*T));\n"
"  T->button= B;\n"
"  T->value= V;\n"
"  T->next= G->head;\n"
"  G->head= T;\n"
"}\n"
"  }\n"
"\n"
"  command set_value {int V}  { radio_set_value(widget, V); }\n"
"  command get_value {int *R} { radio_get_value(widget, R); }\n"
"\n"
"}\n"
"\n"
"define_widget\n"
"{\n"
"  name radio_button\n"
"  foxclass FXRadioButton\n"
"  property default flag\n"
"  property text str\n"
"  property group ident\n"
"  property value int\n"
"  signal click\n"
"  common_properties { layout iconpos frame justification padding }\n"
"  property font font\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"\n"
"  FXRadioButton * $G_obj;\n"
"  $G_obj= new FXRadioButton($container, $dev($text)(\042\042), this, $G_selector, \n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(FRAME_NONE) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
"    radio_append( $group, $G_obj, $value );\n"
"    $def($default)( $G_obj->setCheck(TRUE); $group$def(1)(_store)= $value; )\n"
"    $nef($default)( $G_obj->setCheck(FALSE); )\n"
"\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_signal_mappings\n"
"  FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
" \n"
"\n"
"@form_methods\n"
"\n"
"long $form_class::$G_click\n"
"  (FXObject *object,FXSelector sel, void *arg)\n"
"{\n"
"  radio_set_value( $group, $value );\n"
"  $dev($click)(/* NOP */)\n"
"  // FIXME: put the on_click stuff here\n"
"  return 1;\n"
"}\n"
"\n"
"@form_members      long $G_click(FXObject *object,FXSelector sel, void *arg);\n"
"@form_selector_ids $G_selector,\n"
"\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name toggle_button\n"
"  foxclass FXToggleButton\n"
"\n"
"  common_properties { objid layout iconpos frame justification padding }\n"
"  property font font\n"
"  property bgcolor color\n"
"  signal click\n"
"  property text_off str\n"
"  property text_on str\n"
"  property icon_on icon\n"
"  property icon_off icon\n"
"  property toolbar_style flag\n"
"\n"
"  widget_code\n"
"  {\n"
"\n"
"@form_constructor\n"
"\n"
"  FXToggleButton *$G_obj;\n"
"\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXToggleButton($container,\n"
"      $dev($text_off)(\042\042), $dev($text_on)(\042\042), \n"
"      $dev($icon_off)(NULL), $dev($icon_on)(NULL),\n"
"      $def($click)(this) $nef($click)(NULL),\n"
"      $def($click)($G_selector) $nef($click)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(FRAME_RAISED|FRAME_THICK) |\n"
"        $dev($iconpos)(ICON_BEFORE_TEXT) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) \n"
"\n"
"        $def($toolbar_style)(| TOGGLEBUTTON_TOOLBAR)\n"
"        ,\n"
"        0,0,$dev($fixed_width)(0),$dev($fixed_height)(0), // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"  $def($bgcolor)( $G_obj->setBackColor($bgcolor); )\n"
"\n"
"\n"
"@form_members\n"
"  $def($click)(long $G_click(FXObject *object,FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click)\n"
"  (\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
"  )\n"
"@form_methods\n"
"  $def($click)\n"
"  (\n"
"     long $form_class::$G_click\n"
"          (FXObject *object,FXSelector sel, void *arg)\n"
"          { $click return 1; }\n"
"  )\n"
"@form_selector_ids $def($click)($G_selector,)\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name group_box\n"
"  foxclass FXGroupBox\n"
"  common_properties { layout spacing padding justification }\n"
"  property title str\n"
"  is_container\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXGroupBox *$G_obj;\n"
"  $G_obj= new FXGroupBox($container, $dev($title)(\042\042), \n"
"        GROUPBOX_TITLE_LEFT |  // FIXME: this shall be configurable\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(FRAME_LINE) |\n"
"        $dev($justify_x)(JUSTIFY_CENTER_X) |\n"
"        $dev($justify_y)(JUSTIFY_CENTER_Y) ,\n"
"     0,0,0,0, // xywh\n"
"        $dev($pad_left)(DEFAULT_SPACING),\n"
"        $dev($pad_right)(DEFAULT_SPACING),\n"
"        $dev($pad_top)(DEFAULT_SPACING),\n"
"        $dev($pad_bottom)(DEFAULT_SPACING),\n"
"        $dev($hz_spacing)(DEFAULT_SPACING),\n"
"        $dev($vt_spacing)(DEFAULT_SPACING));\n"
"   }\n"
"}\n"
"\n"
"define_widget\n"
"{\n"
"  name spinner\n"
"  foxclass FXSpinner\n"
"  common_properties { objid layout frame padding }\n"
"  property max int\n"
"  property min int\n"
"  property increment int\n"
"  property ncols int\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXSpinner *$G_obj;\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXSpinner($container, $dev($ncols)(3),\n"
"       // target and selector\n"
"       NULL, 0,\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"       // there are some options, but I dont know how to use those yet.\n"
"        $dev($frame)(0) | SPIN_NORMAL,\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
"    $def($max $min)(\n"
"      $G_obj->setRange($dev($min)(INT_MIN), $dev($max)(INT_MAX));\n"
"    )\n"
"    $def($increment)(\n"
"      $G_obj->setIncrement($increment);\n"
"    )\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"  }\n"
"  command set_value { int V } { widget->setValue(V); }\n"
"  command get_value { int *R } { *R= widget->getValue(); }\n"
"}\n"
"\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name float_spinner\n"
"  foxclass FXRealSpinner\n"
"  common_properties { objid layout frame padding }\n"
"  property max float\n"
"  property min float\n"
"  property increment float\n"
"  property ncols int\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"\n"
"  FXRealSpinner *$G_obj;\n"
"  $G_obj= $def($objid)($objid =)\n"
"    new FXRealSpinner($container, $dev($ncols)(3),\n"
"       // target and selector\n"
"       NULL, 0,\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($frame)(0) |\n"
"        $nef($max)(REALSPIN_NOMAX |)\n"
"        $nef($min)(REALSPIN_NOMIN |)\n"
"       // there are some options, but I dont know how to use those yet.\n"
"        SPIN_NORMAL,\n"
"        0,0,0,0, // x,y,w,h\n"
"  $dev($pad_left)(DEFAULT_PAD),\n"
"  $dev($pad_right)(DEFAULT_PAD),\n"
"  $dev($pad_top)(DEFAULT_PAD),\n"
"  $dev($pad_bottom)(DEFAULT_PAD)\n"
"\n"
"        );\n"
"\n"
"    $def($max $min)( $G_obj->setRange($dev($min)(0.0), $dev($max)(1.0));)\n"
"    $def($increment)( $G_obj->setIncrement($increment); )\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"  }\n"
"\n"
"  command set_value { double V } { widget->setValue(V); }\n"
"  command get_value { double *ret } { *ret= widget->getValue(); }\n"
"}\n"
"\n"
"define_widget\n"
"{\n"
"  name file_list\n"
"  foxclass FXFileList\n"
"  property show_hidden flag\n"
"  property no_parent flag\n"
"  common_properties { objid layout frame }\n"
"  signal click_file\n"
"  signal click_dir\n"
"  signal dclick_file\n"
"  signal dclick_dir\n"
"  property font font\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"\n"
"  FXFileList *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXFileList($container,\n"
"           $def($click_file $dclick_file $dclick_dir $click_dir)(this)\n"
"           $nef($click_file $dclick_file $dclick_dir $click_dir)(NULL),\n"
"           $def($click_file $dclick_file $dclick_dir $click_dir)($G_selector)\n"
"           $nef($click_file $dclick_file $dclick_dir $click_dir)(0),\n"
"             FILELIST_NO_OWN_ASSOC |\n"
"           $def($show_hidden)(FILELIST_SHOWHIDDEN |)\n"
"           $def($no_parent)(FILELIST_NO_PARENT |)\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"           $dev($frame)(FRAME_RAISED|FRAME_THICK) \n"
"           ,0,0,0,0);  // xywh\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"   $def($click_file $click_dir)\n"
"     (long $G_click(FXObject *object,FXSelector sel,void *arg);)\n"
"   $def($dclick_file $dclick_dir)\n"
"     (long $G_dclick(FXObject *object,FXSelector sel,void *arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click_file $click_dir)(\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click), )\n"
"  $def($dclick_file $dclick_dir)(\n"
"    FXMAPFUNC(SEL_DOUBLECLICKED, $form_class::$G_selector, $form_class::$G_dclick), )\n"
"\n"
"@form_methods\n"
"\n"
"  $def($click_file $click_dir)(\n"
"long $form_class::$G_click\n"
"     (FXObject *object, FXSelector sel, void *arg)\n"
"{\n"
"   FXFileList *$G_Ylist= (FXFileList*) object;\n"
"   int $G_clicked_item= (intptr_t) arg;\n"
"   FXString $G_path= $G_Ylist->getItemPathname($G_clicked_item);\n"
"   const char *clicked_path=$G_path.text(); \n"
"   FXString $G_fname= $G_Ylist->getItemFilename($G_clicked_item);\n"
"   const char *clicked_name= $G_fname.text();\n"
"   if ($G_Ylist->isItemFile($G_clicked_item))\n"
"   {\n"
"      $click_file\n"
"      return 1;\n"
"   }\n"
"   if ($G_Ylist->isItemDirectory($G_clicked_item))\n"
"   {\n"
"      $click_dir\n"
"      return 1;\n"
"   }\n"
"   return 1;\n"
"}\n"
"  )\n"
"\n"
"\n"
"  $def($dclick_file $dclick_dir)(\n"
"long $form_class::$G_dclick\n"
"     (FXObject *object, FXSelector sel, void *arg)\n"
"{\n"
"   FXFileList *$G_Ylist= (FXFileList*) object;\n"
"   int $G_clicked_item= (intptr_t) arg;\n"
"   FXString $G_path= $G_Ylist->getItemPathname($G_clicked_item);\n"
"   const char *clicked_path=$G_path.text(); \n"
"   FXString $G_fname= $G_Ylist->getItemFilename($G_clicked_item);\n"
"   const char *clicked_name= $G_fname.text();\n"
"   if ($G_Ylist->isItemFile($G_clicked_item))\n"
"   {\n"
"      $dclick_file\n"
"      return 1;\n"
"   }\n"
"   if ($G_Ylist->isItemDirectory($G_clicked_item))\n"
"   {\n"
"      $dclick_dir\n"
"      return 1;\n"
"   }\n"
"   return 1;\n"
"}\n"
"  )\n"
"\n"
"@form_selector_ids \n"
"    $def($click_file $click_dir $dclick_file $dclick_dir)($G_selector,)\n"
"  }\n"
"\n"
"  command get_current { int *Rresult, const char **Rname, int *Rtype }\n"
"  {\n"
"    FXString cur;\n"
"    int item;\n"
"\n"
"    item= widget->getCurrentItem();\n"
"    if (item<0) { *Rresult= 0; return ; }\n"
"    cur= widget->getCurrentFile();\n"
"    if (Rname) *Rname= strdup(cur.text());\n"
"    if (Rtype) *Rtype= item_type(widget,item);\n"
"    *Rresult= 1;\n"
"  }\n"
"  command set_current_file { const char *fn }\n"
"  {\n"
"    widget->setCurrentFile(fn);\n"
"  }\n"
"\n"
"  command set_directory { const char *fn } { widget->setDirectory(fn); }\n"
"  command get_directory { char **fn }\n"
"  {\n"
"    FXString cur;\n"
"    cur= widget->getDirectory();\n"
"    if (fn) *fn= strdup(cur.text());\n"
"  }\n"
"\n"
"  library_code\n"
"  {\n"
"@library_code\n"
"static int item_type(FXFileList *L, int item)\n"
"{\n"
"  if (L->isItemDirectory(item)) return \047D\047;\n"
"  return \047F\047;\n"
"}\n"
"  }\n"
"\n"
"}\n"
"\n"
"\n"
"define_widget \n"
"{\n"
"  name dir_list\n"
"  foxclass FXDirList\n"
"  property show_hidden flag\n"
"  property show_files flag\n"
"  common_properties { objid layout frame }\n"
"  property font font\n"
"  signal click\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXDirList *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXDirList($container,\n"
"           $def($click)(this) $nef($click)(NULL),\n"
"           $def($click)($G_selector) $nef($click)(0),\n"
"             TREELIST_SHOWS_LINES|TREELIST_SHOWS_BOXES|TREELIST_BROWSESELECT|\n"
"             DIRLIST_NO_OWN_ASSOC |\n"
"             $def($show_files)(DIRLIST_SHOWFILES|) \n"
"             $def($show_hidden)(DIRLIST_SHOWHIDDEN|) \n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"             $dev($frame)(FRAME_RAISED|FRAME_THICK) \n"
"           ,0,0,0,0);  // xywh\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"   $def($click)(long $G_click(FXObject *object, FXSelector sel, void *arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click)\n"
"  (\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
"  )\n"
"@form_methods\n"
"  $def($click)\n"
"  (\n"
"long $form_class::$G_click\n"
"     (FXObject *object, FXSelector sel, void *arg)\n"
"{\n"
"   $click\n"
"   return 1;\n"
"}\n"
"  )\n"
"\n"
"@form_selector_ids $def($click)($G_selector,)\n"
"  }\n"
"\n"
"  command set_current_file {const char *fn}\n"
"    { widget->setCurrentFile(fn); }\n"
"\n"
"  command set_current_dir {const char *fn}\n"
"    { widget->setDirectory(fn); }\n"
"\n"
"  command get_current {int *result, const char **name, int *type}\n"
"  {\n"
"    FXDirItem *item= (FXDirItem*) (widget->getCurrentItem());\n"
"    *result= 0;\n"
"    if (!item) return ;\n"
"    if (name) *name= strdup(widget->getItemPathname(item).text());\n"
"    if (type) *type= item_type(item);\n"
"    *result= 1;\n"
"  }\n"
"\n"
"  library_code\n"
"  {\n"
"@library_code\n"
"static int item_type(FXDirItem *item)\n"
"{\n"
"  if (item->isDirectory()) return \047D\047;\n"
"  if (item->isSymlink())   return \047L\047;\n"
"  if (item->isChardev())   return \047C\047;\n"
"  if (item->isBlockdev())  return \047B\047;\n"
"  if (item->isFifo())      return \047P\047;\n"
"  if (item->isSocket())    return \047S\047;\n"
"  return \047F\047;\n"
"}\n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name message_console\n"
"  foxclass FXText\n"
"  property text str\n"
"  common_properties { objid layout frame justification padding }\n"
"  property font font\n"
"  enum wrap { word_wrap {TEXT_WORDWRAP} no_wrap {0}\n"
"              fixed_wrap {TEXT_FIXEDWRAP} }\n"
"  property no_vertical_scroller flag\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXText *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXText(\n"
"       $container, NULL,0, // target & selector\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($wrap)(TEXT_FIXEDWRAP) |\n"
"        $nef($no_vertical_scroller)(VSCROLLER_ALWAYS) |\n"
"        TEXT_READONLY | TEXT_AUTOSCROLL |\n"
"        $dev($frame)(0),\n"
"      0,0,0,0,  // x,y,w,h\n"
"           // FIXME: these are given as number constants in the\n"
"           // FXText constructor. Nothing symbolic like DEFAULT_PAD\n"
"           // etc. is used. So, I will do the same unwillingly.\n"
"     $dev($pad_left)(3),\n"
"     $dev($pad_right)(3),\n"
"     $dev($pad_top)(2),\n"
"     $dev($pad_bottom)(2));\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"  }\n"
"\n"
"  command print {const char *fmt, ...}\n"
"  {\n"
"   int size=200; char *message; int len; char *atmp;\n"
"   va_list ap;\n"
"   message= (char*) malloc(size);\n"
"   while(1) {\n"
"     va_start(ap,fmt);\n"
"     len= vsnprintf(message,size, fmt, ap);\n"
"     va_end(ap);\n"
"     if (len<0) size*= 2;\n"
"     else if (len<size) break;\n"
"     else size= len+2;\n"
"     message= (char*) realloc(atmp= message, size);\n"
"     if (!message) {\n"
"        free(atmp);\n"
"        message= (char*) fmt;\n"
"        break;\n"
"     }\n"
"    } \n"
"    widget->appendText(message, strlen(message));\n"
"    if (message!=fmt) free(message);\n"
"     // argh, AUTOSCROLL doesn`t work yet. see\n"
"     // http://ruby.11.n6.nabble.com/TEXT-AUTOSCROLL-in-FXText-with-usage-of-FXDataTarget-td3510118.html\n"
"    widget->makePositionVisible(widget->getLength()-1);\n"
"  }\n"
"\n"
"  command append {const char *str, size_t len}\n"
"  {\n"
"    //If somebody does their own formatting, they will want to print bytes\n"
"    //directly. So, this one does that.\n"
"    widget->appendText(str, len);\n"
"     // argh, AUTOSCROLL doesn`t work yet. see\n"
"     // http://ruby.11.n6.nabble.com/TEXT-AUTOSCROLL-in-FXText-with-usage-of-FXDataTarget-td3510118.html\n"
"    widget->makePositionVisible(widget->getLength()-1);\n"
"  }\n"
"\n"
"  command clear { }\n"
"  {\n"
"    widget->removeText(0, widget->getLength()); \n"
"  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name text_viewer\n"
"  foxclass FXText\n"
"  property text str\n"
"  common_properties { objid layout frame justification padding }\n"
"  property font font\n"
"  enum wrap { fixed_wrap {TEXT_FIXEDWRAP} \n"
"              no_wrap {0}\n"
"              word_wrap {TEXT_WORDWRAP} }\n"
"  property no_vertical_scroller flag\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"  FXText *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXText(\n"
"       $container, NULL,0, // target & selector\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        $dev($wrap)(TEXT_WORDWRAP) |\n"
"        $nef($no_vertical_scroller)(VSCROLLER_ALWAYS |) \n"
"        TEXT_READONLY | \n"
"        $dev($frame)(0),\n"
"     0,0,0,0,  // x,y,w,h\n"
"             // FIXME: these are given as number constants in the\n"
"             // FXText constructor. Nothing symbolic like DEFAULT_PAD\n"
"             // etc. is used. So, I will do the same unwillingly.\n"
"     $dev($pad_left)(3),\n"
"     $dev($pad_right)(3),\n"
"     $dev($pad_top)(2),\n"
"     $dev($pad_bottom)(2));\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"  }\n"
"\n"
"  command set_text {const char *V} { widget->setText(V); }\n"
"  command clear { } { widget->removeText(0, widget->getLength());  }\n"
"}\n"
"\n"
"\n"
"define_widget\n"
"{\n"
"  name int_list\n"
"  foxclass FXList\n"
"  common_properties { layout objid }\n"
"  property font font\n"
"\n"
"  signal click\n"
"  signal dclick\n"
"  \n"
"  library_code\n"
"  {\n"
"@library_code\n"
"\n"
"class FYListItem_i : public FXListItem \n"
"{\n"
"  FXDECLARE(FYListItem_i)\n"
"protected:\n"
"  FYListItem_i() : FXListItem() { }\n"
"public:\n"
"  FYListItem_i(const FXString& text,FXIcon* ic, int idata)\n"
"   : FXListItem(text,ic,NULL)\n"
"  { data_i= idata; }\n"
"  ~FYListItem_i() { }\n"
"  int data_i;\n"
"};\n"
"FXIMPLEMENT(FYListItem_i,FXListItem,NULL,0)\n"
"\n"
"static FYListItem_i* intlist_get_selected(FXList *L)\n"
"{\n"
"   int i, N= L->getNumItems();\n"
"   for(i=0;i<N;i++)\n"
"     if (L->isItemSelected(i))\n"
"       return (FYListItem_i*) L->getItem(i);\n"
"   return NULL;\n"
"}\n"
"static int intlist_find_item(FXList *L, int key)\n"
"{\n"
"  int i;\n"
"  int N= L->getNumItems();\n"
"  for(i=0;i<N;i++)\n"
"    {\n"
"        FYListItem *it= (FYListItem*) L->getItem(i);\n"
"        if (it->data_i==key) return i;\n"
"    }\n"
"  return -1;\n"
"}\n"
"  }\n"
"\n"
"  command clear_selection { }\n"
"  {\n"
"    int i,N;\n"
"    N= widget->getNumItems();\n"
"    for(i=0;i<N;i++) widget->deselectItem(i);\n"
"  }\n"
"\n"
"  command get_selected {int *R, int *key}\n"
"  {\n"
"    FYListItem_i *item= intlist_get_selected(widget);\n"
"    if (item) { *key= item->data_i; *R= 1; }\n"
"    else        *R= 0;\n"
"  }\n"
"  \n"
"  command select_item { int key, int sel }\n"
"  {\n"
"     int i= intlist_find_item(widget, key); \n"
"     if (i==-1) return ;\n"
"     if (sel) widget->selectItem(i);\n"
"         else widget->deselectItem(i); \n"
"  }\n"
"\n"
"  command append { const char *text, int key }\n"
"    { widget->appendItem(new FYListItem_i(text, NULL,key)); }\n"
"\n"
"  command prepend { const char *text, int key }\n"
"    { widget->prependItem(new FYListItem_i(text, NULL,key)); }\n"
"\n"
"  command insert { int poskey, const char *text, int key }\n"
"  {\n"
"    int i= intlist_find_item(widget, poskey);\n"
"    if (i!=-1)\n"
"      widget->insertItem(i, new FYListItem_i(text, NULL, key));\n"
"    else\n"
"      widget->appendItem(new FYListItem_i(text, NULL, key));\n"
"  }\n"
"\n"
"  command remove { int key }\n"
"  {\n"
"    int i= intlist_find_item(widget, key);\n"
"    if (i==-1) return ;\n"
"    widget->removeItem(i);\n"
"  }\n"
"\n"
"  command clear { } { widget->clearItems(); }\n"
"\n"
"  widget_code\n"
"  {\n"
"@form_constructor\n"
"   FXList *$G_obj; \n"
"\n"
"   $G_obj= $def($objid)($objid =) new FXList($container,\n"
"        $def($click $dclick)(this) $nef($dclick $click)(NULL),\n"
"        $def($click $dclick)($G_selector) $nef($dclick $click)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"           0 ,0,0,0,0); // xywh\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"  $def($click)(long $G_click(FXObject *object,FXSelector sel,void* arg);)\n"
"  $def($dclick)(long $G_dclick(FXObject *object,FXSelector sel,void* arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click)\n"
"  (\n"
"     FXMAPFUNC(SEL_CLICKED,$form_class::$G_selector,$form_class::$G_click),\n"
"  )\n"
"  $def($dclick)\n"
"  (\n"
"     FXMAPFUNC(SEL_DOUBLECLICKED,$form_class::$G_selector,\n"
"               $form_class::$G_dclick),\n"
"  )\n"
"\n"
"@form_selector_ids\n"
"  $def($click $dclick)($G_selector,)\n"
"\n"
"@form_methods\n"
"  $def($click)\n"
"  (\n"
"long $form_class::$G_click(FXObject *object,FXSelector sel, void *arg)\n"
"    {\n"
"      FXList *$G_list= (FXList*)(object);\n"
"      int clicked_item= (intptr_t) (arg);\n"
"      FYListItem_i *item= (FYListItem_i*) ($G_list->getItem(clicked_item));\n"
"      int clicked_key = item->data_i;\n"
"      $click\n"
"      return 1;\n"
"    }\n"
"  )\n"
"  $def($dclick)\n"
"  (\n"
"long $form_class::$G_dclick(FXObject *object,FXSelector sel, void *arg)\n"
"    {\n"
"      FXList *$G_list= (FXList*)(object);\n"
"      int clicked_item= (intptr_t) (arg);\n"
"      FYListItem_i *item= (FYListItem_i*) ($G_list->getItem(clicked_item));\n"
"      int clicked_key = item->data_i;\n"
"      $dclick\n"
"      return 1;\n"
"    }\n"
"  )\n"
"  }\n"
"}\n"
"\n"
;
void parse_builtin_widgets()
{
  parser_t* P;
  extern int no_lines;
  int nn;
  nn= no_lines;
  no_lines= 1;
  P= malloc(sizeof(*P));
  P->fn= strdup("[builtin]");
  P->ipt= P->ore= builtin_code;
  while(1) {
   char *kw;
   kw= parse_ident_or_eof(P);
   if (!kw) break;
   if (!strcmp(kw,"define_widget")) { define_widget(P); continue; }
   p_error(P, NULL, "unknown keyword in builtin definitions: %s\n", kw);
  }
  free(P->fn);
  free(P);
  no_lines= nn;
}
/* END FILE ../build/builtin.c */
/* BEGIN FILE ../build/main.c */
#line 224 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
/* CONTINUE FILE ../build/main.c */
/* CONTINUE FILE ../build/main.c */
#line 261 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
typedef struct strnode { struct strnode *next; char *data; } strlist_t;
#line 265 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
static strlist_t *verbs;
#line 233 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
int no_lines;
#line 19 "main.c"
static char *strip_quotes(char *str);
static void write_file(char *fn,char *dfn, tpl_t *contents);
static void insert_verbs(tpl_t *dest);
#line 42 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
tpl_t *p_main_window(parser_t *P);
tpl_t *p_dialog(parser_t *P);
tpl_t *define_widget(parser_t *P);
#line 48 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
static void parse_file(char *fn)
{
   char *code_file=0, *header_file= 0;
   parser_t *P= parser_new(fn);
   tpl_t *form_code;
#line 99 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
   tpl_t *top_header= tpl_new(
#line 38 "main.c"
"\n"
"\n"
"#define gui_list_append(X, ...) \134\n"
" do { typeof(X)* Z= &(X); Z->cls->append_item(Z, __VA_ARGS__ ); } while(0)\n"
"\n"
"#define gui_list_get_selected(X,Y) \134\n"
" ({ typeof(X)* Z= &(X); int _K= Z->cls->get_selected(Z,Y); _K; })\n"
"\n"
" <verbs>\n"
" <library_interface>\n"
"#ifdef __cplusplus\n"
"extern \042C\042 {\n"
"#endif\n"
"\n"
"void gui_init(int *argc,char **argv);\n"
"void gui_run();\n"
"void gui_flush();\n"
"\n"
"#ifdef __cplusplus\n"
"}\n"
"#endif\n"
" <top_level_interface>\n"
"\n"
#line 103 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
   );
   tpl_t *top_code= tpl_new(
#line 65 "main.c"
"\n"
"#include <stdlib.h>\n"
"#include <stdio.h>\n"
"#include <stdarg.h>\n"
"#include <string.h>\n"
"#include <limits.h>\n"
"#include <fx.h>\n"
"#include <stdint.h>\n"
"#include <FXPNGIcon.h>\n"
"\n"
"static int app_created;\n"
"\n"
"$header_include\n"
"$header\n"
"\n"
" <library_code>\n"
" <generated_commands>\n"
" <library_objects>\n"
" <form_types>\n"
" <top_level_code>\n"
"\n"
"static FXApp *app;\n"
"\n"
"void gui_init(int *argc,char **argv)\n"
"{\n"
"  app= new FXApp(\042YAK\042, \042KUT\042);\n"
"  app->init(*argc, argv);\n"
"  app->create();\n"
"  <GUI_object_creation>\n"
"  app_created= 1;\n"
"}\n"
"\n"
"void gui_run()\n"
"{\n"
"  app->run();\n"
"}\n"
"\n"
"void gui_flush()\n"
"{\n"
"  app->runWhileEvents();\n"
"}\n"
"\n"
"$footer\n"
"\n"
#line 108 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
  );
#line 55 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
  while(1) {
   char *kw;
   kw= parse_ident_or_eof(P);
   if (!kw) break;
   if (!strcmp(kw,"header_file")) { header_file= strip_quotes(parse_strlit(P)); continue; }
   if (!strcmp(kw,"code_file")) { code_file= strip_quotes(parse_strlit(P)); continue; }
   if (!strcmp(kw,"no_lines")) { no_lines=1; continue; }
   if (!strcmp(kw,"main_window")) {
        form_code= p_main_window(P);
        tpl_relocations_known_only(top_header, form_code);
        tpl_relocations(top_code, form_code);
        continue; }
   if (!strcmp(kw,"dialog")) {
        form_code= p_dialog(P);
        tpl_relocations_known_only(top_header, form_code);
        tpl_relocations(top_code, form_code);
        continue; }
   if (!strcmp(kw,"define_widget")) { define_widget(P); continue; }
   if (!strcmp(kw,"header"))
      { tpl_replace(top_code,"$header", parse_cpp(P)); continue; }
   if (!strcmp(kw,"footer"))
      { tpl_replace(top_code,"$footer", parse_cpp(P)); continue; }
   p_error(P,NULL,"unknown keyword %s\n",kw);
  }
  if (!header_file) header_file= "gui.h";
  char buf[200];
  snprintf(buf,200, "#include \"%s\"\n", header_file);
  tpl_replace(top_code, "$header_include", strdup(buf));
  insert_verbs(top_header);
  tpl_replace(top_code, "$footer", "");
  write_file(code_file,"gui.cc", top_code);
  write_file(header_file,"gui.h", top_header);
}
#line 113 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
static char *strip_quotes(char *str)
{
  char *x;
  str= strdup(str);
  if (str[0]=='"') memmove(str, str+1, strlen(str+1)+1);
  x= strchr(str,'"');
  if (x) x[0]= 0;
  return str;
}
static void write_file(char *fn,char *dfn, tpl_t *contents)
{
  char *R;
  if (!fn) fn= dfn;
  R= tpl_to_str(contents);
  FILE *f= fopen(fn,"w");
  if (!f) exit(fprintf(stderr,"can not open %s for writing.\n", fn));
  fwrite(R, 1, strlen(R),f);
  fclose(f);
  free(R);
}
#line 282 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
static void insert_verbs(tpl_t *dest)
{
  tpl_t *T;
  strlist_t *V;
  for(V=verbs;V;V=V->next)
  {
    T= tpl_new(
#line 185 "main.c"
"\n"
"@verbs\n"
"#define $extern_name(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->$name(_Z, __VA_ARGS__);})\n"
#line 294 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
    );
    tpl_replace(T,"$name", V->data);
    char buf[2000];
    sprintf(buf,"gui_%s",V->data);
    tpl_replace(T,"$extern_name", strdup(buf));
    tpl_relocations(dest, T);
  }
}
#line 269 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
void define_verb(char *name)
{
  strlist_t *V;
  for(V=verbs;V;V=V->next)
    if (!strcmp(V->data,name)) return ;
  V= malloc(sizeof(*V));
  V->next= verbs;
  V->data= strdup(name);
  verbs= V;
}
#line 6 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
int main(int argc,char **argv)
{
  int i;
  for(i=1;i<argc;i++)
    if (!strcmp(argv[i], "-v")) {
      printf("fxforms-1.4 2015-04-30 Copyright Sukru Cinar\n"
             "This program is distributed under the GPL v3 and\n"
             "there is no warranty, even for fitness for a\n"
             "particular purpose. See the file LICENSING for\n"
             "details.\n");
      return 0;
    } else if (!strcmp(argv[i], "-h")) {
      printf("usage: fxforms inputfile\n");
      return 0;
    }
  if (argc!=2) {
     fprintf(stderr,"usage: fxform inputfile\n");
     return 1;
  }
  parse_builtin_widgets();
  parse_file(argv[1]);
  return 0;
}
#line 242 "/home/dodo/tmp/FX/fxform-1.4/src/main.u"
/* END FILE ../build/main.c */
/* BEGIN FILE ../build/parse.c */
#line 427 "/home/dodo/SFP/fxform-1.3/src/parse.u"
#include <stdarg.h>
#include <errno.h>
#include <ctype.h>
/* CONTINUE FILE ../build/parse.c */
/* CONTINUE FILE ../build/parse.c */
#line 392 "/home/dodo/SFP/fxform-1.3/src/parse.u"
typedef struct { char *name; tpl_t* (*func)(parser_t*); } widget_parser_t;
tpl_t  *parse_user_widget(parser_t *P, char *name);
#line 48 "/home/dodo/SFP/fxform-1.3/src/file.u"
typedef struct buffer {
  struct buffer *next;
  int len;
  char data[504];
} buffer_t;
#line 384 "/home/dodo/SFP/fxform-1.3/src/parse.u"
  tpl_t *p_list(parser_t*);
  tpl_t *p_tab_book(parser_t*);
#line 31 "parse.c"
static char *parser_collect(char *s,parser_t *P);
static int isspc(int a);
static int isident(int a);
static void skip_quote(parser_t *P);
static void skip_comment(parser_t *P);
static void skip_directive(parser_t *P);
static int count_lines(parser_t *P, char *lref);
static file_t *newfile(char* name);
static void do_read(FILE *D, file_t *F);
#line 23 "/home/dodo/SFP/fxform-1.3/src/parse.u"
void p_error(parser_t *P, char *lref, char *fmt, ...)
{
   int N;
   char *L;
   va_list(ap);
   if (!lref) lref= P->ipt;
   for(L=P->ore,N=1;L!=lref;L++)
     if (L[0]=='\n') N++;
   fprintf(stderr,"error at %s:%d: ", P->fn, N);
   va_start(ap,fmt);
   vfprintf(stderr, fmt, ap);
   va_end(ap);
   exit(1);
}
parser_t *parser_new(char *fn)
{
  parser_t *P;
  file_t *F;
  P= malloc(sizeof(*P));
  P->fn= fn;
  F= file_read(fn);
  if (F->error)
    exit(fprintf(stderr,"can not open %s for reading: %s\n", fn, F->error));
  P->ore= P->ipt= (char*) F->contents;
// FIXME: file_close??
  return P;
}
#line 68 "/home/dodo/SFP/fxform-1.3/src/parse.u"
char *parse_strlit(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]!='"') p_error(P,0,"a string literal was expected.\n");
  b= P->ipt;
  P->ipt++;
  while(1)
  {
    if (P->ipt[0]==0) { goto premature_eof; }
    if (P->ipt[0]=='\\') { P->ipt++; if (P->ipt[0]==0) goto premature_eof; }
    if (P->ipt[0]=='"') { P->ipt++; break; }
    P->ipt++;
  }
  return parser_collect(b, P);
premature_eof:
  p_error(P, b, "end of file within string literal");
  return 0;
}
#line 96 "/home/dodo/SFP/fxform-1.3/src/parse.u"
int parse_int(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (!isdigit(P->ipt[0]) && P->ipt[0]!='-')
     p_error(P, 0,"an integer was expected.\n");
  b= P->ipt;
  P->ipt++;
  while(isdigit(P->ipt[0])) P->ipt++;
  char *V= parser_collect(b,P);
  if (V[0]=='-' && V[1]==0)
    p_error(P, b, "malformed integer");
  int R= atoi(V);
  free(V);
  return R;
}
char* parse_flo(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (!isdigit(P->ipt[0]) && P->ipt[0]!='-')
     p_error(P, 0,"a floating point number was expected.\n");
  b= P->ipt;
  P->ipt++;
  while(isdigit(P->ipt[0])) P->ipt++;
  if (P->ipt[0]=='.') {
     P->ipt++;
     while(isdigit(P->ipt[0])) P->ipt++;
  }
  if (P->ipt[0]=='E' || P->ipt[0]=='e') {
     P->ipt++;
     if (P->ipt[0]=='-' || P->ipt[0]=='+') P->ipt++;
     if (!isdigit(P->ipt[0])) p_error(P,b,"malformed float");
     while(isdigit(P->ipt[0])) P->ipt++;
  }
  return parser_collect(b,P);
}
#line 157 "/home/dodo/SFP/fxform-1.3/src/parse.u"
char* parse_ident_or_rcurly(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]=='}') { P->ipt++; return 0; }
  if (!isalpha(P->ipt[0]) && P->ipt[0]!='_')
    p_error(P,0, "an identifier or '}' was expected.\n");
  b= P->ipt;
  while(isident(P->ipt[0]))
    P->ipt++;
  return parser_collect(b,P);
}
#line 175 "/home/dodo/SFP/fxform-1.3/src/parse.u"
char *parse_ident_or_eof(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]==0) return 0;
  if (!isalpha(P->ipt[0]) && P->ipt[0]!='_')
    p_error(P,0, "an identifier or EOF was expected.\n");
  b= P->ipt;
  while(isident(P->ipt[0]))
    P->ipt++;
  return parser_collect(b,P);
}
#line 194 "/home/dodo/SFP/fxform-1.3/src/parse.u"
char *parse_ident(parser_t *P)
{
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (!isalpha(P->ipt[0]) && P->ipt[0]!='_')
    p_error(P,0, "an identifier was expected.\n");
  b= P->ipt;
  while(isident(P->ipt[0]))
    P->ipt++;
  return parser_collect(b,P);
}
#line 228 "/home/dodo/SFP/fxform-1.3/src/parse.u"
void parse_lcurly(parser_t *P)
{
  char *ep= P->ipt;
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]!='{')
     p_error(P, ep, "'{' was expected.\n");
  P->ipt++;
}
#line 242 "/home/dodo/SFP/fxform-1.3/src/parse.u"
 char* gen_symbol()
 {
   static int last= 1;
   char buf[200];
   sprintf(buf,"VFLL%d",last++);
   return strdup(buf);
 }
#line 324 "/home/dodo/SFP/fxform-1.3/src/parse.u"
char *parse_cpp(parser_t *P)
{
// FIXME: do this properly
  extern int no_lines;
  int K;
  char *b;
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]!='{') p_error(P,0, "a '{' was expected.\n");
  b= P->ipt; P->ipt++;
  K=1;
  while(1)
    if (P->ipt[0]=='#') skip_directive(P);
    else if (P->ipt[0]=='\'' || P->ipt[0]=='"') skip_quote(P);
    else if (P->ipt[0]=='/')
       { P->ipt++; if (P->ipt[0]=='*' || P->ipt[0]=='/') skip_comment(P); }
    else if (P->ipt[0]=='{') { P->ipt++; K++; }
    else if (P->ipt[0]=='}') {
       K--; P->ipt++;
       if (K==0) {
         char lnbuf[2000];
         char *R, *C;
  if (no_lines)
           lnbuf[0]= 0;
         else
           snprintf(lnbuf,2000,"\n#line %d \"%s\" \n",
             count_lines(P,b),P->fn);
         C= parser_collect(b+1,P);
         R= malloc(strlen(C)+strlen(lnbuf)+1);
         sprintf(R, "%s%s", lnbuf, C);
         R[strlen(R)-1]= 0;
         free(C);
         return R;
       }
    } else P->ipt++;
  p_error(P,b, "unterminated code section.\n");
}
#line 398 "/home/dodo/SFP/fxform-1.3/src/parse.u"
tpl_t *parse_sub_widget(parser_t* P,char *name)
{
   tpl_t *R;
   static widget_parser_t widgets[]=
   {
      { "list", p_list },
      { "tab_book", p_tab_book },
      { 0,0 },
   };
   int i;
   R= parse_user_widget(P, name);
   if (R) return R;
   for(i=0;widgets[i].name;i++)
       if (!strcmp(widgets[i].name,name))
         return (*widgets[i].func)(P);
   return 0;
}
#line 450 "/home/dodo/SFP/fxform-1.3/src/parse.u"
char *parse_color(parser_t *P)
{
  int i;
  char buf[200];
  while(isspc(P->ipt[0])) P->ipt++;
  if (P->ipt[0]!='#') goto bad_color;
  P->ipt++;
  for(i=0;i<6;i++)
   if (!P->ipt[i] || !strchr("0123456789abcdefABCDEF",P->ipt[i]))
      goto bad_color;
  sprintf(buf,"FXRGB(0x%c%c,0x%c%c,0x%c%c)",
     P->ipt[0], P->ipt[1],
     P->ipt[2], P->ipt[3],
     P->ipt[4], P->ipt[5]);
  P->ipt+=6;
  return strdup(buf);
bad_color:
  p_error(P,0, "a color specification (#xxxxxx) was expected.\n");
  return 0;
}
#line 21 "/home/dodo/SFP/fxform-1.3/src/file.u"
file_t *file_read(char *name)
{
   file_t *F;
   FILE *D;
   F= newfile(name);
   D= fopen(name, "r");
   if (!D) {
      char buf[2000];
      sprintf(buf, "can not open file for reading: %s", strerror(errno));
      F->error= strdup(buf);
      return F;
   }
   do_read(D, F);
   fclose(D);
   return F;
}
file_t *file_read_descriptor(FILE *D,char *name)
{
   file_t *F;
   F= newfile(name);
   do_read(D, F);
   return F;
}
#line 142 "/home/dodo/SFP/fxform-1.3/src/parse.u"
static char *parser_collect(char *s,parser_t *P)
{
  int L= P->ipt-s;
  char *R= malloc(L+1);
  memcpy(R, s, L);
  R[L]= 0;
  return R;
}
#line 214 "/home/dodo/SFP/fxform-1.3/src/parse.u"
static int isspc(int a)
{
  if (a>0 && a<=32) return 1;
  if (a==127) return 1;
  return 0;
}
static int isident(int a)
{
  return isalnum(a) || a=='_';
}
#line 262 "/home/dodo/SFP/fxform-1.3/src/parse.u"
static void skip_quote(parser_t *P)
{
  int q= P->ipt[0];
  char *b= P->ipt;
  P->ipt++;
  while(P->ipt[0])
  {
     if (P->ipt[0]=='\\') { P->ipt++; if (!P->ipt[0]) break; P->ipt++;}
     if (P->ipt[0]==q) { P->ipt++; return ; }
     P->ipt++;
  }
  p_error(P, b, "unmatched quote.\n");
}
#line 282 "/home/dodo/SFP/fxform-1.3/src/parse.u"
static void skip_comment(parser_t *P)
{
  char *b;
  b= P->ipt-1;
  if (P->ipt[0]=='*') {
     P->ipt++;
     while(1)
        if (P->ipt[0]==0) break;
        else if (P->ipt[0]!='*') P->ipt++;
        else { P->ipt++; if (P->ipt[0]=='/') { P->ipt++; return ; } }
  } else {
    P->ipt++;
    while(1)
      if (P->ipt[0]==0) break;
      else if (P->ipt[0]=='\n') { P->ipt++; return; }
      else P->ipt++;
  }
  p_error(P,b, "unterminated comment.\n");
}
static void skip_directive(parser_t *P)
{
  char *b= P->ipt;
  while(1)
     if (P->ipt[0]==0) break;
     else if (P->ipt[0]=='\'' || P->ipt[0]=='"') skip_quote(P);
     else if (P->ipt[0]=='\\')
          { P->ipt++;
            if (P->ipt[0]=='\r') P->ipt++;
            if (P->ipt[0]==0) break; P->ipt++; }
     else if (P->ipt[0]=='/')
          { P->ipt++; if (P->ipt[0]=='*' || P->ipt[0]=='/') skip_comment(P); }
     else if (P->ipt[0]=='\n') { P->ipt++; return ; }
     else P->ipt++;
  p_error(P,b, "unterminated preprocessor directive.\n");
}
#line 363 "/home/dodo/SFP/fxform-1.3/src/parse.u"
static int count_lines(parser_t *P, char *lref)
{
   int N;
   char *L;
   if (!lref) lref= P->ipt;
   for(L=P->ore,N=1;L!=lref;L++)
     if (L[0]=='\n') N++;
   return N;
}
#line 56 "/home/dodo/SFP/fxform-1.3/src/file.u"
static file_t *newfile(char* name)
{
  file_t *F;
  F= calloc(1,sizeof(*F));
  F->name= strdup(name);
  return F;
}
static void do_read(FILE *D, file_t *F)
{
  buffer_t **tail;
  buffer_t *head;
  buffer_t *B,*N;
  tail= &head;
  head= 0;
  while(1) {
     int R;
     B= malloc(sizeof(*B));
     R= fread(B->data, 1, sizeof(B->data), D);
     if (R<=0) {
 free(B);
        if (feof(D)) break;
        F->error= strdup("read failed");
        goto free_all;
     }
     B->len= R;
     B->next= 0;
     *tail= B;
     tail = &B->next;
  }
  int L=0;
  for(B=head;B;B=B->next)
    L+= B->len;
  F->contents= malloc(L+1);
  L= 0;
  for(B=head;B;B=B->next) {
      memcpy(F->contents+L, B->data, B->len);
      L+= B->len;
  }
  F->contents[L]= 0;
  F->size= L;
free_all:
  for(B= head; B; B=N)
  {
     N= B->next;
     free(B);
  }
}
#line 444 "/home/dodo/SFP/fxform-1.3/src/parse.u"
/* END FILE ../build/parse.c */
/* BEGIN FILE ../build/w_dialog.c */
#line 180 "/home/dodo/SFP/fxform-1.3/src/w_dialog.u"
/* CONTINUE FILE ../build/w_dialog.c */
/* CONTINUE FILE ../build/w_dialog.c */
/* CONTINUE FILE ../build/w_dialog.c */
/* CONTINUE FILE ../build/w_dialog.c */
#line 12 "w_dialog.c"
static tpl_t *dialog_code();
#line 193 "/home/dodo/SFP/fxform-1.3/src/w_dialog.u"
#line 14 "/home/dodo/SFP/fxform-1.3/src/w_dialog.u"
tpl_t *p_dialog(parser_t *P)
{
   tpl_t *T= dialog_code();
   tpl_t *child;
   char *kw;
   static property_t *props;
   if (!props) {
      prop_common(&props, "padding"); prop_common(&props, "spacing");
      prop_common(&props, "objid");
      prop_int(&props, "pos_x"); prop_int(&props, "pos_y");
      prop_int(&props, "default_width"); prop_int(&props, "default_height");
      prop_str(&props, "title"); }
   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (handle_prop_keyword(kw, props, T, P)) continue;
     if (!strcmp(kw,"decorations"))
          { tpl_replace(T,"$decorations", p_mainwindow_decorations(P));
            continue; }
     if (!strcmp(kw,"close"))
     {
       tpl_replace(T,"$close_code", parse_cpp(P));
       continue;
     }
     if ((child=parse_sub_widget(P,kw)))
     {
        tpl_replace(child, "$container", "this");
        tpl_relocations(T, child);
        continue;
     }
   }
   tpl_replace(T, "$form_class", gen_symbol());
   tpl_builtin(T);
   return T;
}
#line 199 "/home/dodo/SFP/fxform-1.3/src/w_dialog.u"
static tpl_t *dialog_code()
{
   tpl_t *T= tpl_new(
#line 60 "w_dialog.c"
"\n"
"@top_level_interface\n"
"\n"
"typedef struct gui_$T($objid) gui_$T($objid)_t;\n"
"\n"
"typedef struct {\n"
"   int (*execute)(gui_$T($objid)_t *);\n"
"   void (*close)(gui_$T($objid)_t *);\n"
"} $G_dialog_class_t;\n"
"\n"
"struct gui_$T($objid) {\n"
"  $G_dialog_class_t *cls;\n"
"  void *self;\n"
"  <form_widget_declarations>\n"
"};\n"
"\n"
"#ifdef __cplusplus\n"
"extern \042C\042 {\n"
"#endif\n"
"\n"
"gui_$T($objid)_t *gui_c_$objid(void *owner);\n"
"\n"
"#ifdef __cplusplus\n"
"}\n"
"#endif\n"
"\n"
"@form_types\n"
"\n"
" class $form_class: public FXTopWindow\n"
" {\n"
"  FXDECLARE($form_class)\n"
" public:\n"
"  enum { ID_FIRST= FXTopWindow::ID_LAST,\n"
"         ID_SELF,\n"
"         <form_selector_ids> };\n"
"  <form_members>\n"
"  $form_class(FXWindow* own,const FXString& name,\n"
"         FXIcon *ic,FXIcon *mi,FXuint opts,\n"
"         FXint x,FXint y,FXint w,FXint h,\n"
"         FXint pl,FXint pr,FXint pt,FXint pb,\n"
"         FXint hs,FXint vs);\n"
"  virtual ~$form_class();\n"
"  $form_class() : FXTopWindow() { }\n"
"  void dialog_done(int value);\n"
"  long handle_close(FXObject *object,FXSelector sel, void *arg);\n"
" };\n"
"\n"
" FXDEFMAP($form_class) $G_map []= {\n"
"  FXMAPFUNC(SEL_CLOSE, $form_class::ID_SELF, $form_class::handle_close),\n"
"  <form_signal_mappings>\n"
" }; \n"
"\n"
" FXIMPLEMENT($form_class, FXTopWindow, $G_map, ARRAYNUMBER($G_map))\n"
" \n"
" // FIXME: the argument names must be changed so that\n"
" // we can have widgets called \047y\047 etc.\n"
" $form_class::$form_class(\n"
"         FXWindow* $G_own,const FXString& $G_name,\n"
"         FXIcon *$G_ic,FXIcon *$G_mi,FXuint $G_opts,\n"
"         FXint $G_x,FXint $G_y,FXint $G_w,FXint $G_h,\n"
"         FXint $G_pl,FXint $G_pr,FXint $G_pt,FXint $G_pb,\n"
"         FXint $G_hs,FXint $G_vs) :\n"
"               FXTopWindow($G_own,$G_name, $G_ic,$G_mi,$G_opts,\n"
"                            $G_x,$G_y,$G_w,$G_h,\n"
"                            $G_pl,$G_pr,$G_pt,$G_pb,\n"
"                            $G_hs,$G_vs)\n"
" {\n"
"   setTarget(this);\n"
"   setSelector(ID_SELF);\n"
"   <form_constructor>\n"
" }\n"
" $form_class:: ~ $form_class() { }\n"
" long $form_class::handle_close\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
" {\n"
"    $dev($close_code)(/* window closing code would go here */)\n"
"    return 0;\n"
" } \n"
" void $form_class::dialog_done(int value)\n"
" {\n"
"   FXApp::instance()->stopModal(value);\n"
" }\n"
" <form_methods>\n"
"\n"
"\n"
"@top_level_code \n"
"\n"
" gui_$T($objid)_t *gui_c_$objid(void *owner)\n"
" {\n"
"    // ffo -> fox form object\n"
"    // ifo -> interface form object \n"
"   $form_class *ffo;\n"
"   gui_$T($objid)_t * ifo;\n"
"   ffo= new $form_class( (FXWindow*) owner, $dev($title)(\042Dialog\042),\n"
"       NULL, NULL, // FIXME: icons\n"
"       $dev($decorations)(DECOR_ALL) ,\n"
"       $dev($pos_x)(0), $dev($pos_y)(0),\n"
"       $dev($default_width)(400), $dev($default_height)(400),\n"
"       $dev($pad_left)(0), $dev($pad_right)(0),\n"
"       $dev($pad_top)(0), $dev($pad_bottom)(0),\n"
"       $dev($hz_spacing)(0), $dev($vt_spacing)(0));\n"
"\n"
"   ifo= (typeof(ifo)) malloc(sizeof(*ifo));\n"
"   ifo->self= ffo;\n"
"   ifo->cls= ($G_dialog_class_t*) &gui_dialog_class;\n"
"\n"
"   <form_widget_export>\n"
"\n"
"   return ifo;\n"
" }\n"
"\n"
#line 205 "/home/dodo/SFP/fxform-1.3/src/w_dialog.u"
   );
   static int lib_done=0;
   if (!lib_done) {
     tpl_append(T, tpl_new(
#line 177 "w_dialog.c"
"\n"
"@library_code\n"
"\n"
"typedef struct {\n"
"   int (*execute)(void*);\n"
"   void (*close)(void*);\n"
"} gui_generic_dialog_class_t;\n"
"\n"
"typedef struct {\n"
"  void *cls;\n"
"  void *widget;\n"
"} gui_ptrpair_t;\n"
"\n"
"static int dialog_execute(void *form)\n"
"{\n"
"  gui_ptrpair_t *W= (gui_ptrpair_t*) form;\n"
"  FXTopWindow *win= (FXTopWindow*) W->widget;\n"
"  win->create();\n"
"  win->show(PLACEMENT_SCREEN);\n"
"  FXApp::instance()->refresh();\n"
"  return FXApp::instance()->runModalFor(win);\n"
"}\n"
"\n"
"static void dialog_close(void *form)\n"
"{\n"
"  gui_ptrpair_t *W= (gui_ptrpair_t*) form;\n"
"  FXTopWindow *win= (FXTopWindow*) W->widget;\n"
"  FXApp::instance()->stopModal(0);\n"
"  delete win;\n"
"  free(form);\n"
"}\n"
"\n"
"static gui_generic_dialog_class_t gui_dialog_class= {\n"
"   dialog_execute,\n"
"   dialog_close\n"
"};\n"
"\n"
#line 212 "/home/dodo/SFP/fxform-1.3/src/w_dialog.u"
     ));
     lib_done= 1;
     define_verb("execute");
     define_verb("close");
   }
   return T;
}
#line 196 "/home/dodo/SFP/fxform-1.3/src/w_dialog.u"
/* END FILE ../build/w_dialog.c */
/* BEGIN FILE ../build/w_list.c */
#line 347 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
/* CONTINUE FILE ../build/w_list.c */
/* CONTINUE FILE ../build/w_list.c */
/* CONTINUE FILE ../build/w_list.c */
/* CONTINUE FILE ../build/w_list.c */
#line 67 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
tpl_t *p_list(parser_t *P)
{
   char *kw;
   int KT= 'd';
   tpl_t *T= tpl_new(
#line 18 "w_list.c"
"\n"
"@form_constructor\n"
"   FXList *$G_obj; \n"
"\n"
"   $G_obj= $def($objid)($objid =) new FXList($container,\n"
"        $def($click_sig $dclick_sig)(this)\n"
"           $nef($dclick_sig $click_sig)(NULL),\n"
"        $def($click_sig $dclick_sig)($G_selector)\n"
"           $nef($dclick_sig $click_sig)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"           0\n"
"            ,0,0,0,0); // xywh\n"
"\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"  $def($objid)(FXList *$objid;)\n"
"\n"
"@form_widget_declarations\n"
"  $def($objid)($list_struct_name $objid;)\n"
"\n"
"@form_widget_export\n"
"  $def($objid)(\n"
"    ifo->$objid.cls= & $list_class_var;\n"
"    ifo->$objid.widget= ffo->$objid;\n"
"  ) \n"
"\n"
"@form_members\n"
"  $def($click_sig)(long $G_click(FXObject *object,FXSelector sel,void* arg);)\n"
"  $def($dclick_sig)(long $G_dclick(FXObject *object,FXSelector sel,void* arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click_sig)(\n"
"     FXMAPFUNC(SEL_CLICKED,$form_class::$G_selector,$form_class::$G_click),)\n"
"  $def($dclick_sig)(\n"
"     FXMAPFUNC(SEL_DOUBLECLICKED,$form_class::$G_selector,$form_class::$G_dclick),)\n"
"\n"
"@form_selector_ids\n"
"  $def($click_sig $dclick_sig)($G_selector,)\n"
"\n"
"@form_methods\n"
"$def($click_sig)(\n"
" long $form_class::$G_click\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
"    {\n"
"      FXList *$G_list= (FXList*)(object);\n"
"      int clicked_item= (intptr_t) (arg);\n"
"      FYListItem *item= (FYListItem*) ($G_list->getItem(clicked_item));\n"
"\n"
"      $def($type_is_int)(int clicked_key = item->data_i;)\n"
"      $def($type_is_str)(char* clicked_key= item->data_p; )\n"
"      $def($type_is_flo)(double clicked_key= item->data_f;)\n"
"      $def($type_is_ptr)(void* clicked_key= item->data_p;)\n"
"      $click\n"
"      return 1;\n"
"    }\n"
")\n"
"$def($dclick_sig)(\n"
" long $form_class::$G_dclick\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
"    {\n"
"      FXList *$G_list= (FXList*)(object);\n"
"      int clicked_item= (intptr_t) (arg);\n"
"      FYListItem *item= (FYListItem*) ($G_list->getItem(clicked_item));\n"
"\n"
"      $def($type_is_int)(int clicked_key = item->data_i;)\n"
"      $def($type_is_str)(char* clicked_key= item->data_p; )\n"
"      $def($type_is_flo)(double clicked_key= item->data_f;)\n"
"      $def($type_is_ptr)(void* clicked_key= item->data_p;)\n"
"      $dclick\n"
"      return 1;\n"
"    }\n"
")\n"
"\n"
#line 76 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
   );
   static property_t *props;
   if (!props)
   {
     prop_common(&props, "layout");
     prop_common(&props, "objid");
     prop_font(&props, "font");
   }
   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
    if (handle_prop_keyword(kw, props, T,P)) continue;
    if (!strcmp(kw,"key"))
    {
       char *typ= parse_ident(P);
       if (!strcmp(typ,"int")) KT= 'i';
       else if (!strcmp(typ,"double")) KT= 'F';
       else if (!strcmp(typ,"string")) KT= 's';
       else if (!strcmp(typ,"ptr")) {
          KT= 'P';
       } else
          p_error(P, 0, "unknown list key type: %s\n", typ);
       switch(KT) {
       case 'i': tpl_replace(T,"$type_is_int", "y"); break;
       case 'F': tpl_replace(T,"$type_is_flo", "y"); break;
       case 's': tpl_replace(T,"$type_is_ptr", "y"); break;
       case 'P': tpl_replace(T,"$type_is_str", "y"); break;
       }
       continue;
    }
#line 587 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
  if (!strcmp(kw,"click")) {
            tpl_replace(T, "$click", parse_cpp(P));
            tpl_replace(T, "$click_sig", "y");  continue; }
  if (!strcmp(kw,"double_click")) {
            tpl_replace(T, "$dclick", parse_cpp(P));
            tpl_replace(T, "$dclick_sig", "y");  continue; }
#line 107 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
// FIXME: do the scrollbar stuff here
   }
#line 318 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
static int common_cls= 0;
if (!common_cls) {
  tpl_append(T, tpl_new(
#line 172 "w_list.c"
"\n"
"@library_code\n"
"\n"
"class FYListItem : public FXListItem \n"
"{\n"
"  FXDECLARE(FYListItem)\n"
"protected:\n"
"  FYListItem() : FXListItem() { }\n"
"public:\n"
"  FYListItem(const FXString& text,FXIcon* ic, void *pdata)\n"
"   : FXListItem(text,ic,NULL)\n"
"  { data_p= pdata; }\n"
"  FYListItem(const FXString& text,FXIcon* ic, int idata)\n"
"   : FXListItem(text,ic,NULL)\n"
"  { data_i= idata; }\n"
"  FYListItem(const FXString& text,FXIcon* ic, double fdata)\n"
"   : FXListItem(text,ic,NULL)\n"
"  { data_f= fdata; }\n"
"  ~FYListItem() { }\n"
"// These could be in a union, but who cares about space\n"
"  int data_i;\n"
"  double data_f;\n"
"  void *data_p;\n"
"};\n"
"\n"
"\n"
"FXIMPLEMENT(FYListItem,FXListItem,NULL,0)\n"
"\n"
"\n"
"@library_code\n"
"\n"
"static void clear_selection\n"
"  (FXList *L)\n"
"{\n"
"  int i;\n"
"  int N= L->getNumItems();\n"
"  for(i=0;i<N;i++)\n"
"    L->deselectItem(i);\n"
"}\n"
"\n"
"static FYListItem* get_selected(FXList *L)\n"
"{\n"
"   int i, N= L->getNumItems();\n"
"   for(i=0;i<N;i++)\n"
"     if (L->isItemSelected(i))\n"
"       return (FYListItem*) L->getItem(i);\n"
"   return 0;\n"
"}\n"
"\n"
#line 326 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
  ));
  common_cls= 1;
}
if (KT=='i') {
  tpl_replace(T, "$list_class_var", "gui_intlist_class");
  tpl_replace(T, "$list_struct_name", "gui_intlist_t");
  static int cls=0;
  if (!cls) {
    tpl_append(T, tpl_new(
#line 233 "w_list.c"
"\n"
"@library_interface\n"
"\n"
"typedef struct gui_intlist gui_intlist_t;\n"
"\n"
"typedef struct {\n"
"   int (*get_selected)(gui_intlist_t *, int *);\n"
"   int (*select_item)(gui_intlist_t *, int, int);\n"
"   void (*clear_selection)(gui_intlist_t *);\n"
"   void (*append_item)(gui_intlist_t *, const char *,int);\n"
"   void (*prepend_item)(gui_intlist_t *, const char *,int);\n"
"   void (*insert_item)(gui_intlist_t *, int, const char *,int);\n"
"   void (*remove)(gui_intlist_t *, int);\n"
"   void (*clear)(gui_intlist_t *);\n"
"} gui_intlist_class_t;\n"
"\n"
"\n"
"struct gui_intlist {\n"
"  gui_intlist_class_t *cls;\n"
"  void *widget;\n"
"};\n"
"\n"
"@library_code\n"
"\n"
"static inline FXList* list(gui_intlist_t *IL)\n"
"{\n"
"  return (FXList*) (IL->widget);\n"
"}\n"
"\n"
"static int intlist_get_selected\n"
"   (gui_intlist_t* IL, int *ret)\n"
"{\n"
"  FYListItem *item= get_selected(list(IL));\n"
"  if (item) { *ret= item->data_i; return 1; }\n"
"  return 0;\n"
"}\n"
"\n"
"static void intlist_clear(gui_intlist_t* IL)\n"
"{\n"
"  list(IL)->clearItems();\n"
"}\n"
"\n"
"static int intlist_find_item(gui_intlist_t *IL, int key)\n"
"{\n"
"  int i;\n"
"  FXList* L= list(IL);\n"
"  int N= L->getNumItems();\n"
"  for(i=0;i<N;i++)\n"
"    {\n"
"        FYListItem *it= (FYListItem*) L->getItem(i);\n"
"        if (it->data_i==key) return i;\n"
"    }\n"
"  return -1;\n"
"}\n"
"\n"
"static int intlist_select_item\n"
"  (gui_intlist_t *IL, int key,int sel)\n"
"{\n"
"  int i= intlist_find_item(IL, key); \n"
"  if (i==-1) return 0;\n"
"  if (sel) list(IL)->selectItem(i);\n"
"  else list(IL)->deselectItem(i); \n"
"  return 1;\n"
"}\n"
"\n"
"\n"
"static void intlist_append_item\n"
"  (gui_intlist_t *IL, const char *text, int key)\n"
"{\n"
"  list(IL)->appendItem(new FYListItem(text, NULL,key));\n"
"}\n"
"\n"
"static void intlist_prepend_item\n"
"  (gui_intlist_t *IL, const char *text, int key)\n"
"{\n"
"  list(IL)->prependItem(new FYListItem(text, NULL,key));\n"
"}\n"
"\n"
"static void intlist_insert_item\n"
"  (gui_intlist_t *IL, int poskey, const char *text, int key)\n"
"{\n"
"  int i= intlist_find_item(IL, poskey);\n"
"  if (i!=-1)\n"
"    list(IL)->insertItem(i, new FYListItem(text, NULL, key));\n"
"  else\n"
"    list(IL)->appendItem(new FYListItem(text, NULL, key));\n"
"}\n"
"\n"
"static void intlist_clear_selection(gui_intlist_t *IL)\n"
"{\n"
"  clear_selection(list(IL));\n"
"}\n"
"\n"
"static void intlist_remove_item(gui_intlist_t *IL, int key)\n"
"{\n"
"  int i= intlist_find_item(IL, key);\n"
"  if (i==-1) return ;\n"
"  list(IL)->removeItem(i);\n"
"}\n"
"\n"
"static gui_intlist_class_t gui_intlist_class=\n"
"{\n"
"   intlist_get_selected,\n"
"   intlist_select_item,\n"
"   intlist_clear_selection,\n"
"   intlist_append_item,\n"
"   intlist_prepend_item,\n"
"   intlist_insert_item,\n"
"   intlist_remove_item,\n"
"   intlist_clear,\n"
"};\n"
"\n"
#line 339 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
    ));
    cls= 1;
  }
}
#line 440 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
// d stands for "displayed string"
if (KT=='d') {
  tpl_replace(T, "$list_class_var", "gui_sslist_class");
  tpl_replace(T, "$list_struct_name", "gui_sslist_t");
  static int cls=0;
  if (!cls) {
    tpl_append(T, tpl_new(
#line 359 "w_list.c"
"\n"
"@library_interface\n"
"\n"
"typedef struct gui_sslist gui_sslist_t;\n"
"\n"
"typedef struct {\n"
"   int (*get_selected)(gui_sslist_t *, char**);\n"
"   void (*append_item)(gui_sslist_t *, const char *);\n"
"   void (*prepend_item)(gui_sslist_t *, const char *);\n"
"   void (*insert_item)(gui_sslist_t *, const char* , const char *);\n"
"} gui_sslist_class_t;\n"
"\n"
"struct gui_sslist {\n"
"  gui_sslist_class_t *cls;\n"
"  void *widget;\n"
"};\n"
"\n"
"\n"
"@library_code\n"
"\n"
"static FXList* list(gui_sslist_t *SL)\n"
"{\n"
"  return (FXList*) SL->widget;\n"
"}\n"
"\n"
"static int sslist_get_selected(gui_sslist_t *SL, char **ret)\n"
"{\n"
"  FYListItem *item= get_selected(list(SL));\n"
"  if (!item) return 0;\n"
"  *ret= (char*) item->data_p;\n"
"  return 1;\n"
"}\n"
"\n"
"static int sslist_find_item(gui_sslist_t *SL,const char *key)\n"
"{\n"
"  FXList *L= list(SL);\n"
"  int i, N= L->getNumItems();\n"
"  for(i=0;i<N;i++) {\n"
"    FYListItem* item= (FYListItem*) L->getItem(i);\n"
"    if (!strcmp((char*) item->data_p, key)) return i;\n"
"  }\n"
"  return -1;\n"
"}\n"
"\n"
"static void sslist_append_item(gui_sslist_t *SL, const char *value)\n"
"{\n"
"  list(SL)->appendItem(new FYListItem(value, NULL, (void*) value));\n"
"}\n"
"static void sslist_prepend_item(gui_sslist_t *SL, const char *value)\n"
"{\n"
"  list(SL)->prependItem(new FYListItem(value, NULL, (void*) value));\n"
"}\n"
"static void sslist_insert_item\n"
"      (gui_sslist_t *SL, const char *poskey, const char *value)\n"
"{\n"
"  int i= sslist_find_item(SL, poskey);\n"
"  if (i==-1) sslist_append_item(SL, value);\n"
"  else list(SL)->insertItem(i,new FYListItem(value, NULL, (void*) value));\n"
"}\n"
"\n"
"static gui_sslist_class_t gui_sslist_class= {\n"
"  sslist_get_selected,\n"
"  sslist_append_item,\n"
"  sslist_prepend_item,\n"
"  sslist_insert_item\n"
"};\n"
"\n"
#line 450 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
    ));
    cls= 1;
  }
}
#line 558 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
if (KT=='s') {
  tpl_replace(T, "$list_class_var", "gui_slist_class");
  tpl_replace(T, "$list_struct_name", "gui_slist_t");
  static int cls=0;
  if (!cls) {
    tpl_append(T, tpl_new(
#line 441 "w_list.c"
"\n"
"@library_interface\n"
"\n"
"typedef struct gui_slist gui_slist_t;\n"
"\n"
"typedef struct {\n"
"   int  (*get_selected)(gui_slist_t *, char**);\n"
"   void (*append_item)(gui_slist_t *, const char *,const char*);\n"
"   void (*prepend_item)(gui_slist_t *, const char *,const char*);\n"
"   void (*insert_item)(gui_slist_t *, const char* , const char *,const char*);\n"
"   void (*remove)(gui_slist_t *,const char *);\n"
"} gui_slist_class_t;\n"
"\n"
"struct gui_slist {\n"
"  gui_slist_class_t *cls;\n"
"  void *widget;\n"
"};\n"
"\n"
"@library_code\n"
"\n"
"static FXList* list(gui_slist_t *SL)\n"
"{\n"
"  return (FXList*) SL->widget;\n"
"}\n"
"\n"
"static int slist_get_selected(gui_slist_t *SL, char **ret)\n"
"{\n"
"  FYListItem *item= get_selected(list(SL));\n"
"  if (!item) return 0;\n"
"  *ret= (char*) item->data_p;\n"
"  return 1;\n"
"}\n"
"\n"
"static int slist_find_item(gui_slist_t *SL,const char *key)\n"
"{\n"
"  FXList *L= list(SL);\n"
"  int i, N= L->getNumItems();\n"
"  for(i=0;i<N;i++) {\n"
"    FYListItem* item= (FYListItem*) L->getItem(i);\n"
"    if (!strcmp((char*) item->data_p, key)) return i;\n"
"  }\n"
"  return -1;\n"
"}\n"
"\n"
"static void slist_append_item\n"
"    (gui_slist_t *SL, const char *value, const char *data)\n"
"{\n"
"  list(SL)->appendItem(new FYListItem(value, NULL, (void*) data));\n"
"}\n"
"\n"
"static void slist_prepend_item\n"
"   (gui_slist_t *SL, const char *value,const char *data)\n"
"{\n"
"  list(SL)->prependItem(new FYListItem(value, NULL, (void*) data));\n"
"}\n"
"\n"
"static void slist_insert_item\n"
"      (gui_slist_t *SL, const char *poskey,\n"
"       const char *value,const char *data)\n"
"{\n"
"  int i= slist_find_item(SL, poskey);\n"
"  if (i==-1) slist_append_item(SL, value,data);\n"
"  else list(SL)->insertItem(i,new FYListItem(value, NULL, (void*) data));\n"
"}\n"
"\n"
"static void slist_remove_item\n"
"      (gui_slist_t *SL, const char *key)\n"
"{\n"
"  int i= slist_find_item(SL, key);\n"
"  if (i!=-1)\n"
"     list(SL)->removeItem(i);\n"
"}\n"
"\n"
"static gui_slist_class_t gui_slist_class= {\n"
"  slist_get_selected,\n"
"  slist_append_item,\n"
"  slist_prepend_item,\n"
"  slist_insert_item,\n"
"  slist_remove_item,\n"
"};\n"
"\n"
#line 569 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
    ));
    cls= 1;
  }
}
#line 110 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
   tpl_builtin(T);
   define_verb("select_item");
   define_verb("append");
   define_verb("remove");
   define_verb("clear_selection");
   return T;
}
#line 357 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
/* END FILE ../build/w_list.c */
/* BEGIN FILE ../build/w_main_window.c */
#line 183 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
/* CONTINUE FILE ../build/w_main_window.c */
/* CONTINUE FILE ../build/w_main_window.c */
/* CONTINUE FILE ../build/w_main_window.c */
/* CONTINUE FILE ../build/w_main_window.c */
#line 13 "w_main_window.c"
static void parse_menu_item(parser_t *P,tpl_t *T);
static void parse_menu(parser_t *P,tpl_t *T);
static void parse_menubar(parser_t *P, tpl_t *T);
#line 280 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
static void parse_menu_item(parser_t *P,tpl_t *T)
{
   char *kw;
   parse_lcurly(P);
   tpl_t *ST;
   ST= tpl_new(
#line 26 "w_main_window.c"
"@menu_items\n"
"   new FXMenuCommand($menupane,$dev($title)(\042Item\042),NULL,\n"
"      $def($click)(this) $nef($click)(NULL),\n"
"      $def($click)($G_selector) $nef($click)(0));\n"
"\n"
"@form_selector_ids\n"
"   $def($click)($G_selector,)\n"
"@form_methods\n"
"   $def($click)(\n"
"     long $form_class::$G_click\n"
"          (FXObject *object,FXSelector sel, void *arg)\n"
"          { $click return 1; }\n"
"   )\n"
"@form_members\n"
"   $def($click)(long $G_click(FXObject *object,FXSelector sel, void *arg);)\n"
"@form_signal_mappings\n"
"  $def($click)\n"
"  (\n"
"    FXMAPFUNC(SEL_COMMAND, $form_class::$G_selector, $form_class::$G_click),\n"
"  )\n"
#line 310 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
  );
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (!strcmp(kw,"title"))
     {
       tpl_replace(ST, "$title", parse_strlit(P));
       continue;
     }
     if (!strcmp(kw,"click"))
     {
       tpl_replace(ST, "$click", parse_cpp(P));
       continue;
     }
     p_error(P, NULL,"unknown keyword %s in menu item",kw);
   }
   tpl_builtin(ST);
   tpl_relocations(T,ST);
}
static void parse_menu(parser_t *P,tpl_t *T)
{
   char *kw;
   parse_lcurly(P);
   tpl_t *ST;
   ST= tpl_new(
#line 73 "w_main_window.c"
"@form_constructor\n"
"   FXMenuPane *$menupane= new FXMenuPane(this); \n"
" <menu_items>\n"
"   new FXMenuTitle($menubar, $dev($title)(\042Menu\042),NULL, $menupane);\n"
#line 341 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
  );
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (!strcmp(kw,"title"))
     {
       tpl_replace(ST, "$title", parse_strlit(P));
       continue;
     }
     if (!strcmp(kw,"item"))
     {
       parse_menu_item(P,ST);
       continue;
     }
     p_error(P, NULL,"unknown keyword %s in menubar",kw);
   }
   tpl_replace(ST, "$menupane", gen_symbol());
   tpl_builtin(ST);
   tpl_relocations(T,ST);
}
static void parse_menubar(parser_t *P, tpl_t *T)
{
   char *kw;
   tpl_t *ST;
   parse_lcurly(P);
   ST= tpl_new(
#line 105 "w_main_window.c"
"@form_constructor\n"
"   FXMenuBar *$menubar= new FXMenuBar(this, LAYOUT_SIDE_TOP|LAYOUT_FILL_X);\n"
#line 371 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
   );
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (!strcmp(kw,"menu"))
     {
       parse_menu(P,ST);
       continue;
     }
     p_error(P, NULL,"unknown keyword %s in menubar",kw);
   }
   tpl_replace(ST, "$menubar", gen_symbol());
   tpl_builtin(ST);
   tpl_relocations(T,ST);
}
#line 8 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
tpl_t *p_main_window(parser_t *P)
{
   char *form_class_name= 0;
   char *kw;
   tpl_t *T= tpl_new(
#line 130 "w_main_window.c"
"\n"
"@top_level_interface\n"
"\n"
"typedef struct {\n"
"  void *self;\n"
"  <form_widget_declarations>\n"
"} gui_$T($objid)_t;\n"
"\n"
"#ifdef __cplusplus\n"
"extern \042C\042 {\n"
"#endif\n"
"\n"
"gui_$T($objid)_t *gui_c_$objid();\n"
"\n"
"#ifdef __cplusplus\n"
"}\n"
"#endif\n"
"\n"
"@form_types\n"
"\n"
" class $form_class: public FXMainWindow\n"
" {\n"
"  FXDECLARE($form_class)\n"
" public:\n"
"  enum { ID_FIRST= FXMainWindow::ID_LAST,\n"
"         ID_SELF,\n"
"         <form_selector_ids> };\n"
"  <form_members>\n"
"  $form_class(FXApp* a,const FXString& name,\n"
"         FXIcon *ic,FXIcon *mi,FXuint opts,\n"
"         FXint x,FXint y,FXint w,FXint h,\n"
"         FXint pl,FXint pr,FXint pt,FXint pb,\n"
"         FXint hs,FXint vs);\n"
"  virtual ~$form_class();\n"
"  $form_class() : FXMainWindow() { }\n"
"  long handle_close(FXObject *object,FXSelector sel, void *arg);\n"
" };\n"
"\n"
" FXDEFMAP($form_class) $G_map []= {\n"
"  FXMAPFUNC(SEL_CLOSE, $form_class::ID_SELF, $form_class::handle_close),\n"
"  <form_signal_mappings>\n"
" }; \n"
"\n"
" FXIMPLEMENT($form_class, FXMainWindow, $G_map, ARRAYNUMBER($G_map))\n"
"\n"
" // FIXME: the argument names must be changed so that\n"
" // we can have widgets called \047y\047 etc.\n"
" $form_class::$form_class(\n"
"         FXApp* a,const FXString& name,\n"
"         FXIcon *ic,FXIcon *mi,FXuint opts,\n"
"         FXint x,FXint y,FXint w,FXint h,\n"
"         FXint pl,FXint pr,FXint pt,FXint pb,\n"
"         FXint hs,FXint vs) :\n"
"               FXMainWindow(a,name, ic,mi,opts,\n"
"                            x,y,w,h, pl,pr,pt,pb, hs,vs)\n"
"\n"
" {\n"
"   setTarget(this);\n"
"   setSelector(ID_SELF);\n"
"   <form_constructor>\n"
" }\n"
" $form_class:: ~ $form_class() { }\n"
" long $form_class::handle_close\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
" {\n"
"    $dev($close_code)(/* window closing code would go here */)\n"
"    return 0;\n"
" } \n"
" <form_methods>\n"
"\n"
"\n"
"@top_level_code \n"
"\n"
" gui_$T($objid)_t *gui_c_$objid()\n"
" {\n"
"    // ffo -> fox form object\n"
"    // ifo -> interface form object \n"
"   $form_class *ffo;\n"
"   gui_$T($objid)_t * ifo;\n"
"   ffo= new $form_class(\n"
"       FXApp::instance(),\n"
"       $dev($title)(\042Main Window\042),\n"
"       NULL, NULL, // FIXME: icons\n"
"       $dev($decorations)(DECOR_ALL) ,\n"
"       $dev($pos_x)(0), $dev($pos_y)(0),\n"
"       $dev($default_width)(400), $dev($default_height)(400),\n"
"       $dev($pad_left)(0), $dev($pad_right)(0),\n"
"       $dev($pad_top)(0), $dev($pad_bottom)(0),\n"
"       $dev($hz_spacing)(0), $dev($vt_spacing)(0));\n"
"   // If the application has not been created, this will done\n"
"   // when the application gets created. Otherwise, we have\n"
"   // to explicitly do this.\n"
"   if (app_created) \n"
"     ffo->create();\n"
"   \n"
"   ffo->show(PLACEMENT_SCREEN);\n"
"\n"
"   ifo= (typeof(ifo)) malloc(sizeof(*ifo));\n"
"   ifo->self= ffo;\n"
"   <form_widget_export>\n"
"   return ifo;\n"
" }\n"
"\n"
"\n"
#line 17 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
   );
   static property_t *props;
   if (!props)
   {
     prop_common(&props, "padding");
     prop_common(&props, "spacing");
     prop_common(&props, "objid");
     prop_str(&props, "title");
     prop_int(&props, "pos_x"); prop_int(&props, "pos_y");
     prop_int(&props, "default_width"); prop_int(&props, "default_height");
   }
   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (handle_prop_keyword(kw,props, T,P)) continue;
     if (!strcmp(kw,"decorations"))
     {
       tpl_replace(T,"decorations", p_mainwindow_decorations(P));
       continue;
     }
     if (!strcmp(kw,"class_name"))
        { form_class_name= parse_ident(P); continue; }
     if (!strcmp(kw,"close"))
        { tpl_replace(T,"$close_code", parse_cpp(P)); continue; }
     if (!strcmp(kw,"menubar"))
        { parse_menubar(P, T); continue; }
#line 214 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
 if (!strcmp(kw, "signal")) {
   char  *id,*selector,*code;
   selector= parse_ident(P);
   id= parse_ident(P);
   code= parse_cpp(P);
   tpl_t *ST= tpl_new(
#line 270 "w_main_window.c"
"\n"
" @form_members\n"
"  long $G_name(FXObject *object,FXSelector sel, void *arg);\n"
" @form_signal_mappings\n"
"  FXMAPFUNC($SELECTOR, $form_class::$ID, $form_class::$G_name),\n"
" @form_methods\n"
"  long $form_class::$G_name(FXObject *object,FXSelector sel, void *arg)\n"
"  {\n"
"    $code\n"
"  }\n"
#line 224 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
   );
   tpl_replace(ST, "$ID", id);
   tpl_replace(ST, "$SELECTOR", selector);
   tpl_replace(ST, "$code", code);
   tpl_builtin(ST);
   tpl_relocations(T, ST);
   continue;
 }
#line 248 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
  if (!strcmp(kw,"selector"))
  {
     tpl_t *trivial= tpl_new("\n@form_selector_ids\n$ID,\n");
     tpl_replace(trivial, "$ID", parse_ident(P));
     tpl_relocations(T, trivial);
     continue;
  }
  if (!strcmp(kw,"constructor"))
  {
     tpl_t *trivial= tpl_new("\n@form_constructor\n$code\n");
     tpl_replace(trivial, "$code", parse_cpp(P));
     tpl_relocations(T, trivial);
     continue;
  }
  if (!strcmp(kw,"members"))
  {
     tpl_t *trivial= tpl_new("\n@form_members\n$code\n");
     tpl_replace(trivial, "$code", parse_cpp(P));
     tpl_relocations(T, trivial);
     continue;
  }
  if (!strcmp(kw,"destructor"))
  {
     tpl_t *trivial= tpl_new("\n@form_destructor\n$code\n");
     tpl_replace(trivial, "$code", parse_cpp(P));
     tpl_relocations(T, trivial);
     continue;
  }
#line 172 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
  { tpl_t *C;
    C= parse_sub_widget(P, kw);
    if (!C) p_error(P, 0, "unknown keyword '%s'.\n",kw);
    tpl_replace(C, "$container", "this");
    tpl_relocations(T, C);
    continue; }
#line 45 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
     p_error(P, NULL,"unknown keyword %s in main window declaration",kw);
   }
   if (form_class_name)
     tpl_replace(T, "$form_class", form_class_name);
   else
     tpl_replace(T, "$form_class", gen_symbol());
   tpl_builtin(T);
   return T;
}
#line 199 "/home/dodo/tmp/FX/fxform-1.4/src/w_main_window.u"
/* END FILE ../build/w_main_window.c */
/* BEGIN FILE ../build/w_tabbook.c */
#line 109 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"
/* CONTINUE FILE ../build/w_tabbook.c */
/* CONTINUE FILE ../build/w_tabbook.c */
/* CONTINUE FILE ../build/w_tabbook.c */
/* CONTINUE FILE ../build/w_tabbook.c */
#line 19 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"
static tpl_t *p_tab(parser_t *P)
{
   tpl_t *child;
   static property_t *props;
   char *kw;
   int child_widget= 0;
   tpl_t *T= tpl_new(
#line 21 "w_tabbook.c"
"@form_constructor\n"
"  FXTabItem *$G_obj;\n"
"  $G_obj= new FXTabItem($container, $dev($title)(\042\042), NULL);\n"
"  // FIXME: do the fonts here\n"
#line 34 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"
   );
// FIXME: do the icon stuff here as well
   if (!props) { prop_str(&props, "title"); }
   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (handle_prop_keyword(kw,props, T,P)) continue;
     child= parse_sub_widget(P, kw);
     if (child)
     {
       if (child_widget) p_error(P,0, "only one child widget is "
                                 "permitted within a tab.\n");
       child_widget= 1;
       tpl_relocations(T, child);
       continue;
     }
     p_error(P,NULL,"unknown keyword %s\n", kw);
   }
   tpl_builtin(T);
   return T;
}
#line 65 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"
tpl_t *p_tab_book(parser_t *P)
{
   char* kw;
   tpl_t *T= tpl_new(
#line 56 "w_tabbook.c"
"@form_constructor\n"
"  FXTabBook *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXTabBook($container,\n"
"           NULL, 0, // selector stuff\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        0, // FIXME: do the tab-side stuff.\n"
"        0,0,0,0, // xywh\n"
"  $dev($pad_left)(DEFAULT_SPACING),\n"
"  $dev($pad_right)(DEFAULT_SPACING),\n"
"  $dev($pad_top)(DEFAULT_SPACING),\n"
"  $dev($pad_bottom)(DEFAULT_SPACING)\n"
"\n"
"        );\n"
"   <form_constructor>\n"
"\n"
"@form_members $def($objid)(FXTabBook *$objid;)\n"
#line 84 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"
   );
   static property_t *props;
   if (!props) { prop_common(&props, "layout");
                 prop_common(&props, "objid"); }
   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (handle_prop_keyword(kw,props, T, P)) continue;
     if (!strcmp(kw,"tab"))
     {
        tpl_t *child;
        child= p_tab(P);
        tpl_replace_var(child, "$container", "$G_obj");
        tpl_relocations(T, child);
        continue;
     }
   }
   tpl_builtin(T);
   return T;
}
#line 119 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"
/* END FILE ../build/w_tabbook.c */
/* BEGIN FILE ../build/template.c */
/* Generated by re2c 0.13.5 on Mon Aug 11 23:08:36 2014 */
#line 1 "template.cr"
/* CONTINUE FILE ../build/template.c */
enum tok_kind { tok_dummy, tok_text, tok_var, tok_reloc,
                tok_paren, tok_target };
static char *tok_names[]= { "dummy", "text", "var", "reloc",
                            "paren", "target" };
typedef struct token {
  struct token *prev, *next, *chpar;
  enum tok_kind kind;
  char *data;
} token_t;
struct tpl { token_t tokens; };
 typedef struct { token_t *dest; unsigned char* cursor; } state_t;
typedef struct {
  int selts;
  int tos;
  state_t *elts;
} lexerstack_t;
lexerstack_t *lexerstack_new(int initial);
int lexerstack_empty(lexerstack_t *S);
void lexerstack_push(lexerstack_t *S, state_t V);
int lexerstack_pop(lexerstack_t *S, state_t* R);
lexerstack_t *lexerstack_new(int initial)
{
  lexerstack_t *S;
  S= malloc(sizeof(*S));
  S->selts= initial;
  S->tos= -1;
  S->elts= malloc(sizeof(state_t)*S->selts);
  return S;
}
int lexerstack_empty(lexerstack_t *S)
  { return S->tos==-1; }
void lexerstack_push(lexerstack_t *S, state_t V)
{
  if(S->tos==S->selts-1) {
    S->selts+= S->selts/2;
    S->elts= realloc(S->elts, sizeof(state_t)*S->selts);
  }
  S->elts[++S->tos]= V;
}
int lexerstack_pop(lexerstack_t *S, state_t* R)
{
  if (S->tos==-1) return 0;
  if (R) *R= S->elts[S->tos];
  S->tos--;
  return 1;
}
#define REVERSE_VIDEO "\033[7m"
#define NORMAL_VIDEO  "\033[0m"
#define FOR_TOKENS(TPL, TOK)                            do {                                                   TOK= TPL->tokens.next;                                while(1) {                                              while(TOK && TOK->kind==tok_dummy) {                    TOK= TOK->chpar;                                      if (!TOK) break;                                      TOK= TOK->next;                                     }                                                     if (!TOK) break;
#define END_FOR(TOK)                                       if (TOK->kind==tok_paren) TOK=TOK->chpar;             TOK=TOK->next;                                      }                                                    }                                                     while(0);
typedef struct {
  char *key, *value;
} strpair_t;
typedef struct strtree_s strtree_t;
strtree_t *strtree_new();
int strtree_find(strtree_t *T, char*  key,  strpair_t *value);
int strtree_insert(strtree_t *T,  strpair_t data) ;
int strtree_remove(strtree_t *T, char*  key,  strpair_t *value);
int strtree_destroy(strtree_t *T, strpair_t *value);
typedef struct strtree_node {
   struct strtree_node *left, *right,*parent;
   int height;
    strpair_t data;
} strtree_node_t;
struct strtree_s {
  strtree_node_t *root;
};
strtree_node_t *strtree_find_node(strtree_t *T, char*  key2);
static void strtree_rebalance(strtree_t *T, strtree_node_t *N);
static void strtree_rotate_left(strtree_t *T, strtree_node_t *A);
static void strtree_rotate_left_twolevels(strtree_t *T, strtree_node_t *A);
static void strtree_rotate_right(strtree_t *T, strtree_node_t *A);
static void strtree_rotate_right_twolevels(strtree_t *T, strtree_node_t *A);
static int strtree_right_heavy(strtree_node_t *A);
static int strtree_left_heavy(strtree_node_t *A);
static void strtree_remove_node(strtree_t *T, strtree_node_t *N);
static strtree_node_t *strtree_remove_max(strtree_t *T,strtree_node_t *N);
static strtree_node_t *strtree_remove_min(strtree_t *T,strtree_node_t *N);
static void strtree_calculate_height(strtree_node_t *N);
static void strtree_replace_child_in_parent
    (strtree_t* T, strtree_node_t* old, strtree_node_t* nw);
static void strtree_set_left_child(strtree_node_t *P, strtree_node_t *N);
static void strtree_set_right_child(strtree_node_t *P, strtree_node_t *N);
static int strtree_height(strtree_node_t * A);
strtree_node_t *strtree_find_node(strtree_t *T, char*  key2)
{
   strtree_node_t *node;
   node= T->root;
   while(node) {
     int result;
      strpair_t data;
     char*  key; char*  key1;
     data= node->data;
     {  key= data.key;  }
     key1= key;
     {  result= strcmp(key1, key2);   }
     if (result==0) return node;
     else if (result<0) node= node->left;
     else node= node->right;
   }
   return 0;
}
static void strtree_rebalance(strtree_t *T, strtree_node_t *N)
{
  int u;
  strtree_node_t *P;
  strtree_calculate_height(N);
  u = strtree_height(N->left)-strtree_height(N->right);
  P = N->parent;
  if (u < -1) {
      if (strtree_left_heavy(N->right)) strtree_rotate_left_twolevels(T, N);
      else strtree_rotate_left(T, N);
  } else if (u > 1) {
      if (strtree_right_heavy(N->left)) strtree_rotate_right_twolevels(T, N);
      else strtree_rotate_right(T, N);
  }
  if (P) strtree_rebalance(T, P);
}
static void strtree_rotate_left(strtree_t *T, strtree_node_t *A)
{
  strtree_node_t *B;
  B = A->right;
  strtree_set_right_child(A, B->left);
  strtree_replace_child_in_parent(T, A, B);
  strtree_set_left_child(B, A);
  strtree_calculate_height(A);
  strtree_calculate_height(B);
}
static void strtree_rotate_left_twolevels(strtree_t *T, strtree_node_t *A)
{
  strtree_node_t *B, *C;
  B = A->right; C = B->left;
  strtree_set_right_child(A, C->left);
  strtree_set_left_child(B, C->right);
  strtree_replace_child_in_parent(T, A, C);
  strtree_set_left_child(C, A);
  strtree_set_right_child(C, B);
  strtree_calculate_height(A);
  strtree_calculate_height(B);
  strtree_calculate_height(C);
}
static void strtree_rotate_right(strtree_t *T, strtree_node_t *A)
{
  strtree_node_t *B;
  B = A->left;
  A->left = B->right;
  if (A->left) A->left->parent = A;
  B->parent = A->parent;
  strtree_replace_child_in_parent(T, A, B);
  B->right = A;
  A->parent = B;
  strtree_calculate_height(A);
  strtree_calculate_height(B);
}
static void strtree_rotate_right_twolevels(strtree_t *T, strtree_node_t *A)
{
  strtree_node_t *B, *C;
  B = A->left;
  C = B->right;
/* we know that B and C are non-null since
     A was left heavy and B was right heavy */
  A->left = C->right;
  if (A->left) A->left->parent = A;
  B->right = C->left;
  if (B->right) B->right->parent = B;
  C->parent = A->parent;
  strtree_replace_child_in_parent(T, A, C);
  C->left = B;
  C->right = A;
  A->parent = C;
  B->parent = C;
  strtree_calculate_height(A);
  strtree_calculate_height(B);
  strtree_calculate_height(C);
}
static int strtree_right_heavy(strtree_node_t *A)
{
  if (!A) return 0;
  return (strtree_height(A->right)-strtree_height(A->left)) > 0;
}
static int strtree_left_heavy(strtree_node_t *A)
{
  if (!A) return 0;
  return (strtree_height(A->right)-strtree_height(A->left)) < 0;
}
static void strtree_remove_node(strtree_t *T, strtree_node_t *N)
{
   strtree_node_t *Z;
   if (!N->left && !N->right) {
     strtree_replace_child_in_parent(T, N, 0);
     if (N->parent) strtree_rebalance(T,N->parent);
   } else {
     if (strtree_left_heavy(N)) Z= strtree_remove_max(T,N->left);
     else Z= strtree_remove_min(T,N->right);
     strtree_replace_child_in_parent(T, N, Z);
     strtree_set_left_child(Z, N->left);
     strtree_set_right_child(Z, N->right);
     strtree_rebalance(T,Z);
   }
   free(N);
}
static strtree_node_t *strtree_remove_max(strtree_t *T,strtree_node_t *N)
{
   while(N->right) N= N->right;
   strtree_replace_child_in_parent(T, N, N->left);
   if (N->parent) strtree_rebalance(T,N->parent);
   return N;
}
static strtree_node_t *strtree_remove_min(strtree_t *T,strtree_node_t *N)
{
   while(N->left) N= N->left;
   strtree_replace_child_in_parent(T, N, N->right);
   if (N->parent) strtree_rebalance(T,N->parent);
   return N;
}
static void strtree_calculate_height(strtree_node_t *N)
{
  int lH, rH;
  lH= strtree_height(N->left);
  rH= strtree_height(N->right);
  if (lH>rH) N->height= lH+1; else N->height= rH+1;
}
static void strtree_replace_child_in_parent
    (strtree_t* T, strtree_node_t* old, strtree_node_t* nw)
{
  if (old->parent)
    {
      if (old->parent->left == old)
 old->parent->left = nw;
      else
 old->parent->right = nw;
    }
  else
    {
      T->root = nw;
    }
  if (nw) nw->parent= old->parent;
}
static void strtree_set_left_child(strtree_node_t *P, strtree_node_t *N)
{
  P->left= N;
  if (N) N->parent= P;
}
static void strtree_set_right_child(strtree_node_t *P, strtree_node_t *N)
{
  P->right= N;
  if (N) N->parent= P;
}
static int strtree_height(strtree_node_t * A)
{
  if (A) return A->height;
  else return 0;
}
strtree_t *strtree_new()
{
  strtree_t *T;
  T= malloc(sizeof(*T));
  T->root= 0;
  return T;
}
int strtree_find(strtree_t *T, char*  key,  strpair_t *value)
{
   strtree_node_t *n;
   n= strtree_find_node(T, key);
   if (n) { if (value) *value= n->data; return 1; }
   else return 0;
}
int strtree_insert(strtree_t *T,  strpair_t data)
{
  strtree_node_t *N,*P,*K,**PL;
  char*  key; char*  key2; char*  key1;
  int result;
  N = calloc(1, sizeof(*N));
  N->data= data;
  N->height= 1;
  P = 0;
  PL= &T->root;
  K= T->root;
  {  key= data.key;  }
  key2= key;
  while (K) {
    data= K->data;
    {  key= data.key;  }
    key1= key;
    {  result= strcmp(key1, key2);  }
    if (result<0)      { PL= &K->left; P= K; K= K->left; }
    else if (result>0) { PL= &K->right; P= K; K= K->right; }
    else               { free(N); return 0; }
  }
  *PL= N;
  N->parent= P;
  strtree_rebalance(T, N);
  return 1;
}
int strtree_remove(strtree_t *T, char*  key,  strpair_t *value)
{
   strtree_node_t *N;
   N= strtree_find_node(T,key);
   if (!N) return 0;
   if (value) *value= N->data;
   strtree_remove_node(T,N);
   return 1;
}
int strtree_destroy(strtree_t *T, strpair_t *value)
{
   strtree_node_t *N= T->root;
   if (!N) return 0;
   while(N->left) N=N->left;
   if (value) *value= N->data;
   strtree_remove_node(T,N);
   return 1;
}
static token_t *token
  (token_t *head, enum tok_kind kind, unsigned char *start,unsigned char *end);
static void insert_B_before_A(token_t *A, token_t *B);
static void print_pos_exit(char *str, char *cursor);
static void print_tokenlist(token_t *head);
static void print_token(token_t *T);
static int tokenlist_to_str(token_t *head, char *buffer, int size);
static int token_to_str(token_t *T, char *buffer, int size);
static token_t *token_var(char *str);
static void remove_node(token_t *T);
static void generate_symbols(tpl_t *TPL);
static token_t *eval_builtin(token_t *input);
static int expand_def(token_t *arglist,token_t **Rfirst, token_t **Rlast);
static int expand_nef(token_t *arglist,token_t **Rfirst, token_t **Rlast);
static int expand_dev(token_t *arglist,token_t **Rfirst, token_t **Rlast);
static int all_spaces(token_t *arglist);
static int get_relocation(tpl_t *src, token_t **Rstart, token_t **Rend);
static int token_empty(token_t *T);
static int relocate(tpl_t *TPL, token_t *first, token_t *last);
static void tpl_append_tokens(tpl_t *TPL, token_t *first, token_t *last);
static token_t *tokenlist_copy(token_t *list);
static token_t *token_copy(token_t *src);
static char *tokenlist_convert_str(token_t *list);
static int expand_eq(token_t *arglist,token_t **Rfirst, token_t **Rlast);
static struct {
  char *name; int (*func)(token_t*,token_t **,token_t **);
} builtins[]= {
  { "$T", NULL },
  { "$F", NULL },
  { "$def", expand_def },
  { "$nef", expand_nef },
  { "$dev", expand_dev },
  { "$eq",  expand_eq },
  { 0, 0 }
};
static token_t *token
  (token_t *head, enum tok_kind kind, unsigned char *start,unsigned char *end)
{
  token_t *R;
  R=calloc(1,sizeof(*R));
  R->data= malloc(end-start+1);
  memcpy(R->data, start, end-start);
  R->data[end-start]= 0;
  R->kind= kind;
  if (head) insert_B_before_A(head, R);
  else R->prev= R->next= R;
  return R;
}
static void insert_B_before_A(token_t *A, token_t *B)
{
  B->prev= A->prev;
  B->next= A;
  A->prev->next= B;
  A->prev= B;
}
static void print_pos_exit(char *str, char *cursor)
{
  fwrite(str, 1, cursor-str, stderr);
  fprintf(stderr,"%s)%s", REVERSE_VIDEO,NORMAL_VIDEO);
  fprintf(stderr,"%s", cursor+1);
  exit(1);
}
static void print_tokenlist(token_t *head)
{
  token_t *T;
  for(T=head->next;T!=head;T=T->next)
   print_token(T);
}
static void print_token(token_t *T)
{
  printf("[%s]%s", tok_names[T->kind], T->data);
  if (T->kind==tok_paren) {
    print_tokenlist(T->chpar);
    printf(")");
  }
}
static int tokenlist_to_str(token_t *head, char *buffer, int size)
{
  token_t *T;
  for(T=head->next;T!=head;T=T->next)
     size= token_to_str(T, buffer, size);
  return size;
}
static int token_to_str(token_t *T, char *buffer, int size)
{
  if (T->kind==tok_target) return size;
  int L= strlen(T->data);
  if (buffer) memcpy(buffer+size, T->data, L);
  size+= L;
  if (T->kind==tok_paren) {
    size= tokenlist_to_str(T->chpar, buffer, size);
    if (buffer) buffer[size]= ')';
    size++;
  }
  return size;
}
static token_t *token_var(char *str)
{
  token_t *T;
  T= calloc(1,sizeof(*T));
  T->kind= tok_var;
  T->data= str;
  return T;
}
static void remove_node(token_t *T)
{
  T->prev->next= T->next;
  T->next->prev= T->prev;
}
static void generate_symbols(tpl_t *TPL)
{
  token_t *T;
  strtree_t *symbols;
  symbols= strtree_new();
  FOR_TOKENS(TPL, T)
    if (T->kind==tok_var && T->data[1]=='G'
        && T->data[2]=='_' && T->data[3]!=0)
    {
      strpair_t entry;
      if (!strtree_find(symbols, T->data, &entry))
      {
        static int last= 1;
        char buf[50];
        sprintf(buf,"YQRZ_%d", last++);
        entry.key= T->data;
        entry.value= strdup(buf);
        strtree_insert(symbols, entry);
      }
      T->kind= tok_text;
      T->data= entry.value;
    }
  END_FOR(T)
  while(strtree_destroy(symbols,0));
  free(symbols);
}
static token_t *eval_builtin(token_t *input)
{
  token_t *T;
  if (input->kind==tok_text || input->kind==tok_reloc
                            || input->kind==tok_target )
     return input->next;
// just in case
  if (input->kind==tok_dummy) return input;
  if (input->kind==tok_paren)
  {
    for(T=input->chpar->next;T!=input->chpar;T=eval_builtin(T)) ;
    return input->next;
  }
// here input->kind== tok_var
  int i;
  for(i=0;builtins[i].name;i++)
     if (!strcmp(builtins[i].name,input->data)) break;
  if (!builtins[i].name) return input->next;
  token_t *anchor;
  token_t *arg;
  token_t *first, *last;
  arg= input->next;
  if (arg->kind!=tok_paren) return input->next;
  anchor= input->prev;
  remove_node(input);
  remove_node(arg);
  if (!strcmp(builtins[i].name,"$F")) goto done;
  if (!strcmp(builtins[i].name,"$T"))
     { first= arg->chpar->next; last= arg->chpar->prev; goto success; }
  for(T=arg->chpar->next;T!=arg->chpar;T=eval_builtin(T));
  if ((*builtins[i].func)(arg->chpar, &first, &last))
    goto success;
done:
  return anchor->next;
success:
  first->prev= anchor;
  last->next= anchor->next;
  anchor->next->prev= last;
  anchor->next= first;
  return first;
}
static int expand_def(token_t *arglist,token_t **Rfirst, token_t **Rlast)
{
  char *var;
  if (all_spaces(arglist)) var= "$F"; else var= "$T";
  *Rfirst= *Rlast= token_var(var);
  return 1;
}
static int expand_nef(token_t *arglist,token_t **Rfirst, token_t **Rlast)
{
  char *var;
  if (all_spaces(arglist)) var= "$T"; else var= "$F";
  *Rfirst= *Rlast= token_var(var);
  return 1;
}
static int expand_dev(token_t *arglist,token_t **Rfirst, token_t **Rlast)
{
  if (all_spaces(arglist))
  {
    *Rfirst= *Rlast= token_var("$T");
    return 1;
  }
  insert_B_before_A(arglist, token_var("$F"));
  *Rfirst= arglist->next;
  *Rlast= arglist->prev;
  return 1;
}
static int all_spaces(token_t *arglist)
{
  token_t *T;
  for(T=arglist->next;T!=arglist;T=T->next) {
    if (T->kind==tok_var) continue;
    if (!token_empty(T)) return 0;
  }
  return 1;
}
static int get_relocation(tpl_t *src, token_t **Rstart, token_t **Rend)
{
  token_t *list;
  list= &src->tokens;
  token_t *start, *end;
  while(1)
  {
    start= list->next;
    if (start==list) return 0;
    if (start->kind==tok_reloc) break;
    if (!token_empty(start))
    {
       fprintf(stderr,"error: template doesn't start with a relocation\n");
       fprintf(stderr,"%s\n", tpl_to_str(src));
       exit(1);
    }
    remove_node(start);
  }
  for(end= start->next; end!=list && end->kind!=tok_reloc;end=end->next) ;
  *Rstart= start;
  *Rend= end->prev;
  end->prev= list;
  list->next= end;
  return 1;
}
static int token_empty(token_t *T)
{
  int i;
  for(i=0;T->data[i];i++) {
    unsigned char C= T->data[i];
    if (C<=32 || C==127) continue;
    return 0;
  }
  return 1;
}
static int relocate(tpl_t *TPL, token_t *first, token_t *last)
{
  token_t *T;
  char *name= first->data;
  if (first==last) return 1;
  FOR_TOKENS(TPL, T)
    if (T->kind==tok_target && !strcmp(T->data, name+1))
    {
       token_t *P= T->prev;
       first= first->next;
       P->next= first; first->prev= P;
       T->prev= last; last->next= T;
       return 1;
    }
  END_FOR(T)
  return 0;
}
static void tpl_append_tokens(tpl_t *TPL, token_t *first, token_t *last)
{
  token_t *tail, *head;
  head= &TPL->tokens; tail= head->prev;
  first->prev= tail; last->next= head;
  tail->next= first; head->prev= last;
}
static token_t *tokenlist_copy(token_t *list)
{
  token_t *ret;
  token_t *src;
  ret= calloc(1,sizeof(*ret));
  ret->prev= ret->next= ret;
  for(src=list->next;src!=list;src=src->next)
    insert_B_before_A(ret, token_copy(src));
  return ret;
}
static token_t *token_copy(token_t *src)
{
  token_t *T;
  T= calloc(1,sizeof(*T));
  T->kind= src->kind; T->data= src->data;
  if (src->kind!=tok_paren) return T;
  T->chpar= tokenlist_copy(src->chpar);
  T->chpar->chpar= T;
  return T;
}
static char *tokenlist_convert_str(token_t *list)
{
  int size;
  char *buffer;
  size= tokenlist_to_str(list, 0,0);
  buffer= malloc(size+1);
  tokenlist_to_str(list, buffer, 0);
  buffer[size]= 0;
  return buffer;
}
static int expand_eq(token_t *arglist,token_t **Rfirst, token_t **Rlast)
{
  char *var;
  char *arg;
  char *B,*C,*D;
  var= "$F";
  arg= tokenlist_convert_str(arglist);
  for(D=arg;D[0];D++)
    if (D[0]=='=') break;
  if (!D[0]) goto done;
  for(B=arg,C=D+1;B!=D;B++,C++)
     if (C[0]!=B[0]) goto done;
  if (C[0]!=0) goto done;
  var= "$T";
done:
  free(arg);
  *Rfirst= *Rlast= token_var(var);
  return 1;
}
tpl_t *tpl_new(char *str)
{
  tpl_t *ret;
  unsigned char *cursor, *marker, *start;
  token_t *dest;
  ret= calloc(1,sizeof(*ret));
  ret->tokens.prev= ret->tokens.next= &ret->tokens;
  cursor= (unsigned char*) str;
  dest= &ret->tokens;
  lexerstack_t *states;
  states= lexerstack_new(50);
again:
  start= cursor;
#line 794 "template.c"
{
 unsigned char yych;
 unsigned int yyaccept = 0;
 yych = *cursor;
 switch (yych) {
 case 0x00: goto yy15;
 case 0x01:
 case 0x02:
 case 0x03:
 case 0x04:
 case 0x05:
 case 0x06:
 case 0x07:
 case 0x08:
 case '\t':
 case '\n':
 case '\v':
 case '\f':
 case '\r':
 case 0x0E:
 case 0x0F:
 case 0x10:
 case 0x11:
 case 0x12:
 case 0x13:
 case 0x14:
 case 0x15:
 case 0x16:
 case 0x17:
 case 0x18:
 case 0x19:
 case 0x1A:
 case 0x1B:
 case 0x1C:
 case 0x1D:
 case 0x1E:
 case 0x1F:
 case ' ':
 case 0x7F: goto yy8;
 case '"': goto yy6;
 case '$': goto yy2;
 case '(': goto yy11;
 case ')': goto yy13;
 case '<': goto yy5;
 case '>': goto yy19;
 case '@': goto yy4;
 default: goto yy17;
 }
yy2:
 ++cursor;
 switch ((yych = *cursor)) {
 case 'A':
 case 'B':
 case 'C':
 case 'D':
 case 'E':
 case 'F':
 case 'G':
 case 'H':
 case 'I':
 case 'J':
 case 'K':
 case 'L':
 case 'M':
 case 'N':
 case 'O':
 case 'P':
 case 'Q':
 case 'R':
 case 'S':
 case 'T':
 case 'U':
 case 'V':
 case 'W':
 case 'X':
 case 'Y':
 case 'Z':
 case '_':
 case 'a':
 case 'b':
 case 'c':
 case 'd':
 case 'e':
 case 'f':
 case 'g':
 case 'h':
 case 'i':
 case 'j':
 case 'k':
 case 'l':
 case 'm':
 case 'n':
 case 'o':
 case 'p':
 case 'q':
 case 'r':
 case 's':
 case 't':
 case 'u':
 case 'v':
 case 'w':
 case 'x':
 case 'y':
 case 'z': goto yy33;
 default: goto yy3;
 }
yy3:
#line 849 "template.cr"
 { token(dest,tok_text,start,cursor); goto again; }
#line 905 "template.c"
yy4:
 yych = *++cursor;
 switch (yych) {
 case 'A':
 case 'B':
 case 'C':
 case 'D':
 case 'E':
 case 'F':
 case 'G':
 case 'H':
 case 'I':
 case 'J':
 case 'K':
 case 'L':
 case 'M':
 case 'N':
 case 'O':
 case 'P':
 case 'Q':
 case 'R':
 case 'S':
 case 'T':
 case 'U':
 case 'V':
 case 'W':
 case 'X':
 case 'Y':
 case 'Z':
 case '_':
 case 'a':
 case 'b':
 case 'c':
 case 'd':
 case 'e':
 case 'f':
 case 'g':
 case 'h':
 case 'i':
 case 'j':
 case 'k':
 case 'l':
 case 'm':
 case 'n':
 case 'o':
 case 'p':
 case 'q':
 case 'r':
 case 's':
 case 't':
 case 'u':
 case 'v':
 case 'w':
 case 'x':
 case 'y':
 case 'z': goto yy30;
 default: goto yy3;
 }
yy5:
 yyaccept = 0;
 yych = *(marker = ++cursor);
 switch (yych) {
 case 'A':
 case 'B':
 case 'C':
 case 'D':
 case 'E':
 case 'F':
 case 'G':
 case 'H':
 case 'I':
 case 'J':
 case 'K':
 case 'L':
 case 'M':
 case 'N':
 case 'O':
 case 'P':
 case 'Q':
 case 'R':
 case 'S':
 case 'T':
 case 'U':
 case 'V':
 case 'W':
 case 'X':
 case 'Y':
 case 'Z':
 case '_':
 case 'a':
 case 'b':
 case 'c':
 case 'd':
 case 'e':
 case 'f':
 case 'g':
 case 'h':
 case 'i':
 case 'j':
 case 'k':
 case 'l':
 case 'm':
 case 'n':
 case 'o':
 case 'p':
 case 'q':
 case 'r':
 case 's':
 case 't':
 case 'u':
 case 'v':
 case 'w':
 case 'x':
 case 'y':
 case 'z': goto yy26;
 default: goto yy3;
 }
yy6:
 yyaccept = 1;
 yych = *(marker = ++cursor);
 goto yy21;
yy7:
#line 837 "template.cr"
 {
    fprintf(stderr,"Error: dangling quote character.\n");
    print_pos_exit(str, (char*) cursor);
                          }
#line 1033 "template.c"
yy8:
 ++cursor;
 yych = *cursor;
 switch (yych) {
 case 0x00:
 case '"':
 case '$':
 case ')':
 case '<':
 case '>':
 case '@': goto yy10;
 case 0x01:
 case 0x02:
 case 0x03:
 case 0x04:
 case 0x05:
 case 0x06:
 case 0x07:
 case 0x08:
 case '\t':
 case '\n':
 case '\v':
 case '\f':
 case '\r':
 case 0x0E:
 case 0x0F:
 case 0x10:
 case 0x11:
 case 0x12:
 case 0x13:
 case 0x14:
 case 0x15:
 case 0x16:
 case 0x17:
 case 0x18:
 case 0x19:
 case 0x1A:
 case 0x1B:
 case 0x1C:
 case 0x1D:
 case 0x1E:
 case 0x1F:
 case ' ':
 case 0x7F: goto yy8;
 case '(': goto yy11;
 default: goto yy17;
 }
yy10:
#line 848 "template.cr"
 { token(dest,tok_text,start,cursor); goto again; }
#line 1084 "template.c"
yy11:
 ++cursor;
#line 814 "template.cr"
 {
       token_t *self;
       state_t state;
       self= token(dest, tok_paren, start,cursor);
       self->chpar= calloc(1,sizeof(*self));
       self->chpar->prev= self->chpar->next= self->chpar;
       self->chpar->chpar= self;
       state.dest= dest; state.cursor= cursor-1;
       lexerstack_push(states, state);
       dest= self->chpar;
       goto again;
                          }
#line 1100 "template.c"
yy13:
 ++cursor;
#line 826 "template.cr"
 {
       state_t state;
       if (!lexerstack_empty(states))
       {
         lexerstack_pop(states, &state);
         dest= state.dest;
         goto again;
       }
       fprintf(stderr,"Error: dangling right-parenthesis.\n");
       print_pos_exit(str, (char*) cursor);
                          }
#line 1115 "template.c"
yy15:
 ++cursor;
#line 841 "template.cr"
 {
     state_t state;
     if (lexerstack_empty(states)) goto all_done;
     lexerstack_pop(states, &state);
     fprintf(stderr,"Error: unmatched left parenthesis.\n");
     print_pos_exit(str, (char*) state.cursor);
                          }
#line 1126 "template.c"
yy17:
 ++cursor;
 yych = *cursor;
 switch (yych) {
 case 0x00:
 case '"':
 case '$':
 case '(':
 case ')':
 case '<':
 case '>':
 case '@': goto yy10;
 default: goto yy17;
 }
yy19:
 yych = *++cursor;
 goto yy3;
yy20:
 ++cursor;
 yych = *cursor;
yy21:
 switch (yych) {
 case '"': goto yy24;
 case '\\': goto yy22;
 default: goto yy20;
 }
yy22:
 ++cursor;
 yych = *cursor;
 switch (yych) {
 case '\n': goto yy23;
 default: goto yy20;
 }
yy23:
 cursor = marker;
 switch (yyaccept) {
 case 0:  goto yy3;
 case 1:  goto yy7;
 }
yy24:
 ++cursor;
#line 813 "template.cr"
 { token(dest, tok_text, start,cursor); goto again; }
#line 1170 "template.c"
yy26:
 ++cursor;
 yych = *cursor;
 switch (yych) {
 case '0':
 case '1':
 case '2':
 case '3':
 case '4':
 case '5':
 case '6':
 case '7':
 case '8':
 case '9':
 case 'A':
 case 'B':
 case 'C':
 case 'D':
 case 'E':
 case 'F':
 case 'G':
 case 'H':
 case 'I':
 case 'J':
 case 'K':
 case 'L':
 case 'M':
 case 'N':
 case 'O':
 case 'P':
 case 'Q':
 case 'R':
 case 'S':
 case 'T':
 case 'U':
 case 'V':
 case 'W':
 case 'X':
 case 'Y':
 case 'Z':
 case '_':
 case 'a':
 case 'b':
 case 'c':
 case 'd':
 case 'e':
 case 'f':
 case 'g':
 case 'h':
 case 'i':
 case 'j':
 case 'k':
 case 'l':
 case 'm':
 case 'n':
 case 'o':
 case 'p':
 case 'q':
 case 'r':
 case 's':
 case 't':
 case 'u':
 case 'v':
 case 'w':
 case 'x':
 case 'y':
 case 'z': goto yy26;
 case '>': goto yy28;
 default: goto yy23;
 }
yy28:
 ++cursor;
#line 809 "template.cr"
 {
         token(dest, tok_target, start+1, cursor-1);
         goto again;
                         }
#line 1248 "template.c"
yy30:
 ++cursor;
 yych = *cursor;
 switch (yych) {
 case '0':
 case '1':
 case '2':
 case '3':
 case '4':
 case '5':
 case '6':
 case '7':
 case '8':
 case '9':
 case 'A':
 case 'B':
 case 'C':
 case 'D':
 case 'E':
 case 'F':
 case 'G':
 case 'H':
 case 'I':
 case 'J':
 case 'K':
 case 'L':
 case 'M':
 case 'N':
 case 'O':
 case 'P':
 case 'Q':
 case 'R':
 case 'S':
 case 'T':
 case 'U':
 case 'V':
 case 'W':
 case 'X':
 case 'Y':
 case 'Z':
 case '_':
 case 'a':
 case 'b':
 case 'c':
 case 'd':
 case 'e':
 case 'f':
 case 'g':
 case 'h':
 case 'i':
 case 'j':
 case 'k':
 case 'l':
 case 'm':
 case 'n':
 case 'o':
 case 'p':
 case 'q':
 case 'r':
 case 's':
 case 't':
 case 'u':
 case 'v':
 case 'w':
 case 'x':
 case 'y':
 case 'z': goto yy30;
 default: goto yy32;
 }
yy32:
#line 808 "template.cr"
 { token(dest, tok_reloc, start,cursor); goto again; }
#line 1321 "template.c"
yy33:
 ++cursor;
 yych = *cursor;
 switch (yych) {
 case '0':
 case '1':
 case '2':
 case '3':
 case '4':
 case '5':
 case '6':
 case '7':
 case '8':
 case '9':
 case 'A':
 case 'B':
 case 'C':
 case 'D':
 case 'E':
 case 'F':
 case 'G':
 case 'H':
 case 'I':
 case 'J':
 case 'K':
 case 'L':
 case 'M':
 case 'N':
 case 'O':
 case 'P':
 case 'Q':
 case 'R':
 case 'S':
 case 'T':
 case 'U':
 case 'V':
 case 'W':
 case 'X':
 case 'Y':
 case 'Z':
 case '_':
 case 'a':
 case 'b':
 case 'c':
 case 'd':
 case 'e':
 case 'f':
 case 'g':
 case 'h':
 case 'i':
 case 'j':
 case 'k':
 case 'l':
 case 'm':
 case 'n':
 case 'o':
 case 'p':
 case 'q':
 case 'r':
 case 's':
 case 't':
 case 'u':
 case 'v':
 case 'w':
 case 'x':
 case 'y':
 case 'z': goto yy33;
 default: goto yy35;
 }
yy35:
#line 807 "template.cr"
 { token(dest, tok_var, start, cursor); goto again; }
#line 1394 "template.c"
}
#line 850 "template.cr"
all_done:
  return ret;
}
void tpl_print(tpl_t *T)
{
  print_tokenlist(&T->tokens);
}
char *tpl_to_str(tpl_t *T)
{
  return tokenlist_convert_str(&T->tokens);
}
void tpl_append(tpl_t *dest, tpl_t *src)
{
   token_t *Dhead, *Dlast;
   token_t *Sfirst, *Slast;
   Dhead= &dest->tokens; Dlast= Dhead->prev;
   Sfirst= src->tokens.next; Slast= src->tokens.prev;
   if (Sfirst==&src->tokens) return ;
// if (Sfirst==Slast) { insert_B_before_A(Dhead, Sfirst); return ;
   Slast->next= Dhead;
   Dhead->prev= Slast;
   Sfirst->prev= Dlast;
   Dlast->next= Sfirst;
}
void tpl_replace(tpl_t *TPL,char *name, char *value)
{
  token_t *T;
  FOR_TOKENS(TPL,T)
   if (T->kind==tok_var && !strcmp(T->data,name))
   {
     T->kind= tok_text;
     T->data= value;
   }
  END_FOR(T)
}
void tpl_replace_i(tpl_t *T, char *name, int v)
{
  char buf[50];
  sprintf(buf,"%d", v);
  tpl_replace(T, name, strdup(buf));
}
void tpl_free(tpl_t *T)
{
// We never free anything, man. That is how we roll.
}
void tpl_builtin(tpl_t *TPL)
{
  token_t *T;
  generate_symbols(TPL);
  for(T=TPL->tokens.next;T!=&TPL->tokens;T=eval_builtin(T));
}
void tpl_relocations(tpl_t *dest,tpl_t *src)
{
  token_t *first, *last;
  while(get_relocation(src, &first, &last))
  {
    if (!relocate(dest, first, last))
      tpl_append_tokens(dest, first, last);
  }
}
void tpl_relocations_known_only(tpl_t *dest, tpl_t *src)
{
  tpl_t temp;
  token_t *first, *last;
  temp.tokens.prev= temp.tokens.next= &temp.tokens;
  while(get_relocation(src, &first, &last))
  {
    if (!relocate(dest, first, last))
      tpl_append_tokens(&temp, first, last);
  }
  tpl_append(src, &temp);
}
void tpl_replace_var(tpl_t *TPL, char *name, char *var)
{
  token_t *T;
  FOR_TOKENS(TPL, T)
    if (T->kind==tok_var && !strcmp(T->data, name))
      T->data= var;
  END_FOR(T)
}
void tpl_replace_tpl(tpl_t *TPL, char *name, tpl_t *value)
{
   token_t *T;
   FOR_TOKENS(TPL, T)
      if (T->kind==tok_var && !strcmp(T->data, name))
      {
        token_t *P= T->prev;
        token_t *copy= tokenlist_copy(&value->tokens);
        token_t *first= copy->next;
        token_t *last= copy->prev;
        if (first==copy)
        {
          remove_node(T);
          T= P->next; continue;
        }
        first->prev= P; last->next= T;
        P->next= first; T->prev= last;
        remove_node(T);
        T= last->next;
        continue;
      }
   END_FOR(T)
}
void tpl_remove_targets(tpl_t *TPL)
{
  token_t *T;
  FOR_TOKENS(TPL,T)
// CAUTION: This works only because we don't free T.
// The loop uses T->next to iterate so that link must
// still be valid after the removal
    if (T->kind==tok_target)
    {
      T->prev->next= T->next;
      T->next->prev= T->prev;
    }
  END_FOR(T)
}
/* END FILE ../build/template.c */
/* BEGIN FILE ../build/icon.c */
#line 116 "/home/dodo/SFP/fxform-1.3/src/icon.u"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
/* CONTINUE FILE ../build/icon.c */
/* CONTINUE FILE ../build/icon.c */
#line 64 "/home/dodo/SFP/fxform-1.3/src/icon.u"
static int has_suffix(char* a, char *sfx)
{
  int La, Lsfx;
  La= strlen(a); Lsfx= strlen(sfx);
  if (La<Lsfx) return 0;
  return !strcasecmp(a+La-Lsfx,sfx);
}
static char *read_file_hex(char *fn)
{
   int i;
   int fd;
   fd= open(fn, O_RDONLY);
   if (fd<0)
   {
      fprintf(stderr,"can't open file %s: %s\n", fn,strerror(errno));
      exit(1);
   }
   struct stat sbuf;
   if (fstat(fd, &sbuf))
   {
      fprintf(stderr,"can't stat %s: %s\n", fn,strerror(errno));
      exit(1);
   }
// 0x0k,
   char *data= malloc(sbuf.st_size * 5 + (sbuf.st_size/10+1) + 1);
   int datao;
   unsigned char idata[10];
   datao= 0;
   while(1)
   {
     int R;
     R= read(fd, idata, 10);
     if (R<=0) break;
     for(i=0;i<R;i++) {
       sprintf(data+datao, "0x%02x,", idata[i]);
       datao+= 5;
     }
     data[datao++]= '\n';
   }
   data[datao]= 0;
   close(fd);
   return data;
}
#line 145 "/home/dodo/SFP/fxform-1.3/src/icon.u"
static char *strlit_escape_decode(char *str)
{
  char *K;
  K= strdup(str+1);
  K[strlen(K)-1]= 0;
  return K;
}
#line 27 "/home/dodo/SFP/fxform-1.3/src/icon.u"
void put_icon(tpl_t *T, char *name, parser_t *P)
{
   char *fn;
   tpl_t *icon_tpl;
   char *data;
   char *ref;
   char *iname;
icon_tpl= tpl_new(
#line 84 "icon.c"
"@library_objects\n"
"  static FXIcon *$iname;\n"
"  static unsigned char $G_icondata []= {\n"
"$icon_data\n"
"  };\n"
"@GUI_object_creation\n"
"  $iname= new $icon_type(app, $G_icondata);\n"
"  $iname->create();\n"
#line 47 "/home/dodo/SFP/fxform-1.3/src/icon.u"
   );
   ref= P->ipt;
   fn= strlit_escape_decode(parse_strlit(P));
   if (has_suffix(fn,".png")) tpl_replace(icon_tpl, "$icon_type", "FXPNGIcon");
   else
     p_error(P, ref, "unknown file type for icon\n");
   data= read_file_hex(fn);
   iname= gen_symbol();
   tpl_replace(icon_tpl, "$iname", iname);
   tpl_replace(icon_tpl, "$icon_data", data);
   tpl_builtin(icon_tpl);
   tpl_replace(T, name, iname);
   tpl_append(T, icon_tpl);
}
#line 131 "/home/dodo/SFP/fxform-1.3/src/icon.u"
/* END FILE ../build/icon.c */
/* BEGIN FILE ../build/property.c */
#line 130 "/home/dodo/tmp/FX/fxform-1.4/src/property.u"
/* CONTINUE FILE ../build/property.c */
#line 19 "/home/dodo/tmp/FX/fxform-1.4/src/property.u"
int prop_common(property_t **L, char* kw)
{
  if (!strcmp(kw,"iconpos"))
  {
    prop_enum(L, "$iconpos", "icon_after_text", "ICON_AFTER_TEXT");
    prop_enum(L, "$iconpos", "icon_before_text", "ICON_BEFORE_TEXT");
    prop_enum(L, "$iconpos", "icon_above_text", "ICON_ABOVE_TEXT");
    prop_enum(L, "$iconpos", "icon_under_text", "ICON_UNDER_TEXT");
    return 1;
  }
  if (!strcmp(kw,"frame"))
  {
    prop_enum(L,"$frame","frame_none", "FRAME_NONE");
    prop_enum(L,"$frame","frame_sunken", "FRAME_SUNKEN");
    prop_enum(L,"$frame","frame_raised", "FRAME_RAISED");
    prop_enum(L,"$frame","frame_thick", "FRAME_THICK");
    prop_enum(L,"$frame","frame_ridge", "FRAME_RIDGE");
    prop_enum(L,"$frame","frame_line", "FRAME_LINE");
    return 1;
  }
  if (!strcmp(kw,"objid"))
  {
    prop_ident(L, "objid");
    return 1;
  }
  if (!strcmp(kw,"layout"))
  {
    prop_flag(L, "pack_left");
    prop_flag(L, "pack_right");
    prop_flag(L, "pack_top");
    prop_flag(L, "pack_bottom");
    prop_flag(L, "fill_x");
    prop_flag(L, "center_x");
    prop_flag(L, "stick_left");
    prop_flag(L, "stick_right");
    prop_flag(L, "fill_y");
    prop_flag(L, "center_y");
    prop_flag(L, "stick_top");
    prop_flag(L, "stick_bottom");
    prop_int(L,"fixed_width");
    prop_int(L,"fixed_height");
    return 1;
  }
  if (!strcmp(kw,"packer"))
  {
    prop_flag(L,"uniform_height");
    prop_flag(L,"uniform_width");
    return 1;
  }
  if (!strcmp(kw,"padding"))
  {
    prop_int(L,"pad_left");
    prop_int(L,"pad_right");
    prop_int(L,"pad_top");
    prop_int(L,"pad_bottom");
    return 1;
  }
  if (!strcmp(kw,"spacing"))
  {
    prop_int(L, "vt_spacing");
    prop_int(L, "hz_spacing");
    return 1;
  }
  return 0;
}
void prop_flag(property_t **L, char *name)
{
  prop_new(L, name, pro_flag, NULL, NULL);
}
void prop_int(property_t **L, char *name)
{
  prop_new(L, name, pro_int, NULL, NULL);
}
void prop_ident(property_t **L, char *name)
{
  prop_new(L, name, pro_ident, NULL, NULL);
}
void prop_enum(property_t **L, char *target, char *name, char *value)
{
  prop_new(L, name, pro_enum, target, value);
}
void prop_str(property_t **L, char *name)
{
  prop_new(L, name, pro_string, NULL, NULL);
}
void prop_font(property_t **L, char *name)
{
  prop_new(L, name, pro_font, NULL, NULL);
}
void prop_new(property_t **L, char *name, int kind, char *target, char *value)
{
  property_t *P;
  P= malloc(sizeof(*P));
  P->name= name; P->kind= kind; P->target= target; P->value= value;
  P->next= *L;
  *L= P;
}
#line 133 "/home/dodo/tmp/FX/fxform-1.4/src/property.u"
/* END FILE ../build/property.c */
/* BEGIN FILE ../build/prophandler.c */
#line 157 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"
/* CONTINUE FILE ../build/prophandler.c */
/* CONTINUE FILE ../build/prophandler.c */
/* CONTINUE FILE ../build/prophandler.c */
/* CONTINUE FILE ../build/prophandler.c */
/* BEGIN FILE ../build/icon.h */
#line 133 "/home/dodo/SFP/fxform-1.3/src/icon.u"
#line 3 "icon.h"
void put_icon(tpl_t *T, char *name, parser_t *P);
/* END FILE ../build/icon.h */
/* CONTINUE FILE ../build/prophandler.c */
#line 38 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"
static void parse_font_and_replace(char *pfx,parser_t *P,tpl_t *T)
{
  static char * font_style_keywords[][3]=
  {
  { "reverse_oblique", "slant", "ReverseOblique" },
  { "reverse_italic" , "slant", "ReverseItalic" },
  { "no_slant"       , "slant", "Straight" },
  { "italic"         , "slant", "Italic" },
  { "oblique"        , "slant", "Oblique" },
  { "thin"           , "weight", "Thin" },
  { "extra_light"    , "weight", "ExtraLight" },
  { "light"          , "weight", "Light" },
  { "normal_weight"  , "weight", "Normal" },
  { "medium_bold"    , "weight", "Medium" },
  { "demi_bold"      , "weight", "DemiBold" },
  { "bold"           , "weight", "Bold" },
  { "extra_bold"     , "weight", "ExtraBold" },
  { "ultra_bold"     , "weight", "Black" },
  { "ultra_condensed", "width", "UltraCondensed"},
  { "extra_condensed", "width", "ExtraCondensed"},
  { "condensed"      , "width", "Condensed"},
  { "semi_condensed" , "width", "SemiCondensed"},
  { "normal_width"   , "width", "NonExpanded"},
  { "semi_expanded"  , "width", "SemiExpanded"},
  { "expanded"       , "width", "Expanded"},
  { "extra_expanded" , "width", "ExtraExpanded"},
  { "ultra_expanded" , "width", "UltraExpanded"},
  { 0, 0, 0 }
  };
  char buf[2000];
  char val[200];
  parse_lcurly(P);
  while(1)
  {
     int i;
     char *kw= parse_ident_or_rcurly(P);
     if (!kw) return ;
     if (!strcmp(kw,"size"))
        { sprintf(buf,"$%s_size", pfx);
          tpl_replace_i(T, buf, parse_int(P)); continue; }
     if (!strcmp(kw,"family"))
        { sprintf(buf,"$%s_family", pfx);
          tpl_replace(T, buf, parse_strlit(P)); continue; }
     for(i=0;font_style_keywords[i][0];i++)
       if (!strcmp(kw,font_style_keywords[i][0]))
       {
        sprintf(buf,"$%s_%s", pfx, font_style_keywords[i][1]);
        sprintf(val,"FXFont::%s", font_style_keywords[i][2]);
        tpl_replace(T, buf, strdup(val));
        break;
       }
     if (!font_style_keywords[i])
       p_error(P,0,"unknown font property '%s'.\n",kw);
  }
}
#line 5 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"
int handle_prop_keyword(char *kw,property_t *props, tpl_t *T, parser_t* P)
{
  property_t *pro;
  char buf[2000], namebuf[2000];
  for(pro=props;pro;pro=pro->next)
    if (!strcmp(pro->name, kw)) break;
  if (!pro) return 0;
  sprintf(buf,"$%s",kw);
  switch(pro->kind)
  {
  case pro_int: tpl_replace_i(T,buf, parse_int(P)); break;
  case pro_float: tpl_replace(T,buf, parse_cpp(P)); break;
  case pro_string: tpl_replace(T,buf, parse_strlit(P)); break;
  case pro_ident: tpl_replace(T, buf, parse_ident(P)); break;
  case pro_flag: tpl_replace(T, buf, "Y"); break;
  case pro_color: tpl_replace(T, buf, parse_color(P)); break;
  case pro_font: parse_font_and_replace(kw,P,T); break;
  case pro_icon:
       sprintf(namebuf,"$%s", pro->name);
       put_icon(T, namebuf,P); break;
  case pro_enum:
       tpl_replace(T, pro->target, pro->value);
       break;
  default:
       p_error(P,0,"bad property type for %s.\n", kw);
  }
  return 1;
}
#line 106 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"
char *p_mainwindow_decorations(parser_t *P)
{
    char *dkw;
    static char *names[]= {
    "title", "minimize", "maximize",
    "close", "border", "shrinkable",
    "stretchable", "menu",0 };
    int decs[8];
    int i;
    for(i=0;i<8;i++) decs[i]= 0;
    parse_lcurly(P);
    while((dkw=parse_ident_or_rcurly(P)))
    {
         char *namepart; int R;
         if (!strncmp(dkw,"no_",3)) { namepart= dkw+3; R= 0; }
         else { namepart= dkw; R= 1; }
         for(i=0;names[i];i++)
           if (!strcmp(namepart,names[i])) { decs[i] = R; break; }
         if (!names[i]) {
            if (!strcmp(namepart,"resize"))
               decs[5]= decs[6]= R;
            else if (!strcmp(dkw,"all"))
               for(i=0;names[i];i++) decs[i]= 1;
            else if (!strcmp(dkw,"none"))
               for(i=0;names[i];i++) decs[i]= 0;
            else p_error(P,0,"unknown decoration %s.\n", dkw);
         }
    }
   char buf[1000];
   strcpy(buf," 0 ");
   for(i=0;names[i];i++)
     if (decs[i]) {
      strcat(buf, " | DECOR_");
      strcat(buf, names[i]);
     }
   for(i=0;buf[i];i++) buf[i]= toupper(buf[i]);
   return strdup(buf);
}
#line 168 "/home/dodo/SFP/fxform-1.3/src/prophandler.u"
/* END FILE ../build/prophandler.c */
